;============================
;
;	common
;
;		assemble with --alocal
;
;	2021/01/23
;		PSG̃`lݒŃWCXeBbN|[ggȂȂsC
;
;============================
macro PUBDEF, name, value
	public name
	name equ value
endm

macro PUBFUNC, name
	public name
	name:
endm


PUBDEF	BANK_CMN,	#29
PUBDEF	CMN_SRC,	#0800
PUBDEF	CMN_BASE,	#d000
PUBDEF	CMN_SIZE,	prog_end-prog_start


PUBDEF	BANK_FONT,	#10
PUBDEF	BANK_ST1,	#11
PUBDEF	BANK_ST1_0,	#14
PUBDEF	BANK_ST2,	#16
PUBDEF	BANK_ST2_0,	BANK_ST2+4
PUBDEF	BANK_ST3,	#1d
PUBDEF	BANK_ST3_0,	BANK_ST3+4
PUBDEF	BANK_ST4,	#23
PUBDEF	BANK_ST4_0,	BANK_ST4+4
PUBDEF	BANK_ST5,	#2a
PUBDEF	BANK_ST5_0,	BANK_ST5+4
PUBDEF	BANK_STE,	#2f
PUBDEF	BANK_STE_0,	BANK_STE+4
PUBDEF	BANK_STE_1,	BANK_STE+8



PUBDEF	WRVDP,	#0007
PUBDEF	GTTRIG,	#00D8
PUBDEF	HTIMI,	#fd9f


PUBDEF	HTIMSV,	#e000
PUBDEF	BNKSV0,	#e002
PUBDEF	BNKSV3,	#f293

PUBDEF	WK_WRTIMG_SRC,	#e004
PUBDEF	WK_WRTIMG_DST,	#e006

PUBDEF	WK_CURSOR,	#e00a
PUBDEF	WK_TXTTC,	#e00c
PUBDEF	WK_TXTADR,	#e00e

PUBDEF	WK_SCRPTPRC_TOP,		#e012
PUBDEF	WK_SCRPTPRC_ARY_TOP,	WK_SCRPTPRC_TOP+2
PUBDEF	WK_SCRPTPRC_C,			0
PUBDEF	WK_SCRPTPRC_B,			1
PUBDEF	WK_SCRPTPRC_TP,			2
PUBDEF	WK_SCRPTPRC_SIZE,		4
PUBDEF	WK_SCRPTPRC_ARY_MAX,	8

PUBDEF	WK_SCRPTPRC_FUNCTBL_EVEN,	WK_SCRPTPRC_ARY_TOP+WK_SCRPTPRC_ARY_MAX*WK_SCRPTPRC_SIZE
PUBDEF	WK_SCRPTPRC_FUNCTBL_ODD,	WK_SCRPTPRC_FUNCTBL_EVEN+WK_SCRPTPRC_ARY_MAX*2

PUBDEF	WK_00,	#e060
PUBDEF	WK_01,	#e062
PUBDEF	WK_02,	#e064
PUBDEF	WK_03,	#e066
PUBDEF	WK_04,	#e068
PUBDEF	WK_05,	#e06a


org CMN_BASE


prog_start:
;======================================
; call	(hl)
;======================================
PUBFUNC call_hl
		jp		(hl)


;======================================
; hl+=a
;======================================
PUBFUNC add_hl_a
		add		a, l
		ld		l, a
		ret		nc
		inc		h
		ret


;======================================
; BANK؂ւ
;======================================
PUBFUNC set_bank
		di
		ld		(#6000),a
		ld		(BNKSV0), a
		inc		a
		ld		(#6800),a
		inc		a
		ld		(#7000),a
		inc		a
		ld		(#7800),a
		ld		(BNKSV3),a
		ei
		ret


;======================================
; INTER-BANKĂяo
;======================================
PUBFUNC interbank_call
PROC
		push	de
		ld		d, a
		ld		a, (BNKSV0)
		push	af
		ld		a, d
		call	set_bank
		call	call_hl
		pop		af
		call	set_bank
		pop		de
		ret
ENDP


;======================================
; check trigger
;======================================
PUBFUNC gettrig
PROC
		push	bc
		push	af
		xor		a
		call	GTTRIG
		inc		a
		jr		z, _ret
		call	GTTRIG
		inc		a
		jr		z, _ret
		inc		a
		call	GTTRIG
		inc		a
	_ret:
		pop		bc
		ld		a, b
		pop		bc
		ret
ENDP

;======================================
; ʕ\~
;======================================
PUBFUNC enable_display
		ld		a, #60
		jr		set_vdp1
PUBFUNC disable_display
		ld		a, #20
PUBFUNC set_vdp1
		inc		c
		di
		out		(c), a
		ld		a, #80 | 1
		out		(c), a
		ei
		dec		c
		ret

;======================================
; VRAMutil			;88
;======================================
PUBFUNC set_vram_adr
							;18 (call)
		inc		c			;5
		ld		a, #40		;8
		di					;5
		out		(c), e		;13
		or		d			;5
		out		(c), a		;13
		ei					;5
		dec		c			;5
		ret					;11

PUBFUNC wrt_zero_x_8
		ld		b, #8
PUBFUNC wrt_zero_in_b_times
		xor		a
PUBFUNC wrt_a_in_b_times
		out		(c), a
		dec		b
		jp		nz, wrt_a_in_b_times
		ret


;======================================
;C[Wꕔ
;======================================
macro	m_write_image_NxN	,width, height
		ld		a, 8*width
		ld		b, height
		jp		write_image_NxN
endm


PUBFUNC write_image_1x1
		m_write_image_NxN 1, 1

PUBFUNC write_image_1x2
		m_write_image_NxN 1, 2

PUBFUNC write_image_1x3
		m_write_image_NxN 1, 3

PUBFUNC write_image_2x1
		m_write_image_NxN 2, 1

PUBFUNC write_image_2x2
		m_write_image_NxN 2, 2

PUBFUNC write_image_2x3
		m_write_image_NxN 2, 3

PUBFUNC write_image_3x1
		m_write_image_NxN 3, 1

PUBFUNC write_image_3x2
		m_write_image_NxN 3, 2

PUBFUNC write_image_3x3
		m_write_image_NxN 3, 3

PUBFUNC write_image_3x4
		m_write_image_NxN 3, 4

PUBFUNC write_image_3x5
		m_write_image_NxN 3, 5

PUBFUNC write_image_4x1
		m_write_image_NxN 4, 1

PUBFUNC write_image_4x2
		m_write_image_NxN 4, 2

PUBFUNC write_image_4x3
		m_write_image_NxN 4, 3

PUBFUNC write_image_4x4
		m_write_image_NxN 4, 4

PUBFUNC write_image_4x6
		m_write_image_NxN 4, 6

PUBFUNC write_image_4x10
		m_write_image_NxN 4, 10

PUBFUNC write_image_5x1
		m_write_image_NxN 5, 1

PUBFUNC write_image_5x2
		m_write_image_NxN 5, 2

PUBFUNC write_image_5x5
		m_write_image_NxN 5, 5

PUBFUNC write_image_5x6
		m_write_image_NxN 5, 6

PUBFUNC write_image_5x8
		m_write_image_NxN 5, 8

PUBFUNC write_image_6x1
		m_write_image_NxN 6, 1

PUBFUNC write_image_6x2
		m_write_image_NxN 6, 2

PUBFUNC write_image_6x11
		m_write_image_NxN 6, 11

PUBFUNC write_image_8x3
		m_write_image_NxN 8, 3

PUBFUNC write_image_10x6
		m_write_image_NxN 10, 6

PUBFUNC write_image_15x2
		m_write_image_NxN 15, 2


PUBFUNC write_image_NxN
PROC
		push	bc
	_lb0:
		push	bc
		push	af
		call	set_vram_adr
		pop		af
		ld		b, a
	_outir0:
		outi
		jp		nz, _outir0
		inc		d
		pop		bc
		djnz	_lb0

		pop		bc

		push	af
		ld		a, d
		add		a, #20
		sub		b
		ld		d, a
		pop		af

	_lb1:
		push	bc
		push	af
		call	set_vram_adr
		pop		af
		ld		b, a
	_outir1:
		outi
		jp		nz, _outir1
		inc		d
		pop		bc
		djnz	_lb1

		ret
ENDP

;======================================
; C[WGANA
;======================================
PUBFUNC clear_vram
PROC
		ld		de, #0000
		call	set_vram_adr
		ld		b, #40
	_loop:
		ld		d, b
		ld		b, 0
		call	wrt_zero_in_b_times
		ld		b, d
		djnz	_loop
		ret
ENDP
PUBFUNC cls_image_all
		ld		de, #0f8
		call	set_vram_adr
		call	wrt_zero_x_8

		ld		de, #ff8
		call	set_vram_adr
		call	wrt_zero_x_8

		ld		de, #20f8
		call	set_vram_adr
		call	wrt_zero_x_8

		ld		de, #2ff8
		call	set_vram_adr
		call	wrt_zero_x_8
PUBFUNC cls_image
		ld		de, #1800
		call	set_vram_adr
		ld		b, 0
		ld		a, #ff
		call	wrt_a_in_b_times
		call	wrt_a_in_b_times

		ret

;======================================
;C[WGAXV
;======================================
PUBFUNC put_image_from_a
PROC
		ld		hl, put_image_from_a_vram_adr_tbl
		ld		b, 12*3
		push	af
		di
	_lp:
		inc		c
		outi
		outi
		dec		c
		REPT 15
			out		(c), a
			inc		a
nop
nop
		endm
		add		a, #11
		djnz	_lp
		ei

		pop		af
		xor		#10
		ret
ENDP
PUBFUNC put_image_from_a_vram_adr_tbl
	dw	#5868,#5888,#58a8,#58c8,#58e8,#5908,#5928,#5948,#5968,#5988,#59a8,#59c8
PUBFUNC put_image_from_a_vram_adr_tbl_l
	dw	#5860,#5880,#58a0,#58c0,#58e0,#5900,#5920,#5940,#5960,#5980,#59a0,#59c0
PUBFUNC put_image_from_a_vram_adr_tbl_r
	dw	#5871,#5891,#58b1,#58d1,#58f1,#5911,#5931,#5951,#5971,#5991,#59b1,#59d1




PUBFUNC put_image_from_a_masked
PROC
		ld		h,a
		and		#0f
		ld		l,a
		add		a,a
		add		a,l
		ld		(_jr0+1),a
		ld		a,#0f
		sub		l
		ld		l,a
		add		a,a
		add		a,l
		ld		(_jr1+1),a
		ld		a,h

		ld		hl, put_image_from_a_vram_adr_tbl
		ld		b, 12*3
		push	af
		di
	_lp:
		inc		c
		outi
		outi
		dec		c
	_jr0:
		jr		_jr0
		REPT 15
			out		(c), a
			inc		a
		endm
		and		#f0
	_jr1:
		jr		_jr1
		REPT 15
			out		(c), a
			inc		a
		endm
		add		a, #20
		djnz	_lp
		ei

		pop		af
		xor		#10
		ret
ENDP




;======================================
;C[W1C(15)A
;======================================
PUBFUNC write_image_horz
PROC
		call	set_vram_adr
		ld		b, 8*15
	_outir0:
		outi
		jp		nz, _outir0

		ld		a, d
		add		a, #20
		ld		d, a

		call	set_vram_adr
		ld		b, 8*15
	_outir1:
		outi
		jp		nz, _outir1

		ret
ENDP

PUBFUNC write_image_horz_up
		ld		hl, (WK_WRTIMG_SRC)
		ld		de, (WK_WRTIMG_DST)

		call	write_image_horz

		ld		(WK_WRTIMG_SRC), hl
		ld		hl, #DF80	;-#2080
		add		hl, de
		ld		(WK_WRTIMG_DST), hl
		ret

PUBFUNC write_image_horz_up_atastroke
		push	bc
		call	write_image_horz_up
		call	write_image_horz_up
		pop		bc
		djnz	write_image_horz_up_atastroke
		ret

PUBFUNC write_image_horz_up_scroll
		; PCGȉ
		ld		hl, (WK_WRTIMG_SRC)
		ld		de, (WK_WRTIMG_DST)

		push	de
		push	hl

		call	write_image_horz

		ld		(WK_WRTIMG_SRC), hl
		ld		hl, #DF80	;-#2080
		add		hl, de
		;PCG݃AhXiɎ܂悤
		ld		a, h
		and		#7
		ld		h, a
		ld		(WK_WRTIMG_DST), hl

		; PCGȉ
		pop		hl
		ld		de, #f6a0	;-8*15*2*2*5
		add		hl, de

		pop		de
		ld		a, d
		add		a, #5
		or		#8
		ld		d, a

		jp		write_image_horz

;======================================
;C[Wc1C(12)
;======================================
PUBFUNC write_image_vert
PROC
		ld		hl, (WK_WRTIMG_SRC)
		ld		de, (WK_WRTIMG_DST)

		ld		b, 12
	_loop_ptn:
		call	set_vram_adr
		ld		a, b
		ld		b, 8
	_outir0:
		outi
		jp		nz, _outir0

		inc		d
		ld		b, a
		djnz	_loop_ptn

		ld		a, d
		add		a, #20-12
		ld		d, a

		ld		b, 12
	_loop_color:
		call	set_vram_adr
		ld		a, b
		ld		b, 8
	_outir1:
		outi
		jp		nz, _outir1
		inc		d
		ld		b, a
		djnz	_loop_color

		ld		a, d
		sub		#20+12
		ld		d, a

		ld		(WK_WRTIMG_SRC), hl
		ret
ENDP

;E
PUBFUNC write_image_vert_right
PROC
		call	write_image_vert

		ld		a,e
		bit		7,a
		jr		nz,_skip
		add		a,#8
		jr		c,_skip2
	_skip:
		add		a,#80
	_skip2:
		ld		(WK_WRTIMG_DST),a

		ret
ENDP

;E獶
PUBFUNC write_image_vert_left
PROC
		call	write_image_vert

		ld		a,e
		bit		7,a
		jr		nz,_skip
		sub		#8
		jr		c,_skip2
	_skip:
		add		a,#80
	_skip2:
		ld		(WK_WRTIMG_DST),a

		ret
ENDP

PUBFUNC write_image_vert_right_atastroke
		push	bc
		call	write_image_vert_right
		call	write_image_vert_right
		pop		bc
		djnz	write_image_vert_right_atastroke
		ret

PUBFUNC write_image_vert_left_atastroke
		push	bc
		call	write_image_vert_left
		call	write_image_vert_left
		pop		bc
		djnz	write_image_vert_left_atastroke
		ret


;======================================
; XNvg 
;======================================
PUBFUNC scrpt_count_proc
PROC
		ld		hl, WK_SCRPTPRC_TOP	;11
		ld		b,(hl)				;8
		inc		b
		dec		b
		ret		z
		ld		e, 0
		inc		hl					;7
		inc		hl					;7
	_loop:
		or		a			;ccf
		dec		(hl)		;0		;12
		jr		nz,_next
		inc		hl			;01	;7
		ld		a, (hl)		;(1)	;8
		inc		hl			;12	;7
		or		a
		jr		z, _nop
		scf
	_nop:
		push	de
		ld		e, (hl)		;(2)	;8
		inc		hl			;23	;7
		ld		d, (hl)		;(3)	;8
		inc		de
		ld		(hl),d		;(3)	;8
		dec		hl			;32	;7
		ld		(hl),e		;(2)	;8
		ld		a,(de)
		dec		hl			;21	;7
		ld		(hl), a		;(1)	;8
		dec		hl			;10	;7
		ld		(hl), a		;(0)	;8
		pop		de
	_next:
		rl		e
		inc		hl					;7
		inc		hl					;7
		inc		hl					;7
		inc		hl					;7
		djnz	_loop

		ld		hl, WK_SCRPTPRC_TOP	;11
		ld		a,(hl)				;8
		ld		(_rla_adjust+1),a
		ld		a, e
	_rla_adjust:
		jr		_rla_adjust
		REPT	8
			rla
		ENDM
		inc		hl
		ld		(hl), a
		ret
ENDP

PUBFUNC scrpt_exec_proc_even
		ld		hl, WK_SCRPTPRC_FUNCTBL_EVEN
		ld		(scrpt_exec_proc_func_adr+1),hl
		jp		scrpt_exec_proc
PUBFUNC scrpt_exec_proc_odd
		ld		hl, WK_SCRPTPRC_FUNCTBL_ODD
		ld		(scrpt_exec_proc_func_adr+1),hl
scrpt_exec_proc:
PROC
		ld		hl, WK_SCRPTPRC_TOP	;11
		ld		d,(hl)				;8
		inc		d
		dec		d
		ret		z
		inc		hl
		ld		e,(hl)
	scrpt_exec_proc_func_adr:
		ld		hl, WK_SCRPTPRC_FUNCTBL_ODD
	_loop:
		rl		e
		jr		nc, _nop
		push	hl
		push	de
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ex		de, hl
		call	call_hl
		pop		de
		pop		hl
	_nop:
		inc		hl
		inc		hl
	_next:
		dec		d
		jr		nz, _loop
		ret
ENDP


;======================================
; eLXgGANA
;======================================
PUBFUNC cls_text
		ld		de, #1a00
		call	set_vram_adr
		ld		b, 0
		call	wrt_zero_in_b_times
PUBFUNC init_text_pos
		ld		de, #1a04;+2
		ld		(WK_CURSOR),de
		ret

;======================================
; eLXg 1ǉ
;======================================
PUBFUNC put_text
PROC
		ld		b, a
		ld		de, (WK_CURSOR)
		call	set_vram_adr
		out		(c), b
		inc		e
		ld 		a,e
		and		#1f
		cp		#1c;-2
		jr		nz, _setcursor
		ld		a,e
		add		a,#8;+4
		ld		e,a
	_setcursor:
		ld		(WK_CURSOR),de
		ret
ENDP


;======================================
; eLXg 
;======================================
PUBFUNC text_proc
PROC
		call	gettrig
		jr		z, text_proc_atastroke
		ld		a,(WK_TXTTC)
		inc		a
		ld		(WK_TXTTC), a
		ld		hl, (WK_TXTADR)
	_loop:
		sub		(hl)
		ret		c
		ld		(WK_TXTTC), a
		push	af
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		(WK_TXTADR),hl
		cp		#ff
		jr		z, _end_txt
		call	put_text
		pop		af
		jr		_loop
	_end_txt:
		pop		af
		or		a			;clear cf
		ret
ENDP
PUBFUNC text_proc_atastroke
PROC
		ld		hl, (WK_TXTADR)
	_loop:
		inc		hl
		ld		a,(hl)
		inc		hl
		cp		#ff
		jr		z, _end_txt
		call	put_text
		jr		_loop
	_end_txt:
		ld		(WK_TXTADR),hl
		halt
		or		a			;clear cf
		ret
ENDP

;======================================
; t[ 
;======================================
PUBFUNC frame_proc
PROC
		push	af
	_loop:
		call	scrpt_count_proc
		pop		af
		halt
		call	put_image_from_a
		push	af
		call	scrpt_exec_proc_odd
		pop		af
		halt
		call	put_image_from_a
		push	af
		call	scrpt_exec_proc_even
		call	text_proc
		jr		c, _loop
		pop		af
		ret
ENDP

PUBFUNC frame_proc_write_image_horz_up
		push	bc
		halt
		call	put_image_from_a
		push	af
		call	write_image_horz_up
		pop		af
		halt
		call	put_image_from_a
		push	af
		call	write_image_horz_up
		pop		af
		pop		bc
		djnz	frame_proc_write_image_horz_up
		ret

PUBFUNC frame_proc_write_image_vert_right
		push	bc
		halt
		call	put_image_from_a
		push	af
		call	write_image_vert_right
		pop		af
		halt
		call	put_image_from_a
		push	af
		call	write_image_vert_right
		pop		af
		pop		bc
		djnz	frame_proc_write_image_vert_right
		ret

PUBFUNC frame_proc_write_image_vert_left
		push	bc
		halt
		call	put_image_from_a
		push	af
		call	write_image_vert_left
		pop		af
		halt
		call	put_image_from_a
		push	af
		call	write_image_vert_left
		pop		af
		pop		bc
		djnz	frame_proc_write_image_vert_left
		ret



PUBFUNC frame_proc_stall
		call	gettrig
		ret		z
PUBFUNC frame_proc_stall_noskip
		push	bc
		halt
	frame_proc_stall_cd_pifa0:
		call	put_image_from_a
		halt
	frame_proc_stall_cd_pifa1:
		call	put_image_from_a
		pop		bc
		djnz	frame_proc_stall
		ret


PUBFUNC set_frame_proc_stall_masked
		ld		hl, put_image_from_a_masked
		ld		(frame_proc_stall_cd_pifa0+1), hl
		ld		(frame_proc_stall_cd_pifa1+1), hl
		ret
PUBFUNC set_frame_proc_stall_nomasked
		ld		hl, put_image_from_a
		ld		(frame_proc_stall_cd_pifa0+1), hl
		ld		(frame_proc_stall_cd_pifa1+1), hl
		ret


;======================================
; sound
;======================================
PUBFUNC play_sound_low
		ld		hl, sound_low
		jp		play_sound
PUBFUNC play_sound_mid
		ld		hl, sound_mid
		jp		play_sound
PUBFUNC play_sound_high
		ld		hl, sound_high
		jp		play_sound
PUBFUNC stop_sound
		ld		hl, sound_stop
		jp		play_sound
PUBFUNC stop_noise
		ld		hl, sound_stop_noise
		jp		play_sound

PUBFUNC play_sound
PROC
		ld		b,(hl)
		inc		hl
	_loop:
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		call	#0093
		djnz	_loop
		ret
ENDP

PUBFUNC play_noise
PROC
		ld		b, 13
		ld		a, r
	_loop:
		ld		e, a
		add		a, a
		add		a, a
		add		a, e
		inc		a
		ld		e, a
		ld		a, b
		cp		#7
		jr		nz,_out
		ld		a, e
		and		#3f
		or		#80
		ld		e, a
		ld		a, b
	_out:
		call	#0093
		;ld		a, e
		djnz	_loop
		ret
ENDP

PUBFUNC sound_low
	db 7, 4,136, 5,0, 7,10111000B, 10,16, 11,192, 12,1, 13,4

PUBFUNC sound_mid
	db 7, 4,116, 5,0, 7,10111000B, 10,16, 11,192, 12,1, 13,4

PUBFUNC sound_high
	db 7, 4,88, 5,0, 7,10111000B, 10,16, 11,128, 12,0, 13,4

PUBFUNC sound_stop_noise
	db 6, 7,10111000B, 8,16, 9,16, 10,16, 12,128, 13,0

PUBFUNC sound_stop
	db 13, 0, 0, 1, 0, 2, 0, 3, 0, 4, 0, 5, 0, 7,10111000B, 8,16, 9,16, 10,16, 11,0, 12,0, 13,0


;======================================
; {ROM BGM֌W
;======================================
PUBFUNC orgbgm_set_1stdata
		ld		(#7800),a
		xor		a
		ld		(#6000),a
		call	#51e3
		ld		a, (BNKSV0)
		jp		set_bank

PUBFUNC orgbgm_htimi
		ld		hl,#f28d
		inc		(hl)
		bit		0,(hl)
		ret		nz

		xor		a
		ld		(#6000),a
		ld		a,#07
		ld		(#7800),a
		call	#525f
		ld		a, (BNKSV0)
		jp		set_bank


;======================================
; PLAY BGM֌W
;======================================
strtms	equ		0099h
musicf	equ		0fb3fh     ; ytp̊荞݃tO
plycnt	equ		0fb40h     ; L[ĂPLAY̐
quetab	equ		0f959h     ; L[e[u
qcblen	equ		6          ; QCB̒

VOICAQ	equ		0F975H     ; L[obt@1
VOICBQ	equ		0F9F5H     ; L[obt@2
VOICCQ	equ		0FA75H     ; L[obt@3

mmlbgm_htimi:
		ld		a,(musicf)		; t?
		or      a
		ret		nz				; tȂA߂

	PUBFUNC mmlbgm_src_adr
		ld		hl, 00
		ld		a, l
		or		h
		jr		nz, mmlbgm_htimi_play

		ld		a,#c9
		ld		(#fd9f),a
		ret
	mmlbgm_htimi_play:
		ld		de,quetab
		ld		bc,qcblen * 3
		ldir                     ; QCB̐ݒ
		ld		(mmlbgm_src_adr+1), bc

		ld		a,1
		ld		(plycnt),a
		call	strtms           ; tJn

		ret


PUBFUNC mmlbgm_stop
		di
		xor		a
		ld		(VOICAQ),   a
		ld		(VOICBQ),   a
		ld		(VOICCQ),   a
		cpl
		ld		(VOICAQ+1), a
		ld		(VOICBQ+1), a
		ld		(VOICCQ+1), a

		ld		hl, VOICAQ
		ld		(mmlbgm_queini_a), hl
		ld		hl, VOICBQ
		ld		(mmlbgm_queini_b), hl
		ld		hl, VOICCQ
		ld		(mmlbgm_queini_c), hl
		ld		hl, mmlbgm_queini
PUBFUNC mmlbgm_play
		di
		ld		(mmlbgm_src_adr+1), hl

		; 荞݃Zbg
		ld		a,#c3
		ld		(#fd9f),a
		ld		hl, mmlbgm_htimi
		ld		(#fda0),hl
		ei
		ret

PUBFUNC mmlbgm_queini
		db		0ffh
		db		0
		db		0
		db		0ffh
	PUBFUNC mmlbgm_queini_a
		dw		VOICAQ
		db		0ffh
		db		0
		db		0
		db		0ffh
	PUBFUNC mmlbgm_queini_b
		dw		VOICBQ
		db		0ffh
		db		0
		db		0
		db		0ffh
	PUBFUNC mmlbgm_queini_c
		dw		VOICCQ

PUBFUNC mmlbgm_buf
	ds	#300

prog_end:
if #e000 < prog_end
  .WARNING PROGRAM SIZE OVER prog_end-#e000 BYTES.
endif
END
