;======================================
; stage 1
;======================================
include "obj\\valis-cmn-52800.publics"
include "obj\\valis-font-20000.publics"
include "obj\\valis-st1a-28000.publics"

org #4000


macro CALLBANK	,_bank_no,	_adr
		ld		a, _bank_no
		ld		hl,	_adr
		call	interbank_call
endm

macro SETIMPRC	,_idx, _odd_proc_ptr, _even_proc_ptr
		ld		hl, _odd_proc_ptr
		ld		(WK_SCRPTPRC_FUNCTBL_ODD+2*_idx), hl
		ld		hl, _even_proc_ptr
		ld		(WK_SCRPTPRC_FUNCTBL_EVEN+2*_idx), hl
endm
macro SETIMADR	,_idx, _is_tbl, _odd_proc_ptr, _even_proc_ptr
PROC
		ld		hl, WK_SCRPTPRC_TOP+2+WK_SCRPTPRC_SIZE*_idx
		ld		de, _is_tbl
		call	setimadr
		SETIMPRC _idx, _odd_proc_ptr, _even_proc_ptr
ENDP
endm

macro FRAMEPROC	,_tx_adr
		ld		hl, _tx_adr
		ld		(WK_TXTADR), hl
		xor		a
		ld		(WK_TXTTC), a
		ld		a, #70
		call	frame_proc
endm


prog_start:
		CALLBANK	BANK_FONT, setupfont12

		ld			a, 6
		ld			(WK_SCRPTPRC_TOP), a

		;0-326
		CALLBANK	BANK_ST1_0, proc_s1_image0
		xor			a
		ld			(WK_SCRPTPRC_TOP), a
		call		init_text_pos
		FRAMEPROC	t1_0_0
		call		cls_text

		;526-531
		CALLBANK	BANK_ST1_0, proc_s1_image1
		ld			a, 3
		ld			(WK_SCRPTPRC_TOP), a
		SETIMADR	0, i1_1_eo, proc_s1_i1_eye_o_O, proc_s1_i1_eye_o_E
		SETIMADR	1, i1_1_eh, proc_s1_i1_eye_h_O, proc_s1_i1_eye_h_E
		SETIMADR	2, i1_1_ec, proc_s1_i1_eye_c_O, proc_s1_i1_eye_c_E

		; 532-850
		call		init_text_pos
		FRAMEPROC	t1_1_0
		call		cls_text
		FRAMEPROC	t1_1_1
		call		cls_text

		;850-857

		;858-1291
		call		cls_image
		call		proc_s1_image2_atastroke
		call		proc_s1_i2_eye_c_O
		call		proc_s1_i2_eye_c_E
		ld			a, 6
		ld			(WK_SCRPTPRC_TOP), a
		SETIMADR	0, i1_2_eo, proc_s1_i2_eye_o_O, proc_s1_i2_eye_o_E
		SETIMADR	1, i1_2_eh, proc_s1_i2_eye_h_O, proc_s1_i2_eye_h_E
		SETIMADR	2, i1_2_ec, proc_s1_i2_eye_c_O, proc_s1_i2_eye_c_E
		SETIMADR	3, i1_2_mo, proc_s1_i2_mouth_o_O, proc_s1_i2_mouth_o_E
		SETIMADR	4, i1_2_mh, proc_s1_i2_mouth_h_O, proc_s1_i2_mouth_h_E
		SETIMADR	5, i1_2_mc, proc_s1_i2_mouth_c_O, proc_s1_i2_mouth_c_E

		call		init_text_pos
		FRAMEPROC	t1_2_0
		call		cls_text
		FRAMEPROC	t1_2_1
		call		cls_text
		FRAMEPROC	t1_2_2
		call		cls_text

		;1292-1297
		call		proc_s1_image3
		SETIMADR	0, i1_3_eo, proc_s1_i3_eye_o_O, proc_s1_i3_eye_o_E
		SETIMADR	1, i1_3_eh, proc_s1_i3_eye_h_O, proc_s1_i3_eye_h_E
		SETIMADR	2, i1_3_ec, proc_s1_i3_eye_c_O, proc_s1_i3_eye_c_E
		SETIMADR	3, i1_3_mo, proc_s1_i3_mouth_o_O, proc_s1_i3_mouth_o_E
		SETIMADR	4, i1_3_mh, proc_s1_i3_mouth_h_O, proc_s1_i3_mouth_h_E
		SETIMADR	5, i1_3_mc, proc_s1_i3_mouth_c_O, proc_s1_i3_mouth_c_E

		call		init_text_pos
		FRAMEPROC	t1_3_0

		call		proc_s1_image2
		SETIMADR	0, i1_4_eo, proc_s1_i2_eye_o_O, proc_s1_i2_eye_o_E
		SETIMADR	1, i1_4_eh, proc_s1_i2_eye_h_O, proc_s1_i2_eye_h_E
		SETIMADR	2, i1_4_ec, proc_s1_i2_eye_c_O, proc_s1_i2_eye_c_E
		SETIMADR	3, i1_4_mo, proc_s1_i2_mouth_o_O, proc_s1_i2_mouth_o_E
		SETIMADR	4, i1_4_mh, proc_s1_i2_mouth_h_O, proc_s1_i2_mouth_h_E
		SETIMADR	5, i1_4_mc, proc_s1_i2_mouth_c_O, proc_s1_i2_mouth_c_E

		call		cls_text
		FRAMEPROC	t1_4_0

		call		proc_s1_image3
		SETIMADR	0, i1_5_eo, proc_s1_i3_eye_o_O, proc_s1_i3_eye_o_E
		SETIMADR	1, i1_5_eh, proc_s1_i3_eye_h_O, proc_s1_i3_eye_h_E
		SETIMADR	2, i1_5_ec, proc_s1_i3_eye_c_O, proc_s1_i3_eye_c_E
		SETIMADR	3, i1_5_mo, proc_s1_i3_mouth_o_O, proc_s1_i3_mouth_o_E
		SETIMADR	4, i1_5_mh, proc_s1_i3_mouth_h_O, proc_s1_i3_mouth_h_E
		SETIMADR	5, i1_5_mc, proc_s1_i3_mouth_c_O, proc_s1_i3_mouth_c_E

		call		cls_text
		FRAMEPROC	t1_5_0
		call		cls_text
		FRAMEPROC	t1_5_1
		call		cls_text
		FRAMEPROC	t1_5_2

		call		proc_s1_image2
		SETIMADR	0, i1_6_eo, proc_s1_i2_eye_o_O, proc_s1_i2_eye_o_E
		SETIMADR	1, i1_6_eh, proc_s1_i2_eye_h_O, proc_s1_i2_eye_h_E
		SETIMADR	2, i1_6_ec, proc_s1_i2_eye_c_O, proc_s1_i2_eye_c_E
		SETIMADR	3, i1_6_mo, proc_s1_i2_mouth_o_O, proc_s1_i2_mouth_o_E
		SETIMADR	4, i1_6_mh, proc_s1_i2_mouth_h_O, proc_s1_i2_mouth_h_E
		SETIMADR	5, i1_6_mc, proc_s1_i2_mouth_c_O, proc_s1_i2_mouth_c_E

		call		cls_text
		FRAMEPROC	t1_6_0

		call		proc_s1_image3
		SETIMADR	0, i1_7_eo, proc_s1_i3_eye_o_O, proc_s1_i3_eye_o_E
		SETIMADR	1, i1_7_eh, proc_s1_i3_eye_h_O, proc_s1_i3_eye_h_E
		SETIMADR	2, i1_7_ec, proc_s1_i3_eye_c_O, proc_s1_i3_eye_c_E
		SETIMADR	3, i1_7_mo, proc_s1_i3_mouth_o_O, proc_s1_i3_mouth_o_E
		SETIMADR	4, i1_7_mh, proc_s1_i3_mouth_h_O, proc_s1_i3_mouth_h_E
		SETIMADR	5, i1_7_mc, proc_s1_i3_mouth_c_O, proc_s1_i3_mouth_c_E

		call		cls_text
		FRAMEPROC	t1_7_0
		call		cls_text
		FRAMEPROC	t1_7_1

		call		proc_s1_image2
		SETIMADR	0, i1_8_eo, proc_s1_i2_eye_o_O, proc_s1_i2_eye_o_E
		SETIMADR	1, i1_8_eh, proc_s1_i2_eye_h_O, proc_s1_i2_eye_h_E
		SETIMADR	2, i1_8_ec, proc_s1_i2_eye_c_O, proc_s1_i2_eye_c_E
		SETIMADR	3, i1_8_mo, proc_s1_i2_mouth_o_O, proc_s1_i2_mouth_o_E
		SETIMADR	4, i1_8_mh, proc_s1_i2_mouth_h_O, proc_s1_i2_mouth_h_E
		SETIMADR	5, i1_8_mc, proc_s1_i2_mouth_c_O, proc_s1_i2_mouth_c_E

		call		cls_text
		FRAMEPROC	t1_8_0

		call		proc_s1_image3
		SETIMADR	0, i1_9_eo, proc_s1_i3_eye_o_O, proc_s1_i3_eye_o_E
		SETIMADR	1, i1_9_eh, proc_s1_i3_eye_h_O, proc_s1_i3_eye_h_E
		SETIMADR	2, i1_9_ec, proc_s1_i3_eye_c_O, proc_s1_i3_eye_c_E
		SETIMADR	3, i1_9_mo, proc_s1_i3_mouth_o_O, proc_s1_i3_mouth_o_E
		SETIMADR	4, i1_9_mh, proc_s1_i3_mouth_h_O, proc_s1_i3_mouth_h_E
		SETIMADR	5, i1_9_mc, proc_s1_i3_mouth_c_O, proc_s1_i3_mouth_c_E

		call		cls_text
		FRAMEPROC	t1_9_0

		call		proc_s1_image2
		SETIMADR	0, i1_a_eo, proc_s1_i2_eye_o_O, proc_s1_i2_eye_o_E
		SETIMADR	1, i1_a_eh, proc_s1_i2_eye_h_O, proc_s1_i2_eye_h_E
		SETIMADR	2, i1_a_ec, proc_s1_i2_eye_c_O, proc_s1_i2_eye_c_E
		SETIMADR	3, i1_a_mo, proc_s1_i2_mouth_o_O, proc_s1_i2_mouth_o_E
		SETIMADR	4, i1_a_mh, proc_s1_i2_mouth_h_O, proc_s1_i2_mouth_h_E
		SETIMADR	5, i1_a_mc, proc_s1_i2_mouth_c_O, proc_s1_i2_mouth_c_E

		call		cls_text
		FRAMEPROC	t1_a_0
		call		cls_text
		FRAMEPROC	t1_a_1
		call		cls_text
		FRAMEPROC	t1_a_2

		ret

setimadr:
		ld		a, (de)
		ld		(hl), a
		inc		hl
		ld		(hl), a
		inc		hl
		ld		(hl), e
		inc		hl
		ld		(hl), d
		ret


;======================================
; script data
;======================================
t1_0_0:	db	0,0,0,0,  0, 1, 0, 2, 5, 3, 5, 4, 5, 5, 5, 6, 5, 7, 16, 7, 14, 7, 16, 8, 5, 9, 5, 10, 5, 11, 5, 12, 5, 7, 14, 7, 16, 7, 16, 13, 57, 255
t1_1_0:	db	0,0,0,0,  17, 14, 5, 15, 6, 16, 5, 17, 7, 7, 16, 7, 15, 7, 18, 255
t1_1_1:	db	0, 18, 4, 19, 5, 20, 5, 21, 5, 22, 11, 7, 16, 7, 15, 7, 15, 23, 5, 24, 4, 25, 6, 26, 5, 10, 5, 27, 5, 28, 5, 15, 5, 29, 5, 30, 5, 31, 5, 15, 9, 7, 14, 7, 15, 7, 59, 255
t1_2_0: db	0, 32, 5, 33, 4, 29, 6, 34, 5, 35, 5, 29, 4, 12, 6, 36, 5, 22, 5, 37, 5, 6, 5, 27, 5, 30, 5, 38, 5, 7, 15, 7, 16, 7, 14, 39, 6, 10, 5, 40, 5, 41, 5, 15, 5, 4, 4, 42, 6, 43, 5, 7, 15, 7, 16, 7, 14, 255
t1_2_1:	db	0, 44, 5, 45, 4, 46, 6, 47, 5, 25, 5, 39, 5, 29, 5, 20, 5, 30, 5, 38, 5, 31, 5, 30, 5, 48, 5, 7, 15, 7, 15, 7, 15, 13, 16, 255
t1_2_2:	db	0,0,0,0,  3, 49, 23, 50, 4, 51, 3, 49, 71, 255
t1_3_0: db	7, 1, 4, 52, 5, 53, 5, 10, 3, 9, 6, 8, 4, 5, 5, 12, 4, 54, 5, 55, 4, 53, 4, 15, 5, 4, 5, 38, 6, 7, 15, 7, 15, 7, 20, 8, 4, 29, 4, 12, 5, 56, 5, 26, 5, 15, 3, 31, 6, 34, 10, 57, 4, 8, 5, 58, 5, 59, 3, 60, 16, 61, 5, 51, 3, 62, 80, 255
t1_4_0: db	0, 50, 5, 51, 5, 63, 4, 18, 4, 60, 22, 64, 5, 15, 4, 4, 4, 29, 5, 65, 5, 57, 5, 38, 3, 7, 15, 7, 15, 7, 19, 1, 5, 25, 4, 56, 5, 19, 7, 66, 5, 30, 4, 38, 5, 15, 4, 8, 5, 58, 5, 67, 3, 62, 80, 255
t1_5_0: db	1, 26, 4, 26, 7, 60, 16, 63, 8, 37, 3, 13, 9, 0, 19, 8, 5, 8, 4, 10, 5, 67, 4, 60, 19, 68, 4, 12, 4, 62, 5, 0, 29, 69, 5, 31, 4, 70, 5, 71, 4, 66, 5, 6, 4, 4, 5, 42, 10, 56, 5, 10, 3, 62, 25, 255
t1_5_1: db	6, 7, 15, 7, 15, 7, 22, 18, 5, 19, 4, 29, 4, 60, 19, 42, 5, 30, 4, 31, 5, 34, 5, 56, 4, 19, 5, 72, 4, 57, 4, 18, 5, 63, 4, 5, 5, 54, 4, 55, 5, 53, 5, 57, 4, 38, 5, 31, 4, 73, 4, 2, 6, 8, 3, 8, 6, 29, 3, 56, 6, 59, 3, 7, 15, 7, 15, 7, 18, 255
t1_5_2: db	0, 72, 11, 15, 5, 33, 4, 74, 4, 56, 5, 1, 4, 12, 5, 25, 5, 75, 4, 37, 5, 15, 4, 8, 5, 58, 8, 62, 29, 76, 4, 77, 5, 25, 4, 78, 5, 37, 5, 15, 4, 8, 4, 5, 5, 57, 5, 79, 4, 19, 4, 48, 5, 80, 7, 7, 15, 7, 15, 7, 15, 62, 69, 255
t1_6_0: db	5, 13, 16, 7, 16, 7, 21, 7, 35, 26, 5, 15, 4, 31, 5, 63, 5, 18, 4, 81, 5, 33, 4, 76, 4, 77, 5, 78, 5, 30, 4, 31, 8, 34, 3, 13, 23, 42, 5, 8, 4, 31, 5, 8, 5, 73, 4, 82, 4, 2, 5, 83, 4, 84, 12, 85, 3, 15, 6, 8, 9, 62, 27, 15, 4, 4, 5, 5, 3, 63, 6, 4, 4, 15, 4, 86, 5, 12, 4, 8, 5, 6, 5, 10, 9, 49, 16, 13, 65, 255
t1_7_0: db	7, 87, 4, 88, 5, 12, 4, 89, 5, 31, 4, 10, 5, 67, 4, 60, 30, 90, 4, 68, 5, 37, 4, 10, 5, 59, 10, 7, 15, 7, 15, 7, 17, 91, 3, 79, 6, 30, 4, 74, 5, 32, 4, 33, 5, 77, 4, 92, 5, 29, 4, 15, 4, 93, 1, 85, 4, 15, 5, 34, 4, 15, 5, 8, 4, 29, 5, 34, 5, 7, 2, 7, 16, 7, 15, 56, 20, 30, 4, 74, 4, 56, 5, 60, 3, 255
t1_7_1:	db	3, 26, 4, 15, 5, 31, 5, 74, 4, 25, 4, 80, 5, 63, 4, 29, 5, 5, 4, 94, 5, 95, 5, 96, 4, 97, 5, 98, 11, 99, 3, 19, 5, 100, 4, 12, 5, 15, 5, 6, 4, 29, 5, 56, 4, 101, 5, 37, 5, 15, 4, 8, 5, 48, 4, 80, 4, 60, 18, 102, 6, 103, 4, 25, 4, 7, 15, 7, 18, 7, 16, 59, 3, 62, 90, 255
t1_8_0: db	0, 13, 6, 7, 16, 7, 15, 7, 22, 39, 4, 104, 5, 20, 5, 30, 4, 38, 5, 8, 4, 6, 4, 10, 10, 13, 17, 15, 5, 4, 10, 10, 5, 63, 5, 74, 3, 49, 16, 13, 65, 255
t1_9_0: db	2, 44, 6, 44, 4, 95, 6, 7, 15, 7, 15, 7, 19, 84, 5, 85, 4, 26, 5, 59, 4, 61, 5, 51, 6, 60, 17, 65, 4, 67, 5, 19, 4, 15, 4, 34, 4, 62, 32, 26, 5, 15, 4, 31, 5, 10, 5, 105, 4, 100, 4, 104, 5, 106, 5, 30, 4, 38, 4, 6, 5, 58, 10, 62, 69, 255
t1_a_0: db	31, 15, 6, 12, 5, 67, 5, 60, 15, 26, 5, 15, 5, 31, 5, 2, 5, 80, 5, 63, 6, 77, 4, 92, 5, 63, 5, 19, 5, 74, 5, 101, 6, 6, 4, 56, 5, 4, 6, 5, 5, 70, 5, 29, 5, 49, 5, 0, 43, 7, 16, 7, 14, 7, 22, 5, 5, 56, 4, 7, 16, 7, 21, 7, 15, 255
t1_a_1: db	0, 56, 5, 57, 4, 26, 6, 37, 4, 2, 6, 107, 4, 101, 6, 27, 5, 5, 5, 60, 15, 108, 5, 10, 5, 109, 5, 2, 5, 50, 5, 51, 5, 7, 15, 7, 15, 7, 15, 7, 16, 7, 14, 7, 16, 94, 8, 110, 5, 111, 4, 31, 6, 8, 5, 60, 5, 18, 6, 4, 4, 15, 6, 100, 4, 26, 6, 6, 4, 112, 5, 15, 5, 8, 6, 56, 5, 10, 5, 7, 15, 7, 15, 7, 15, 62, 25, 255
t1_a_2: db	0, 7, 14, 7, 16, 7, 15, 84, 5, 85, 5, 26, 5, 7, 15, 7, 15, 7, 15, 35, 5, 7, 16, 7, 14, 7, 16, 13, 105, 255

i1_0_eo: db	199+1
i1_1_eo: db	88, 31, 199+1
i1_2_eo: db	0, 75, 22, 31, 49+1
i1_3_eo: db	5, 114, 42, 78, 46+1
i1_4_eo: db	38, 101, 63, 50+1
i1_5_eo: db	33, 27, 84, 42, 41, 51, 189, 11, 148, 116+1
i1_6_eo: db	5, 52, 91, 28, 46, 20, 81, 82+1
i1_7_eo: db	5, 61, 29, 0, 24, 129, 52, 13, 46+1
i1_8_eo: db	5, 52, 42, 31, 96+1
i1_9_eo: db	95, 68, 62, 70+1
i1_a_eo: db	5, 14, 176, 57, 46, 0, 0, 107+1

i1_0_eh: db	199+1
i1_1_eh: db	38, 48, 28, 4, 108, 92+1
i1_2_eh: db	0, 73, 19, 3, 28, 3, 51+1
i1_3_eh: db	1, 2, 66, 49, 39, 3, 75, 3, 47+1
i1_4_eh: db	33, 3, 80, 21, 60, 4, 51+1
i1_5_eh: db	9, 23, 23, 4, 41, 42, 40, 3, 37, 3, 48, 4, 31, 158, 7, 3, 87, 62, 117+1
i1_6_eh: db	1, 2, 49, 3, 34, 58, 23, 4, 43, 4, 16, 4, 77, 4, 83+1
i1_7_eh: db	1, 2, 50, 11, 26, 3, 175, 37, 69, 82, 47, 48, 3, 11, 3, 47+1
i1_8_eh: db	1, 3, 48, 3, 39, 4, 28, 3, 97+1
i1_9_eh: db	63, 30, 66, 3, 58, 3, 72+1
i1_a_eh: db	1, 2, 11, 4, 11, 164, 54, 3, 43, 3, 205, 0, 160+1

i1_0_ec: db	199+1
i1_1_ec: db	39, 77, 112, 90+1
i1_2_ec: db	0, 94, 31, 52+1
i1_3_ec: db	2, 69, 88, 77, 49+1
i1_4_ec: db	35, 83, 81, 53+1
i1_5_ec: db	11, 46, 44, 82, 40, 52, 35, 165, 89, 178+1
i1_6_ec: db	2, 52, 37, 81, 47, 20, 81, 85+1
i1_7_ec: db	2, 53, 36, 179, 103, 85, 94, 14, 49+1
i1_8_ec: db	2, 52, 42, 32, 98+1
i1_9_ec: db	65, 96, 60, 74+1
i1_a_ec: db	2, 15, 13, 218, 47, 208, 0, 158+1

i1_0_mo: db	199+1
i1_1_mo: db	0, 62+1
i1_2_mo: db	0, 103, 74+1
i1_3_mo: db	11, 9, 4, 19, 5, 4, 4, 5, 4, 56, 5, 4, 5, 9, 4, 16, 4, 5, 24, 5, 83+1
i1_4_mo: db	1, 4, 9, 26, 4, 5, 4, 5, 9, 53, 9, 12, 5, 4, 5, 4, 5, 4, 84+1
i1_5_mo: db	5, 23, 7, 32, 5, 4, 5, 22, 5, 38, 9, 5, 4, 5, 4, 5, 10, 5, 87, 5, 4, 23, 9, 9, 5, 13, 5, 4, 5, 4, 5, 4, 5, 5, 4, 4, 5, 4, 9, 58, 11, 9, 4, 5, 4, 5, 5, 4, 5, 4, 5, 37, 4, 5, 4, 5, 9, 4, 5, 9, 4, 5, 121+1
i1_6_mo: db	93, 9, 9, 18, 5, 5, 4, 34, 5, 4, 5, 5, 4, 4, 5, 4, 11, 4, 41, 5, 8, 10, 4, 5, 4, 5, 4, 91+1
i1_7_mo: db	7, 4, 5, 4, 5, 4, 5, 34, 4, 5, 4, 5, 56, 4, 19, 5, 4, 5, 4, 4, 5, 9, 9, 5, 62, 4, 5, 27, 9, 5, 4, 9, 5, 4, 5, 5, 4, 4, 11, 4, 5, 4, 5, 5, 4, 9, 5, 9, 9, 22, 10, 53, 93+1
i1_8_mo: db	59, 4, 14, 9, 4, 27, 15, 5, 4, 85+1
i1_9_mo: db	67, 9, 5, 4, 32, 13, 36, 5, 4, 5, 5, 4, 4, 5, 5, 4, 4, 5, 79+1
i1_a_mo: db	0, 0, 0, 149+1

i1_0_mh: db	199+1
i1_1_mh: db	0, 62+1
i1_2_mh: db	0, 98, 4, 75+1
i1_3_mh: db	6, 4, 5, 10, 4, 4, 4, 5, 4, 5, 4, 5, 65, 6, 3, 5, 14, 10, 4, 5, 5, 19, 2, 2, 85+1
i1_4_mh: db	4, 5, 4, 26, 9, 6, 2, 6, 4, 53, 4, 5, 5, 7, 5, 4, 5, 4, 5, 89+1
i1_5_mh: db	1, 3, 23, 7, 34, 3, 6, 3, 27, 38, 4, 5, 5, 4, 4, 5, 5, 10, 2, 3, 87, 5, 4, 23, 5, 4, 5, 4, 5, 5, 3, 5, 2, 3, 4, 2, 3, 4, 5, 4, 5, 5, 4, 4, 2, 3, 6, 4, 9, 54, 9, 4, 4, 7, 3, 4, 5, 2, 2, 5, 5, 4, 5, 37, 4, 5, 4, 5, 5, 4, 6, 3, 5, 10, 3, 122+1
i1_6_mh: db	92, 5, 4, 4, 9, 6, 3, 7, 3, 5, 4, 8, 28, 2, 7, 3, 4, 5, 9, 15, 6, 4, 40, 4, 9, 5, 4, 5, 4, 5, 96+1
i1_7_mh: db	6, 6, 3, 9, 9, 34, 9, 6, 3, 56, 6, 3, 5, 4, 5, 4, 5, 4, 5, 4, 5, 5, 4, 5, 4, 5, 5, 52, 5, 4, 2, 3, 22, 5, 5, 9, 4, 2, 2, 7, 3, 6, 3, 4, 5, 19, 7, 12, 9, 4, 5, 5, 4, 5, 4, 27, 5, 53, 94+1
i1_8_mh: db	58, 4, 5, 4, 5, 5, 4, 6, 25, 5, 10, 5, 4, 86+1
i1_9_mh: db	66, 4, 5, 4, 5, 5, 23, 4, 5, 3, 5, 2, 34, 2, 3, 4, 2, 3, 4, 5, 4, 5, 5, 4, 9, 80+1
i1_a_mh: db	0, 0, 0, 149+1

i1_0_mc: db	199+1
i1_1_mc: db	0, 62+1
i1_2_mc: db	0, 100, 4, 73+1
i1_3_mc: db	8, 4, 5, 4, 5, 5, 3, 6, 4, 5, 4, 4, 5, 5, 55, 5, 5, 4, 5, 4, 5, 5, 10, 4, 5, 4, 21, 4, 82+1
i1_4_mc: db	2, 4, 4, 5, 26, 4, 5, 5, 4, 5, 4, 53, 4, 5, 5, 7, 5, 4, 5, 4, 5, 4, 83+1
i1_5_mc: db	2, 4, 23, 7, 33, 4, 5, 4, 22, 5, 38, 4, 5, 5, 4, 5, 4, 5, 11, 4, 87, 5, 4, 23, 5, 4, 5, 4, 5, 5, 3, 6, 4, 5, 4, 5, 4, 5, 4, 5, 4, 5, 4, 5, 4, 5, 5, 53, 10, 5, 4, 5, 4, 5, 5, 4, 4, 5, 4, 5, 37, 4, 5, 4, 5, 4, 5, 5, 4, 5, 4, 5, 4, 120+1
i1_6_mc: db	94, 5, 4, 5, 4, 5, 5, 3, 6, 4, 5, 4, 8, 27, 4, 5, 4, 5, 4, 5, 4, 5, 10, 5, 5, 35, 5, 5, 3, 5, 5, 4, 5, 4, 5, 5, 89+1
i1_7_mc: db	8, 5, 4, 5, 4, 4, 5, 34, 4, 5, 5, 4, 56, 5, 4, 4, 6, 4, 5, 4, 5, 4, 5, 4, 4, 5, 5, 4, 5, 4, 53, 5, 5, 4, 21, 2, 4, 5, 4, 5, 5, 3, 6, 4, 5, 4, 5, 4, 5, 10, 5, 5, 4, 4, 5, 4, 5, 4, 5, 4, 5, 5, 4, 23, 5, 4, 53, 92+1
i1_8_mc: db	60, 4, 5, 4, 5, 5, 4, 5, 26, 4, 12, 4, 5, 83+1
i1_9_mc: db	68, 4, 5, 5, 4, 4, 23, 5, 5, 3, 6, 36, 4, 5, 4, 5, 4, 5, 4, 5, 4, 5, 4, 78+1
i1_a_mc: db	0, 0, 0, 149+1




;======================================
; anime proc
;======================================
macro mAnimeProcC, src, dst, fnc
		ld		hl, src
		ld		de, dst
		call	fnc
endm
macro mAnimeProcJ, src, dst, fnc
		ld		hl, src
		ld		de, dst
		jp		fnc
endm

public	proc_s1_i1_eye_c_O
public	proc_s1_i1_eye_c_E
public	proc_s1_i2_eye_c_O
public	proc_s1_i2_eye_c_E

proc_nop:
		ret

proc_s1_i1_eye_o_O:
		mAnimeProcJ	i1_eye_o_O, #8d8, write_image_2x2
proc_s1_i1_eye_o_E:
		mAnimeProcJ	i1_eye_o_E, #858, write_image_2x2
proc_s1_i1_eye_h_O:
		mAnimeProcJ	i1_eye_h_O, #8d8, write_image_2x2
proc_s1_i1_eye_h_E:
		mAnimeProcJ	i1_eye_h_E, #858, write_image_2x2
proc_s1_i1_eye_c_O:
		mAnimeProcJ	i1_eye_c_O, #8d8, write_image_2x2
proc_s1_i1_eye_c_E:
		mAnimeProcJ	i1_eye_c_E, #858, write_image_2x2

proc_s1_i2_eye_o_O:
		mAnimeProcC	i2_eyel_o_O, 0x6b8, write_image_3x3
		mAnimeProcC	i2_eyer_o_a_O, 0x4d8, write_image_2x1
		mAnimeProcC	i2_eyer_o_b_O, 0x5d0, write_image_4x1
		mAnimeProcC	i2_eyer_o_c_O, 0x6d8, write_image_3x1
		mAnimeProcJ	i2_eyer_o_d_O, 0x7d8, write_image_2x1
proc_s1_i2_eye_o_E:
		mAnimeProcC	i2_eyel_o_E, 0x638, write_image_3x3
		mAnimeProcC	i2_eyer_o_a_E, 0x458, write_image_2x1
		mAnimeProcC	i2_eyer_o_b_E, 0x550, write_image_4x1
		mAnimeProcC	i2_eyer_o_c_E, 0x658, write_image_3x1
		mAnimeProcJ	i2_eyer_o_d_E, 0x758, write_image_2x1

proc_s1_i2_eye_h_O:
		mAnimeProcC	i2_eyel_h_O, 0x6b8, write_image_3x3
		mAnimeProcC	i2_eyer_h_a_O, 0x4d8, write_image_2x1
		mAnimeProcC	i2_eyer_h_b_O, 0x5d0, write_image_4x1
		mAnimeProcC	i2_eyer_h_c_O, 0x6d8, write_image_3x1
		mAnimeProcJ	i2_eyer_h_d_O, 0x7d8, write_image_2x1
proc_s1_i2_eye_h_E:
		mAnimeProcC	i2_eyel_h_E, 0x638, write_image_3x3
		mAnimeProcC	i2_eyer_h_a_E, 0x458, write_image_2x1
		mAnimeProcC	i2_eyer_h_b_E, 0x550, write_image_4x1
		mAnimeProcC	i2_eyer_h_c_E, 0x658, write_image_3x1
		mAnimeProcJ	i2_eyer_h_d_E, 0x758, write_image_2x1

proc_s1_i2_eye_c_O:
		mAnimeProcC	i2_eyel_c_O, 0x6b8, write_image_3x3
		mAnimeProcC	i2_eyer_c_a_O, 0x4d8, write_image_2x1
		mAnimeProcC	i2_eyer_c_b_O, 0x5d0, write_image_4x1
		mAnimeProcC	i2_eyer_c_c_O, 0x6d8, write_image_3x1
		mAnimeProcJ	i2_eyer_c_d_O, 0x7d8, write_image_2x1
proc_s1_i2_eye_c_E:
		mAnimeProcC	i2_eyel_c_E, 0x638, write_image_3x3
		mAnimeProcC	i2_eyer_c_a_E, 0x458, write_image_2x1
		mAnimeProcC	i2_eyer_c_b_E, 0x550, write_image_4x1
		mAnimeProcC	i2_eyer_c_c_E, 0x658, write_image_3x1
		mAnimeProcJ	i2_eyer_c_d_E, 0x758, write_image_2x1

proc_s1_i2_mouth_c_O:
		mAnimeProcJ	i2_mouth_c_O, 0x9d0, write_image_2x2
proc_s1_i2_mouth_c_E:
		mAnimeProcJ	i2_mouth_c_E, 0x950, write_image_2x2

proc_s1_i2_mouth_h_O:
		mAnimeProcC	i2_mouth_h_O, 0x9d0, write_image_2x2
		jp		play_sound_mid
proc_s1_i2_mouth_h_E:
		mAnimeProcJ	i2_mouth_h_E, 0x950, write_image_2x2

proc_s1_i2_mouth_o_O:
		mAnimeProcC	i2_mouth_o_O, 0x9d0, write_image_2x2
		jp		play_sound_mid
proc_s1_i2_mouth_o_E:
		mAnimeProcJ	i2_mouth_o_E, 0x950, write_image_2x2

proc_s1_i3_eye_o_O:
		mAnimeProcC	i3_eyel_o_a_O, 0x788, write_image_3x2
		mAnimeProcC	i3_eyel_o_b_O, 0x990, write_image_2x1
		mAnimeProcJ	i3_eyer_o_O, 0x9a0, write_image_3x2
proc_s1_i3_eye_o_E:
		mAnimeProcC	i3_eyel_o_a_E, 0x708, write_image_3x2
		mAnimeProcC	i3_eyel_o_b_E, 0x910, write_image_2x1
		mAnimeProcJ	i3_eyer_o_E, 0x920, write_image_3x2
proc_s1_i3_eye_h_O:
		mAnimeProcC	i3_eyel_h_a_O, 0x788, write_image_3x2
		mAnimeProcC	i3_eyel_h_b_O, 0x990, write_image_2x1
		mAnimeProcJ	i3_eyer_h_O, 0x9a0, write_image_3x2
proc_s1_i3_eye_h_E:
		mAnimeProcC	i3_eyel_h_a_E, 0x708, write_image_3x2
		mAnimeProcC	i3_eyel_h_b_E, 0x910, write_image_2x1
		mAnimeProcJ	i3_eyer_h_E, 0x920, write_image_3x2
proc_s1_i3_eye_c_O:
		mAnimeProcC	i3_eyel_c_a_O, 0x788, write_image_3x2
		mAnimeProcC	i3_eyel_c_b_O, 0x990, write_image_2x1
		mAnimeProcJ	i3_eyer_c_O, 0x9a0, write_image_3x2
proc_s1_i3_eye_c_E:
		mAnimeProcC	i3_eyel_c_a_E, 0x708, write_image_3x2
		mAnimeProcC	i3_eyel_c_b_E, 0x910, write_image_2x1
		mAnimeProcJ	i3_eyer_c_E, 0x920, write_image_3x2


proc_s1_i3_mouth_c_O:
		mAnimeProcC	i3_mouth_c_a_O, 0xb90, write_image_2x1
		mAnimeProcJ	i3_mouth_c_b_O, 0xc98, write_image_1x2
proc_s1_i3_mouth_c_E:
		mAnimeProcC	i3_mouth_c_a_E, 0xb10, write_image_2x1
		mAnimeProcJ	i3_mouth_c_b_E, 0xc18, write_image_1x2
proc_s1_i3_mouth_h_O:
		mAnimeProcC	i3_mouth_h_a_O, 0xb90, write_image_2x1
		mAnimeProcC	i3_mouth_h_b_O, 0xc98, write_image_1x2
		jp	play_sound_low
proc_s1_i3_mouth_h_E:
		mAnimeProcC	i3_mouth_h_a_E, 0xb10, write_image_2x1
		mAnimeProcJ	i3_mouth_h_b_E, 0xc18, write_image_1x2
proc_s1_i3_mouth_o_O:
		mAnimeProcC	i3_mouth_o_a_O, 0xb90, write_image_2x1
		mAnimeProcC	i3_mouth_o_b_O, 0xc98, write_image_1x2
		jp	play_sound_low
proc_s1_i3_mouth_o_E:
		mAnimeProcC	i3_mouth_o_a_E, 0xb10, write_image_2x1
		mAnimeProcJ	i3_mouth_o_b_E, 0xc18, write_image_1x2




;======================================
; anime pcg
;======================================
i1_eye_o_O: ;0x8d8 11,5,2,2,1
	db	#70, #76, #16, #36, #76, #6d, #4f, #1e, #1f, #6f, #7f, #1f, #9f, #c0, #7f, #80
	db	#3d, #7f, #3f, #3f, #3c, #5c, #4c, #6c, #80, #c0, #80, #80, #00, #80, #00, #00
	db	#f1, #d1, #f1, #f1, #f1, #f4, #fc, #f1, #94, #91, #91, #96, #96, #d9, #93, #d9
	db	#fc, #f1, #a1, #a1, #f8, #f8, #f8, #f8, #f9, #b9, #b9, #b9, #b9, #b9, #b9, #b9

i1_eye_o_E: ;0x858 11,5,2,2,0
	db	#04, #76, #63, #46, #2d, #4f, #0c, #3c, #50, #70, #3f, #3f, #3f, #80, #bf, #80
	db	#7f, #7f, #7e, #3e, #3f, #1f, #1f, #1f, #00, #40, #00, #00, #00, #00, #00, #00
	db	#d1, #21, #e1, #b1, #d1, #a1, #a1, #a1, #d8, #d8, #81, #81, #87, #f8, #86, #a8
	db	#a1, #a1, #f8, #f8, #a1, #a1, #a1, #a1, #88, #88, #88, #88, #88, #88, #88, #88

i1_eye_h_O: ;0x8d8 11,5,2,2,1
	db	#70, #77, #67, #77, #2e, #6d, #4f, #1e, #1f, #6f, #80, #60, #7f, #bf, #80, #7f
	db	#3d, #7f, #3f, #3f, #3c, #5c, #4c, #6c, #80, #c0, #80, #80, #00, #80, #00, #00
	db	#f1, #61, #e1, #a1, #e4, #f5, #fc, #f1, #94, #91, #d9, #d9, #96, #96, #a9, #93
	db	#fc, #f1, #a1, #a1, #f8, #f8, #f8, #f8, #f9, #b9, #b9, #b9, #b9, #b9, #b9, #b9

i1_eye_h_E: ;0x858 11,5,2,2,0
	db	#04, #76, #17, #14, #24, #4f, #0c, #3c, #50, #70, #bf, #c0, #3f, #7f, #c0, #00
	db	#7f, #7f, #7e, #3e, #3f, #1f, #1f, #1f, #00, #00, #00, #00, #00, #00, #00, #00
	db	#d1, #31, #a1, #51, #b1, #a1, #a1, #a1, #d8, #d8, #81, #b8, #81, #87, #d8, #88
	db	#a1, #a1, #f8, #f8, #a1, #a1, #a1, #a1, #88, #88, #88, #88, #88, #88, #88, #88

i1_eye_c_O: ;0x8d8 11,5,2,2,1
	db	#70, #77, #17, #ca, #75, #4f, #4e, #c1, #1f, #6f, #80, #60, #60, #7f, #7f, #80
	db	#3d, #7f, #3f, #3f, #3c, #5c, #4c, #6c, #80, #c0, #80, #80, #00, #80, #00, #00
	db	#f1, #81, #f1, #cf, #fd, #f1, #f1, #cf, #94, #91, #d9, #d9, #d9, #93, #91, #d9
	db	#fc, #f1, #a1, #a1, #f8, #f8, #f8, #f8, #f9, #b9, #b9, #b9, #b9, #b9, #b9, #b9

i1_eye_c_E: ;0x858 11,5,2,2,0
	db	#04, #76, #65, #07, #2f, #6d, #3f, #1c, #50, #70, #bf, #c0, #80, #bf, #7f, #80
	db	#7f, #7f, #7e, #3e, #3f, #1f, #1f, #1f, #00, #00, #00, #00, #00, #00, #00, #00
	db	#d1, #31, #a1, #a1, #a1, #ad, #a1, #a1, #d8, #d8, #81, #b8, #f8, #81, #81, #a8
	db	#a1, #a1, #f8, #f8, #a1, #a1, #a1, #a1, #88, #88, #88, #88, #88, #88, #88, #88

i2_eyel_o_O: ;0x6b8 7,3,3,3,1
	db	#f0, #c7, #76, #04, #18, #3c, #7f, #3f, #0d, #02, #01, #10, #34, #66, #fe, #fc, #00, #7f, #7f, #7f, #3f, #1f, #0f, #0f
	db	#1f, #0f, #07, #83, #83, #81, #81, #c0, #fc, #f8, #f0, #70, #f9, #f8, #f8, #fc, #0f, #3f, #1f, #37, #37, #1f, #57, #f3
	db	#d0, #c0, #80, #80, #90, #90, #90, #90, #fc, #7f, #7f, #39, #7f, #3f, #3f, #3f, #67, #07, #8f, #cf, #1f, #3f, #f7, #f3
	db	#41, #d4, #d1, #d1, #91, #91, #84, #94, #91, #c1, #61, #d1, #f1, #f4, #f1, #f1, #99, #96, #96, #91, #91, #94, #91, #91
	db	#94, #94, #94, #91, #91, #81, #81, #c1, #f1, #f1, #f1, #f4, #b7, #f4, #f4, #f4, #91, #d1, #d1, #d1, #b1, #f1, #b4, #fa
	db	#e1, #d1, #f1, #f1, #f1, #a1, #f1, #e1, #f4, #fc, #f1, #f1, #f4, #f1, #f1, #f4, #f1, #f1, #f1, #f1, #f3, #fb, #fc, #f3

i2_eyel_o_E: ;0x638 7,3,3,3,0
	db	#00, #86, #bc, #38, #84, #78, #3c, #1f, #02, #07, #00, #38, #7e, #7c, #6c, #ec, #00, #7f, #7f, #3f, #1f, #0f, #1f, #0f
	db	#0f, #07, #03, #ba, #9d, #a5, #98, #9c, #68, #70, #70, #f0, #70, #fa, #fc, #fc, #27, #07, #07, #07, #17, #33, #5b, #57
	db	#8e, #8f, #1f, #1f, #0f, #df, #0f, #0f, #7e, #76, #33, #7e, #3e, #3f, #3f, #1f, #0f, #0f, #ef, #f0, #3f, #c0, #f7, #f7
	db	#11, #61, #61, #61, #41, #61, #91, #81, #61, #81, #11, #31, #71, #71, #f1, #e1, #88, #86, #86, #81, #81, #81, #84, #81
	db	#81, #81, #81, #48, #41, #41, #41, #41, #f1, #f1, #b1, #e1, #f4, #b1, #b4, #b1, #d1, #91, #91, #91, #81, #a1, #f1, #a1
	db	#41, #41, #41, #41, #41, #41, #41, #41, #b1, #a1, #a1, #a4, #a1, #a1, #a1, #a1, #a5, #a4, #a1, #fa, #a1, #ba, #a6, #a1

i2_eyer_o_a_O: ;0x4d8 11,1,2,1,1
	db	#00, #00, #00, #01, #f9, #c1, #0f, #3f, #00, #00, #00, #80, #f0, #f8, #e0, #df
	db	#99, #99, #99, #d9, #d4, #84, #94, #94, #99, #99, #99, #d8, #d9, #d9, #98, #91

i2_eyer_o_a_E: ;0x458 11,1,2,1,0
	db	#00, #00, #00, #03, #fc, #e1, #08, #40, #00, #00, #00, #00, #07, #df, #7f, #2f
	db	#88, #88, #88, #98, #91, #d1, #d1, #61, #88, #88, #88, #99, #81, #86, #91, #81

i2_eyer_o_b_O: ;0x5d0 10,2,4,1,1
	db	#f8, #07, #fd, #00, #02, #fe, #00, #00, #10, #80, #80, #02, #0f, #1b, #1f, #1e, #63, #0b, #02, #c0, #c0, #80, #80, #07, #fc, #fc, #fc, #fe, #5e, #7e, #01, #81
	db	#94, #d8, #96, #99, #d8, #91, #99, #99, #96, #a1, #a1, #c1, #71, #e1, #f1, #fb, #96, #91, #d1, #71, #f1, #f1, #f1, #41, #94, #94, #84, #91, #96, #91, #d9, #d9

i2_eyer_o_b_E: ;0x550 10,2,4,1,0
	db	#fc, #fe, #f9, #fc, #fe, #fc, #fe, #00, #c0, #e0, #c0, #85, #0d, #1f, #3b, #3b, #17, #17, #07, #81, #f8, #ce, #06, #00, #f8, #3c, #7c, #9e, #3e, #fe, #7f, #7f
	db	#81, #98, #86, #81, #91, #81, #81, #88, #d1, #61, #61, #31, #31, #71, #71, #f1, #61, #81, #61, #61, #41, #41, #41, #11, #81, #81, #91, #81, #81, #86, #81, #81

i2_eyer_o_c_O: ;0x6d8 11,3,3,1,1
	db	#3f, #3e, #38, #3f, #3c, #9e, #1f, #1f, #07, #83, #04, #06, #07, #0b, #19, #1d, #7e, #7f, #7f, #7f, #7f, #80, #3f, #7f
	db	#f8, #f6, #f6, #f8, #f6, #f6, #fa, #fa, #41, #41, #d1, #91, #f1, #f1, #f4, #f7, #96, #91, #94, #94, #94, #f9, #96, #96

i2_eyer_o_c_E: ;0x658 11,3,3,1,0
	db	#fa, #f8, #fc, #fc, #fc, #7c, #fe, #fe, #00, #00, #83, #c7, #c3, #d3, #09, #08, #3f, #7e, #3f, #3f, #3f, #3f, #7f, #7f
	db	#e1, #f1, #f1, #f1, #f4, #f4, #f1, #f3, #11, #11, #41, #71, #71, #71, #f4, #f1, #81, #81, #81, #81, #81, #81, #81, #81

i2_eyer_o_d_O: ;0x7d8 11,4,2,1,1
	db	#ef, #0f, #f3, #f9, #fd, #fe, #00, #00, #9c, #c0, #e8, #fc, #c8, #3f, #00, #00
	db	#fb, #fa, #fe, #f5, #fb, #f6, #ff, #ff, #f1, #f1, #fa, #fa, #ea, #f3, #ff, #ff

i2_eyer_o_d_E: ;0x758 11,4,2,1,0
	db	#1f, #00, #03, #f3, #fc, #fe, #00, #00, #6a, #81, #e1, #f3, #e7, #1f, #00, #00
	db	#fa, #ff, #fa, #a1, #a1, #a3, #aa, #aa, #41, #e1, #f1, #f1, #f1, #a1, #aa, #aa

i2_eyel_h_O: ;0x6b8 7,3,3,3,1
	db	#f0, #87, #67, #1f, #1f, #3f, #3e, #9c, #0f, #c3, #21, #3e, #e1, #00, #0c, #3c, #00, #00, #7f, #40, #3f, #1f, #1f, #0f
	db	#1f, #0f, #07, #83, #83, #81, #81, #c0, #3c, #78, #f0, #f0, #7a, #f8, #f8, #1f, #0f, #3f, #1f, #37, #37, #1f, #57, #f3
	db	#d0, #c0, #80, #80, #90, #90, #90, #90, #fc, #7f, #7f, #39, #7f, #3f, #3f, #3f, #67, #07, #8f, #cf, #1f, #3f, #f7, #f3
	db	#41, #91, #96, #91, #91, #91, #91, #d1, #d1, #91, #96, #96, #61, #11, #e1, #f1, #99, #99, #96, #a9, #91, #91, #91, #91
	db	#94, #94, #94, #91, #91, #81, #81, #c1, #f1, #b1, #f1, #f4, #76, #f4, #f4, #ea, #91, #d1, #d1, #d1, #b1, #f1, #b4, #fa
	db	#e1, #d1, #f1, #f1, #f1, #a1, #f1, #e1, #f4, #fc, #f1, #f1, #f4, #f1, #f1, #f4, #f1, #f1, #f1, #f1, #f3, #fb, #fc, #f3

i2_eyel_h_E: ;0x638 7,3,3,3,0
	db	#00, #63, #3f, #2f, #0e, #78, #7c, #3e, #0f, #81, #80, #00, #00, #00, #10, #0c, #00, #00, #7f, #7f, #1f, #3f, #0f, #0f
	db	#0f, #07, #03, #ba, #9d, #a5, #98, #9c, #68, #7c, #70, #30, #f0, #fa, #fc, #fc, #07, #07, #07, #07, #17, #33, #5b, #57
	db	#8e, #8f, #1f, #1f, #0f, #df, #0f, #0f, #7e, #76, #33, #7e, #3e, #3f, #3f, #1f, #0f, #0f, #ef, #f0, #3f, #c0, #f7, #f7
	db	#11, #61, #81, #81, #81, #81, #81, #91, #91, #61, #61, #11, #11, #11, #c1, #e1, #88, #88, #86, #81, #86, #81, #81, #81
	db	#81, #81, #81, #48, #41, #41, #41, #41, #e1, #51, #b1, #f1, #b4, #b1, #a4, #f1, #81, #91, #91, #91, #81, #a1, #f1, #a1
	db	#41, #41, #41, #41, #41, #41, #41, #41, #b1, #a1, #a1, #a4, #a1, #a1, #a1, #a1, #a5, #a4, #a1, #fa, #a1, #ba, #a6, #a1

i2_eyer_h_a_O: ;0x4d8 11,1,2,1,1
	db	#00, #00, #00, #02, #07, #cb, #0f, #1f, #00, #00, #00, #f0, #f0, #f8, #00, #00
	db	#99, #99, #99, #d8, #d9, #d4, #94, #94, #99, #99, #99, #d8, #d9, #d9, #99, #99

i2_eyer_h_a_E: ;0x458 11,1,2,1,0
	db	#00, #00, #00, #00, #fc, #e1, #0f, #3f, #00, #00, #00, #00, #07, #00, #00, #00
	db	#88, #88, #88, #99, #81, #81, #81, #81, #88, #88, #88, #99, #81, #88, #88, #88

i2_eyer_h_b_O: ;0x5d0 10,2,4,1,1
	db	#f8, #07, #00, #00, #00, #00, #fd, #01, #78, #cf, #af, #8f, #f0, #e0, #01, #03, #bf, #1f, #e3, #f9, #39, #04, #02, #00, #fc, #fc, #fe, #fe, #fe, #fe, #be, #3e
	db	#94, #d8, #99, #99, #99, #99, #98, #d9, #96, #96, #96, #96, #96, #d1, #e1, #f1, #86, #96, #96, #96, #91, #f1, #b1, #11, #94, #94, #94, #91, #91, #96, #96, #96

i2_eyer_h_b_E: ;0x550 10,2,4,1,0
	db	#fc, #fc, #00, #00, #00, #00, #fe, #01, #f8, #e7, #d0, #e0, #80, #80, #c2, #8f, #7f, #8f, #37, #03, #c3, #1b, #01, #00, #f8, #fc, #fc, #fe, #fe, #fe, #7f, #5e
	db	#81, #98, #88, #88, #88, #88, #81, #98, #81, #81, #91, #61, #21, #61, #61, #61, #91, #81, #d1, #81, #61, #61, #61, #11, #81, #81, #81, #81, #81, #81, #81, #86

i2_eyer_h_c_O: ;0x6d8 11,3,3,1,1
	db	#0e, #0e, #38, #3c, #3c, #9e, #1f, #1f, #02, #83, #04, #06, #07, #0b, #19, #19, #7e, #7f, #7f, #7f, #7f, #80, #3f, #7f
	db	#f1, #fd, #fd, #fd, #f6, #f6, #fa, #fa, #41, #41, #d1, #91, #f1, #f1, #f4, #f4, #96, #91, #94, #94, #94, #f9, #96, #96

i2_eyer_h_c_E: ;0x658 11,3,3,1,0
	db	#1b, #18, #9c, #fc, #fc, #7c, #fe, #fe, #00, #00, #83, #c7, #c3, #d3, #09, #4c, #3f, #7e, #3f, #3f, #3f, #3f, #7f, #7f
	db	#71, #e1, #e1, #b1, #e4, #f4, #f1, #f3, #11, #11, #41, #71, #71, #71, #f4, #51, #81, #81, #81, #81, #81, #81, #81, #81

i2_eyer_h_d_O: ;0x7d8 11,4,2,1,1
	db	#ef, #0f, #f3, #f9, #fd, #fe, #00, #00, #9c, #c0, #e8, #fc, #c8, #3f, #00, #00
	db	#fb, #fa, #fe, #f5, #fb, #f6, #ff, #ff, #f1, #f1, #fa, #fa, #ea, #f3, #ff, #ff

i2_eyer_h_d_E: ;0x758 11,4,2,1,0
	db	#1f, #00, #03, #f3, #fc, #fe, #00, #00, #6a, #81, #e1, #f3, #e7, #1f, #00, #00
	db	#fa, #ff, #fa, #a1, #a1, #a3, #aa, #aa, #41, #e1, #f1, #f1, #f1, #a1, #aa, #aa

i2_eyel_c_O: ;0x6b8 7,3,3,3,1
	db	#f0, #87, #67, #1f, #1f, #3f, #7f, #3f, #0f, #c7, #dd, #7f, #00, #00, #7f, #7f, #00, #00, #7f, #7f, #bf, #ef, #ef, #f7
	db	#1f, #0f, #07, #83, #83, #81, #81, #c0, #3f, #bf, #bf, #df, #60, #fc, #f3, #0f, #00, #f7, #00, #08, #f3, #17, #2f, #e3
	db	#d0, #c0, #80, #80, #90, #90, #90, #90, #8b, #70, #78, #38, #7f, #3f, #3f, #3f, #c7, #0f, #0f, #1f, #3f, #3f, #f7, #f3
	db	#41, #91, #96, #91, #91, #91, #84, #94, #91, #d1, #98, #96, #99, #99, #98, #96, #99, #99, #96, #91, #96, #96, #96, #96
	db	#94, #94, #94, #91, #91, #81, #81, #c1, #96, #96, #98, #96, #f9, #f9, #fa, #cf, #99, #96, #99, #d8, #96, #f8, #a9, #f6
	db	#e1, #d1, #f1, #f1, #f1, #a1, #f1, #e1, #cf, #fc, #f1, #f1, #f4, #f1, #f1, #f4, #f1, #f1, #f1, #f1, #f1, #fb, #fc, #f3

i2_eyel_c_E: ;0x638 7,3,3,3,0
	db	#00, #63, #3f, #2f, #0f, #7f, #3f, #1f, #07, #db, #bc, #7e, #7f, #7f, #7f, #7f, #00, #00, #7f, #bf, #df, #df, #ef, #ef
	db	#0f, #07, #03, #ba, #9d, #a5, #98, #9c, #3f, #3f, #bf, #bf, #78, #fc, #04, #f8, #00, #f7, #00, #f3, #f6, #e3, #83, #07
	db	#8e, #8f, #1f, #1f, #0f, #df, #0f, #0f, #f3, #70, #78, #7e, #3e, #3f, #3f, #1f, #27, #07, #0f, #0f, #3f, #c0, #f7, #f7
	db	#11, #61, #81, #81, #81, #81, #91, #81, #81, #61, #81, #86, #81, #81, #86, #86, #88, #88, #86, #81, #81, #81, #86, #86
	db	#81, #81, #81, #48, #41, #41, #41, #41, #86, #86, #86, #86, #a8, #a8, #ca, #a6, #88, #86, #88, #98, #86, #91, #f1, #a1
	db	#41, #41, #41, #41, #41, #41, #41, #41, #a1, #a1, #a1, #a1, #a1, #a1, #a1, #a1, #a1, #a1, #a1, #a1, #a1, #ba, #a6, #a1

i2_eyer_c_a_O: ;0x4d8 11,1,2,1,1
	db	#00, #00, #00, #02, #07, #cb, #0f, #1f, #00, #00, #00, #f0, #f0, #f8, #00, #00
	db	#99, #99, #99, #d8, #d9, #d4, #94, #94, #99, #99, #99, #d8, #d9, #d9, #99, #99

i2_eyer_c_a_E: ;0x458 11,1,2,1,0
	db	#00, #00, #00, #00, #fc, #e1, #0f, #3f, #00, #00, #00, #00, #07, #00, #00, #00
	db	#88, #88, #88, #99, #81, #81, #81, #81, #88, #88, #88, #99, #81, #88, #88, #88

i2_eyer_c_b_O: ;0x5d0 10,2,4,1,1
	db	#f8, #07, #00, #00, #00, #00, #00, #00, #7c, #c4, #60, #60, #00, #bf, #3f, #3f, #3f, #17, #e7, #fb, #fc, #fc, #01, #01, #fc, #fc, #fe, #fe, #fe, #fe, #01, #fe
	db	#94, #d8, #99, #99, #99, #99, #99, #99, #96, #98, #d9, #d9, #99, #96, #96, #96, #86, #96, #96, #96, #96, #86, #98, #d9, #94, #94, #94, #91, #91, #96, #d8, #94

i2_eyer_c_b_E: ;0x550 10,2,4,1,0
	db	#fc, #fc, #00, #00, #00, #00, #00, #00, #f8, #e3, #cf, #9f, #bf, #00, #bf, #3f, #7f, #8f, #f3, #f9, #fd, #fe, #fe, #00, #f8, #fc, #fc, #fe, #fe, #fe, #7e, #7f
	db	#81, #98, #88, #88, #88, #88, #88, #88, #81, #d1, #81, #86, #81, #88, #86, #86, #91, #81, #81, #81, #81, #91, #91, #88, #81, #81, #81, #81, #81, #81, #96, #81

i2_eyer_c_c_O: ;0x6d8 11,3,3,1,1
	db	#bf, #00, #bf, #00, #00, #18, #7c, #00, #01, #00, #00, #00, #fe, #01, #1f, #c4, #01, #01, #01, #00, #7f, #7f, #7f, #7f
	db	#96, #99, #96, #99, #99, #b9, #fb, #ff, #d9, #99, #99, #99, #96, #a9, #98, #b1, #d9, #d9, #d9, #99, #96, #96, #91, #96

i2_eyer_c_c_E: ;0x658 11,3,3,1,0
	db	#00, #bf, #9f, #bf, #00, #38, #fc, #00, #01, #00, #00, #00, #fe, #fc, #f0, #fa, #7f, #fe, #01, #00, #7f, #7f, #3f, #7f
	db	#88, #81, #86, #86, #88, #b8, #a9, #aa, #98, #88, #88, #88, #86, #81, #91, #81, #81, #86, #98, #88, #86, #86, #81, #81

i2_eyer_c_d_O: ;0x7d8 11,4,2,1,1
	db	#fc, #07, #f0, #f8, #fc, #fe, #00, #00, #38, #f0, #03, #03, #0f, #c0, #00, #00
	db	#f3, #cf, #f1, #f1, #f1, #f1, #ff, #ff, #d1, #c1, #b1, #f1, #f1, #cf, #ff, #ff

i2_eyer_c_d_E: ;0x758 11,4,2,1,0
	db	#fe, #f3, #f8, #f0, #f8, #00, #00, #00, #f0, #c1, #01, #07, #07, #1f, #00, #00
	db	#a1, #a1, #a1, #a1, #a1, #aa, #aa, #aa, #a1, #91, #91, #a1, #a1, #a1, #aa, #aa

i2_mouth_c_O: ;0x9d0 10,6,2,2,1
	db	#00, #7f, #7f, #7f, #7f, #00, #00, #f8, #00, #00, #00, #00, #00, #00, #00, #3f
	db	#f1, #f3, #07, #fc, #fe, #fe, #00, #00, #3f, #3f, #3f, #3f, #7f, #00, #fe, #fc
	db	#ff, #fb, #fb, #f9, #fb, #ff, #ff, #fb, #ff, #ff, #ff, #ff, #ff, #ff, #ff, #fc
	db	#f1, #fb, #cf, #f9, #f9, #fb, #ff, #ff, #fa, #fa, #f6, #fb, #fa, #ff, #f1, #f1

i2_mouth_c_E: ;0x950 10,6,2,2,0
	db	#00, #00, #7f, #7f, #80, #00, #00, #fc, #00, #00, #00, #00, #00, #00, #00, #7f
	db	#f8, #06, #fa, #f8, #fc, #01, #00, #00, #7f, #80, #7f, #7f, #7f, #01, #03, #f8
	db	#aa, #aa, #a9, #a3, #ba, #aa, #aa, #a1, #aa, #aa, #aa, #aa, #aa, #aa, #aa, #a6
	db	#a1, #ba, #a8, #a1, #a8, #ba, #aa, #aa, #a3, #ba, #a1, #a8, #a8, #6a, #6a, #a1

i2_mouth_h_O: ;0x9d0 10,6,2,2,1
	db	#00, #7f, #7f, #7f, #7f, #00, #00, #f0, #00, #00, #00, #00, #00, #00, #00, #3f
	db	#f0, #f9, #f6, #f8, #f8, #fd, #00, #00, #3f, #00, #7f, #7f, #7f, #00, #fe, #fc
	db	#ff, #fb, #fb, #f9, #fb, #ff, #ff, #f6, #ff, #ff, #ff, #ff, #ff, #ff, #ff, #fc
	db	#f1, #f1, #fb, #f1, #f9, #fb, #ff, #ff, #fa, #ff, #f8, #f9, #fa, #ff, #f1, #f1

i2_mouth_h_E: ;0x950 10,6,2,2,0
	db	#00, #00, #7f, #7f, #80, #00, #00, #07, #00, #00, #00, #00, #00, #00, #00, #3f
	db	#f0, #fb, #fe, #f6, #f9, #fd, #00, #00, #7f, #00, #7f, #7f, #7f, #01, #03, #f8
	db	#aa, #aa, #a9, #a3, #ba, #aa, #aa, #ca, #aa, #aa, #aa, #aa, #aa, #aa, #aa, #a6
	db	#a1, #a6, #a6, #a6, #a1, #a9, #aa, #aa, #a1, #aa, #a2, #a2, #a8, #6a, #6a, #a1

i2_mouth_o_O: ;0x9d0 10,6,2,2,1
	db	#00, #7f, #7f, #7f, #7f, #00, #f0, #e0, #00, #00, #00, #00, #00, #00, #7f, #3f
	db	#f0, #f0, #f9, #f6, #f8, #fc, #fc, #00, #3f, #7f, #7f, #7f, #7f, #00, #fe, #fc
	db	#ff, #fb, #fb, #f9, #fb, #ff, #f9, #f1, #ff, #ff, #ff, #ff, #ff, #ff, #f9, #f1
	db	#f8, #f1, #f6, #fb, #f8, #f8, #fb, #ff, #f6, #fc, #fb, #fa, #fc, #ff, #f1, #f1

i2_mouth_o_E: ;0x950 10,6,2,2,0
	db	#00, #00, #7f, #7f, #80, #00, #f0, #f0, #00, #00, #00, #00, #00, #00, #7f, #7f
	db	#e0, #f8, #fb, #fe, #f8, #f9, #03, #00, #3f, #7f, #80, #7f, #7f, #01, #03, #f8
	db	#aa, #aa, #a9, #a3, #ba, #aa, #a2, #a1, #aa, #aa, #aa, #aa, #aa, #aa, #a2, #a6
	db	#a1, #a1, #a1, #a1, #a1, #a6, #ba, #aa, #a1, #a6, #ba, #a1, #a9, #6a, #6a, #a1

i3_eyel_o_a_O: ;0x788 1,4,3,2,1
	db	#34, #f0, #e0, #e0, #e0, #c0, #fc, #1c, #40, #13, #02, #01, #20, #38, #1c, #1f, #02, #20, #97, #84, #01, #03, #01, #80
	db	#f8, #14, #86, #ee, #f4, #f8, #fc, #fc, #1f, #1f, #1f, #0f, #0f, #07, #0f, #3f, #81, #c1, #c0, #e1, #c0, #c0, #80, #80
	db	#ca, #f1, #f1, #f6, #f1, #f1, #d1, #fc, #c1, #96, #91, #d1, #61, #61, #f1, #f1, #96, #a6, #86, #96, #81, #91, #91, #c1
	db	#f1, #f1, #fd, #f1, #f6, #f8, #f8, #f6, #f1, #f1, #f1, #f6, #f8, #f8, #f8, #f6, #f1, #e1, #f1, #f1, #f8, #f9, #f9, #f9

i3_eyel_o_a_E: ;0x708 1,4,3,2,0
	db	#e0, #f0, #f0, #e0, #e0, #f8, #f8, #f8, #66, #0c, #05, #00, #00, #00, #08, #1c, #01, #47, #0f, #03, #32, #0c, #06, #03
	db	#98, #da, #84, #d4, #e2, #f0, #f8, #fc, #1d, #0d, #0d, #09, #6b, #e7, #07, #0f, #c3, #c0, #c1, #c2, #e0, #c0, #c0, #80
	db	#f1, #a1, #a1, #a1, #a6, #a1, #91, #f1, #91, #c1, #81, #11, #11, #11, #f1, #f1, #81, #81, #61, #81, #61, #61, #61, #91
	db	#31, #e1, #b1, #a1, #a1, #a1, #a1, #a1, #f1, #e1, #f1, #f1, #d1, #61, #f1, #f6, #61, #71, #31, #e1, #f6, #f8, #f8, #f8

i3_eyel_o_b_O: ;0x990 2,6,2,1,1
	db	#3f, #7e, #ba, #d3, #54, #00, #00, #00, #80, #00, #00, #7f, #00, #00, #00, #00
	db	#f9, #f6, #e6, #96, #98, #99, #99, #99, #f9, #99, #99, #98, #99, #99, #99, #99

i3_eyel_o_b_E: ;0x910 2,6,2,1,0
	db	#7f, #7f, #3c, #80, #ef, #00, #00, #00, #00, #00, #00, #00, #00, #00, #00, #00
	db	#f1, #f1, #e1, #81, #91, #88, #88, #88, #88, #88, #88, #88, #88, #88, #88, #88

i3_eyer_o_O: ;0x9a0 4,6,3,2,1
	db	#00, #00, #00, #00, #00, #01, #fe, #03, #f0, #c0, #80, #ae, #07, #87, #c7, #85, #43, #80, #6c, #1e, #8c, #8f, #9f, #80
	db	#fe, #fe, #fd, #fc, #fc, #fe, #fc, #01, #8d, #e9, #c3, #06, #18, #f0, #60, #fe, #a0, #1f, #0f, #b1, #0e, #91, #81, #20
	db	#99, #99, #99, #99, #99, #a9, #93, #d9, #91, #91, #91, #61, #f1, #f1, #f1, #f1, #98, #c8, #96, #91, #91, #91, #81, #f6
	db	#97, #96, #86, #96, #91, #91, #96, #a9, #f1, #f8, #f6, #f9, #f6, #f6, #e8, #96, #ed, #d9, #d9, #98, #d9, #98, #98, #98

i3_eyer_o_E: ;0x920 4,6,3,2,0
	db	#00, #00, #00, #00, #00, #fe, #00, #fe, #e3, #e1, #d8, #86, #86, #06, #84, #cf, #23, #b9, #1f, #2f, #1f, #80, #80, #87
	db	#fd, #fd, #fc, #fc, #fe, #fc, #fc, #fc, #e3, #43, #42, #cc, #b8, #73, #0f, #9f, #ef, #cf, #cf, #ce, #0e, #2e, #6e, #4e
	db	#88, #88, #88, #88, #88, #86, #88, #83, #81, #81, #61, #61, #e1, #e1, #f1, #e1, #81, #91, #81, #81, #61, #71, #71, #81
	db	#81, #81, #91, #81, #81, #81, #86, #86, #e1, #f1, #f6, #e1, #81, #e1, #91, #81, #81, #81, #81, #81, #81, #d1, #d1, #d1

i3_eyel_h_a_O: ;0x788 1,4,3,2,1
	db	#00, #99, #e9, #ec, #c0, #c0, #f8, #1c, #e2, #fe, #20, #20, #39, #06, #01, #10, #02, #60, #87, #87, #e1, #72, #71, #fd
	db	#f8, #14, #86, #ee, #f4, #f8, #fc, #fc, #1c, #1c, #1f, #0d, #07, #07, #07, #3f, #1f, #1f, #1f, #8f, #3f, #80, #80, #80
	db	#ff, #fb, #b6, #b8, #f1, #f1, #d1, #fc, #96, #98, #d9, #d9, #96, #91, #91, #f1, #96, #96, #86, #81, #81, #96, #98, #96
	db	#f1, #f1, #fd, #f1, #f6, #f8, #f8, #f6, #f1, #f1, #f1, #f8, #f9, #f6, #f8, #f6, #91, #91, #91, #91, #87, #f9, #f9, #f9

i3_eyel_h_a_E: ;0x708 1,4,3,2,0
	db	#00, #60, #dc, #a0, #b1, #f8, #fc, #f8, #fc, #fe, #3f, #07, #03, #19, #02, #08, #01, #07, #0f, #eb, #d2, #e0, #38, #1e
	db	#98, #da, #84, #d4, #e2, #f0, #f8, #fc, #18, #0f, #0d, #0b, #0b, #03, #0f, #0f, #7f, #3f, #9f, #9f, #97, #c0, #c0, #80
	db	#aa, #ba, #b1, #b1, #61, #61, #81, #f1, #81, #86, #81, #81, #61, #81, #81, #e1, #81, #61, #61, #61, #61, #81, #61, #61
	db	#31, #e1, #b1, #a1, #a1, #a1, #a1, #a1, #e1, #e1, #71, #71, #f1, #f6, #f1, #f6, #81, #81, #81, #81, #91, #f8, #f8, #f8

i3_eyel_h_b_O: ;0x990 2,6,2,1,1
	db	#3f, #7e, #ba, #d3, #54, #00, #00, #00, #80, #00, #00, #7f, #00, #00, #00, #00
	db	#f9, #f6, #e6, #96, #98, #99, #99, #99, #f9, #99, #99, #98, #99, #99, #99, #99

i3_eyel_h_b_E: ;0x910 2,6,2,1,0
	db	#7f, #7f, #3c, #80, #ef, #00, #00, #00, #00, #00, #00, #00, #00, #00, #00, #00
	db	#f1, #f1, #e1, #81, #91, #88, #88, #88, #88, #88, #88, #88, #88, #88, #88, #88

i3_eyer_h_O: ;0x9a0 4,6,3,2,1
	db	#00, #00, #00, #00, #00, #01, #fe, #03, #f0, #cc, #83, #80, #04, #86, #c7, #85, #03, #7b, #3c, #de, #3c, #3d, #80, #f0
	db	#fe, #fe, #fd, #fc, #fc, #fe, #fc, #01, #8d, #e9, #c3, #06, #18, #f0, #60, #fe, #a0, #1f, #0f, #b1, #0e, #91, #81, #20
	db	#99, #99, #99, #99, #99, #a9, #93, #d9, #91, #91, #91, #61, #71, #f1, #f1, #f1, #98, #96, #96, #96, #91, #91, #76, #e6
	db	#97, #96, #86, #96, #91, #91, #96, #a9, #f1, #f8, #f6, #f9, #f6, #f6, #e8, #96, #ed, #d9, #d9, #98, #d9, #98, #98, #98

i3_eyer_h_E: ;0x920 4,6,3,2,0
	db	#00, #00, #00, #00, #00, #fe, #00, #fe, #e3, #e3, #c0, #80, #86, #07, #84, #cf, #e3, #f9, #7f, #3e, #5f, #1a, #9b, #87
	db	#fd, #fd, #fc, #fc, #fe, #fc, #fc, #fc, #e3, #43, #42, #cc, #b8, #73, #0f, #9f, #ef, #cf, #cf, #ce, #0e, #2e, #6e, #4e
	db	#88, #88, #88, #88, #88, #86, #88, #83, #81, #81, #81, #61, #61, #e1, #f1, #e1, #61, #81, #81, #81, #61, #81, #81, #d1
	db	#81, #81, #91, #81, #81, #81, #86, #86, #e1, #f1, #f6, #e1, #81, #e1, #91, #81, #81, #81, #81, #81, #81, #d1, #d1, #d1

i3_eyel_c_a_O: ;0x788 1,4,3,2,1
	db	#00, #f0, #fe, #21, #f8, #f8, #f0, #f0, #80, #26, #c1, #fc, #07, #00, #00, #00, #02, #20, #97, #07, #61, #32, #f9, #44
	db	#f0, #0f, #e0, #e0, #f1, #f8, #fc, #fc, #00, #00, #00, #00, #00, #7f, #7f, #3f, #00, #df, #df, #df, #df, #df, #bf, #9f
	db	#ff, #f6, #a6, #af, #f9, #f9, #f9, #f9, #f6, #96, #96, #91, #98, #99, #99, #99, #96, #a6, #86, #86, #81, #96, #98, #d9
	db	#f9, #93, #b8, #f6, #f1, #f1, #f1, #f1, #99, #99, #99, #99, #99, #98, #91, #91, #99, #96, #96, #96, #91, #91, #96, #96

i3_eyel_c_a_E: ;0x708 1,4,3,2,0
	db	#00, #f8, #e7, #dc, #f8, #f0, #f0, #f0, #fc, #1f, #e3, #fb, #fe, #01, #00, #00, #01, #47, #0f, #83, #d2, #a0, #90, #dc
	db	#f0, #1f, #87, #c3, #e0, #f4, #f8, #fc, #00, #00, #00, #00, #00, #7f, #7f, #1f, #df, #df, #df, #df, #00, #00, #df, #bf
	db	#aa, #a1, #f1, #a8, #a8, #a8, #a8, #a8, #91, #81, #81, #81, #91, #98, #88, #88, #81, #61, #61, #61, #61, #81, #91, #81
	db	#a8, #81, #91, #b1, #a1, #a1, #a1, #a1, #88, #88, #88, #88, #88, #86, #81, #81, #81, #86, #86, #86, #88, #88, #81, #81

i3_eyel_c_b_O: ;0x990 2,6,2,1,1
	db	#0f, #03, #81, #c7, #ef, #00, #00, #00, #bf, #00, #00, #7f, #00, #00, #00, #00
	db	#91, #91, #61, #91, #96, #99, #99, #99, #96, #99, #99, #98, #99, #99, #99, #99

i3_eyel_c_b_E: ;0x910 2,6,2,1,0
	db	#1f, #81, #80, #88, #c7, #00, #00, #00, #3f, #00, #00, #7f, #00, #00, #00, #00
	db	#81, #61, #61, #61, #86, #88, #88, #88, #86, #88, #88, #86, #88, #88, #88, #88

i3_eyer_c_O: ;0x9a0 4,6,3,2,1
	db	#00, #00, #00, #00, #00, #fe, #fe, #fe, #f0, #c6, #df, #3f, #7f, #00, #00, #00, #03, #03, #3c, #3e, #9c, #fd, #99, #a0
	db	#fc, #fd, #fd, #fc, #fc, #fe, #fd, #01, #00, #00, #02, #fc, #01, #03, #8f, #fe, #e0, #1f, #0f, #b0, #71, #91, #81, #6f
	db	#99, #99, #99, #99, #99, #98, #96, #96, #91, #96, #91, #96, #96, #99, #99, #99, #98, #98, #96, #96, #96, #96, #96, #96
	db	#96, #96, #96, #91, #91, #91, #96, #a9, #99, #99, #d9, #91, #81, #91, #91, #96, #96, #d9, #d9, #98, #98, #98, #98, #d6

i3_eyer_c_E: ;0x920 4,6,3,2,0
	db	#00, #00, #00, #00, #fe, #fe, #fe, #fc, #e3, #cc, #bf, #3f, #7f, #7f, #00, #00, #e3, #f9, #7f, #be, #bc, #98, #b2, #f7
	db	#fd, #fc, #fc, #fe, #fe, #fc, #fe, #fc, #00, #00, #fe, #79, #70, #05, #17, #9f, #ef, #cf, #cf, #cf, #8e, #2e, #6e, #4e
	db	#88, #88, #88, #88, #86, #86, #86, #86, #81, #81, #81, #86, #86, #86, #88, #88, #81, #91, #81, #81, #81, #81, #81, #81
	db	#86, #86, #81, #81, #81, #81, #81, #86, #88, #88, #81, #81, #61, #61, #81, #81, #81, #81, #81, #d1, #81, #d1, #d1, #81

i3_mouth_c_a_O: ;0xb90 2,8,2,1,1
	db	#00, #00, #00, #00, #00, #00, #00, #02, #00, #00, #00, #00, #00, #00, #40, #80
	db	#99, #99, #99, #99, #99, #99, #99, #d9, #99, #99, #99, #99, #99, #99, #98, #a9

i3_mouth_c_a_E: ;0xb10 2,8,2,1,0
	db	#00, #00, #00, #00, #00, #00, #fe, #fe, #00, #00, #00, #00, #00, #00, #00, #3f
	db	#88, #88, #88, #88, #88, #88, #81, #81, #88, #88, #88, #88, #88, #88, #99, #81

i3_mouth_c_b_O: ;0xc98 3,9,1,2,1
	db	#d0, #30, #20, #bf, #87, #c7, #ef, #00
	db	#00, #00, #00, #00, #01, #be, #3c, #c3
	db	#c8, #c8, #f6, #96, #91, #91, #86, #99
	db	#99, #99, #99, #99, #a9, #96, #91, #81

i3_mouth_c_b_E: ;0xc18 3,9,1,2,0
	db	#df, #e7, #25, #1f, #df, #8f, #cf, #00
	db	#00, #00, #00, #00, #fe, #7c, #83, #b5
	db	#91, #91, #96, #81, #81, #81, #91, #88
	db	#88, #88, #88, #88, #86, #81, #81, #61

i3_mouth_h_a_O: ;0xb90 2,8,2,1,1
	db	#00, #00, #00, #00, #00, #00, #02, #fe, #00, #00, #00, #00, #00, #00, #00, #7f
	db	#99, #99, #99, #99, #99, #99, #d9, #96, #99, #99, #99, #99, #99, #99, #99, #96

i3_mouth_h_a_E: ;0xb10 2,8,2,1,0
	db	#00, #00, #00, #00, #00, #00, #fe, #fe, #00, #00, #00, #00, #00, #00, #00, #3f
	db	#88, #88, #88, #88, #88, #88, #81, #81, #88, #88, #88, #88, #88, #88, #88, #81

i3_mouth_h_b_O: ;0xc98 3,9,1,2,1
	db	#8f, #c3, #60, #20, #1f, #87, #cf, #df
	db	#00, #00, #00, #00, #01, #be, #3c, #c3
	db	#91, #f1, #e6, #f9, #96, #91, #91, #96
	db	#99, #99, #99, #99, #a9, #96, #91, #81

i3_mouth_h_b_E: ;0xc18 3,9,1,2,0
	db	#3f, #c5, #e1, #3f, #9f, #8f, #87, #ef
	db	#00, #00, #00, #00, #fe, #7c, #83, #b5
	db	#81, #61, #91, #81, #81, #81, #81, #81
	db	#88, #88, #88, #88, #86, #81, #81, #61

i3_mouth_o_a_O: ;0xb90 2,8,2,1,1
	db	#00, #00, #00, #00, #00, #00, #00, #fe, #00, #00, #00, #00, #00, #00, #7f, #7f
	db	#99, #99, #99, #99, #99, #99, #99, #91, #99, #99, #99, #99, #99, #99, #96, #96

i3_mouth_o_a_E: ;0xb10 2,8,2,1,0
	db	#00, #00, #00, #00, #00, #00, #fe, #fe, #00, #00, #00, #00, #00, #00, #7f, #1f
	db	#88, #88, #88, #88, #88, #88, #81, #81, #88, #88, #88, #88, #88, #88, #86, #81

i3_mouth_o_b_O: ;0xc98 3,9,1,2,1
	db	#03, #a1, #7f, #1f, #20, #9f, #87, #cf
	db	#cf, #00, #00, #00, #01, #be, #3c, #c3
	db	#96, #91, #83, #63, #f9, #91, #91, #91
	db	#96, #99, #99, #99, #a9, #96, #91, #81

i3_mouth_o_b_E: ;0xc18 3,9,1,2,0
	db	#07, #51, #81, #e3, #37, #9f, #cf, #c7
	db	#cf, #00, #00, #00, #fe, #7c, #83, #b5
	db	#81, #61, #91, #91, #81, #81, #81, #81
	db	#86, #88, #88, #88, #86, #81, #81, #61










;============================================================================
;
;  image2
;
;============================================================================
;PCG
proc_s1_image2:
PROC
		call	image2_setup
		jp		frame_proc_write_image_vert_right
ENDP

;xPCG
public	proc_s1_image2_atastroke
proc_s1_image2_atastroke:
PROC
		halt
		call	image2_setup
		jp		write_image_vert_right_atastroke
ENDP

image2_setup:
		ld		hl, image2_pcgptn
		ld		(WK_WRTIMG_SRC), hl
		ld		de, #380
		ld		(WK_WRTIMG_DST), de
		ld		a, #70
		ld		b, 15
		ret

;================
;PCG` cp12,cc12 
;================
image2_pcgptn:
	db	#d5, #60, #40, #30, #49, #43, #87, #8d
	db	#7f, #e0, #09, #67, #83, #f8, #e0, #40
	db	#03, #03, #03, #bf, #5f, #80, #1f, #2f
	db	#df, #4f, #18, #77, #cf, #2c, #28, #99
	db	#60, #64, #ee, #43, #40, #a6, #95, #96
	db	#08, #a3, #7f, #61, #41, #c0, #e0, #42
	db	#03, #21, #5f, #37, #23, #23, #40, #27
	db	#c7, #06, #0a, #6f, #5f, #fe, #fb, #f8
	db	#80, #00, #06, #1f, #7e, #9f, #db, #05
	db	#fd, #00, #ee, #10, #1c, #1c, #6c, #09
	db	#7f, #3c, #3d, #1f, #7d, #1c, #0e, #0e
	db	#1d, #7d, #1c, #3c, #38, #18, #06, #12
	db	#c3, #ed, #dc, #a2, #fc, #d6, #d6, #cb
	db	#61, #b3, #a6, #ca, #c3, #c1, #c1, #c1
	db	#e1, #f1, #f1, #ca, #cb, #86, #cb, #ca
	db	#ca, #ca, #c1, #a6, #c3, #f6, #f6, #d6
	db	#ec, #e6, #ca, #a6, #b6, #b6, #b6, #c3
	db	#a6, #c2, #c3, #fc, #f6, #db, #d6, #e6
	db	#b6, #cb, #ca, #d6, #e6, #fc, #ec, #cb
	db	#d6, #fc, #f1, #ca, #cb, #ca, #ca, #b1
	db	#a1, #11, #c1, #61, #61, #ca, #ca, #a6
	db	#ca, #cc, #c2, #d6, #d6, #f6, #a8, #d6
	db	#ca, #fc, #d6, #fe, #d6, #d6, #f6, #fc
	db	#f1, #d6, #f6, #fc, #d6, #d6, #a6, #a6
	db	#31, #1f, #9e, #8f, #92, #7f, #3e, #0d
	db	#7e, #1e, #b6, #66, #9a, #f0, #e0, #80
	db	#00, #04, #1c, #3f, #5f, #df, #1f, #0f
	db	#cf, #0f, #bf, #88, #7f, #13, #07, #1f
	db	#9f, #00, #e2, #bc, #bd, #49, #6a, #b6
	db	#77, #7e, #00, #1e, #16, #40, #fc, #bd
	db	#7c, #01, #5f, #5d, #dc, #dc, #3f, #07
	db	#c7, #7d, #75, #4f, #5f, #fe, #f8, #00
	db	#00, #00, #01, #05, #19, #0f, #cb, #fa
	db	#fc, #00, #00, #b3, #df, #23, #93, #7f
	db	#7f, #c2, #fe, #00, #9f, #b7, #71, #71
	db	#c2, #9f, #83, #c3, #df, #f9, #79, #e9
	db	#d1, #c1, #81, #81, #61, #c1, #c1, #d1
	db	#21, #61, #c1, #d1, #61, #61, #61, #61
	db	#11, #31, #b1, #61, #61, #c1, #61, #61
	db	#61, #61, #61, #21, #61, #c1, #c1, #c1
	db	#61, #11, #61, #21, #c1, #31, #31, #61
	db	#21, #61, #66, #81, #c1, #31, #c1, #21
	db	#21, #d1, #61, #c1, #21, #61, #d1, #d1
	db	#c1, #61, #b1, #d1, #61, #61, #61, #11
	db	#11, #11, #b1, #21, #31, #81, #61, #21
	db	#61, #66, #66, #c2, #c2, #c1, #21, #c1
	db	#61, #61, #c1, #11, #c1, #21, #21, #61
	db	#b1, #c1, #21, #61, #c1, #c2, #21, #21
	db	#86, #c7, #c5, #c4, #35, #70, #11, #4e
	db	#40, #40, #80, #80, #07, #13, #1e, #43
	db	#f1, #b0, #04, #fe, #70, #10, #42, #49
	db	#42, #fe, #ba, #08, #40, #48, #ee, #21
	db	#9f, #08, #95, #c0, #38, #8b, #20, #fe
	db	#e4, #07, #01, #cf, #fd, #cc, #e7, #04
	db	#30, #7c, #9f, #e0, #d0, #d8, #bf, #3b
	db	#30, #70, #60, #8d, #28, #90, #80, #00
	db	#0a, #2d, #4f, #bf, #db, #3f, #9f, #e0
	db	#bf, #8f, #ac, #72, #7f, #88, #0c, #88
	db	#0c, #5d, #88, #9c, #d8, #18, #42, #43
	db	#d0, #d2, #91, #86, #3c, #3c, #5f, #fb
	db	#e1, #f6, #d6, #d6, #a2, #d6, #a6, #c1
	db	#e1, #c1, #b1, #d1, #c1, #c1, #f1, #e6
	db	#fc, #d6, #ec, #c3, #86, #d6, #ec, #d6
	db	#86, #c3, #ca, #a6, #d6, #f6, #da, #a6
	db	#ca, #b6, #b6, #86, #86, #86, #e6, #ca
	db	#86, #a6, #a6, #c7, #61, #d6, #c1, #b6
	db	#86, #c2, #c3, #d6, #fc, #d6, #cb, #ca
	db	#f6, #d6, #f6, #ca, #c1, #c1, #c1, #11
	db	#c1, #c1, #ca, #c3, #c3, #ca, #cb, #e6
	db	#ca, #c2, #86, #86, #cb, #86, #86, #86
	db	#a6, #cb, #fc, #fb, #d6, #b8, #d6, #d6
	db	#f6, #f6, #f6, #ed, #d6, #d6, #cb, #a8
	db	#39, #38, #f7, #f9, #c8, #c9, #ce, #fc
	db	#98, #c0, #40, #03, #03, #0f, #21, #3c
	db	#0e, #f7, #03, #00, #f7, #fd, #99, #fd
	db	#7f, #00, #b2, #f7, #fe, #b3, #ec, #9c
	db	#9f, #b7, #22, #f7, #00, #00, #cf, #fe
	db	#00, #f9, #f8, #fc, #fd, #f3, #f7, #e3
	db	#7f, #fb, #db, #d3, #2f, #f7, #bf, #3b
	db	#c3, #f7, #8f, #8c, #d0, #c0, #00, #00
	db	#04, #3f, #4f, #2f, #6f, #2f, #9f, #9f
	db	#bf, #00, #5f, #7f, #7f, #ef, #00, #f3
	db	#73, #5d, #55, #02, #d9, #e7, #fe, #fe
	db	#2e, #28, #6e, #f9, #3d, #00, #1f, #04
	db	#b1, #21, #c2, #c3, #81, #21, #21, #61
	db	#a1, #61, #61, #c1, #61, #61, #a1, #21
	db	#61, #c1, #d6, #66, #c1, #c3, #d1, #c1
	db	#c1, #66, #81, #21, #c3, #c1, #c1, #21
	db	#81, #c1, #31, #c3, #cc, #cc, #c1, #61
	db	#cc, #c1, #c1, #61, #21, #c1, #61, #c1
	db	#c3, #61, #61, #c1, #61, #c1, #61, #61
	db	#21, #c1, #c1, #81, #b1, #61, #11, #11
	db	#b1, #61, #61, #61, #61, #61, #61, #c1
	db	#64, #66, #c2, #c1, #61, #c1, #cc, #c2
	db	#21, #61, #61, #31, #c3, #21, #c3, #c1
	db	#c1, #c1, #21, #c1, #c3, #cc, #61, #21
	db	#70, #80, #6d, #f4, #f0, #80, #01, #03
	db	#0f, #07, #03, #12, #b8, #c8, #c0, #3c
	db	#06, #01, #98, #9f, #40, #7f, #ce, #ce
	db	#04, #20, #ef, #b0, #1f, #26, #d8, #7f
	db	#02, #83, #01, #08, #04, #00, #88, #88
	db	#4a, #bf, #bf, #40, #80, #01, #28, #0a
	db	#df, #20, #09, #7f, #e7, #a2, #1c, #e3
	db	#ef, #e4, #c0, #80, #03, #02, #02, #ca
	db	#c3, #7d, #fd, #fd, #07, #07, #07, #80
	db	#0b, #04, #01, #82, #ef, #44, #0f, #0f
	db	#a4, #eb, #04, #04, #20, #c0, #0f, #0d
	db	#ec, #9f, #3f, #7f, #1f, #5a, #e1, #3e
	db	#eb, #d6, #c3, #c1, #c1, #b1, #f1, #f1
	db	#f1, #f1, #fc, #d6, #fc, #fc, #d6, #c3
	db	#a6, #f6, #a6, #ca, #86, #ca, #cb, #ca
	db	#d6, #a6, #ca, #a6, #fe, #db, #a6, #ca
	db	#d6, #86, #86, #86, #a6, #cc, #86, #86
	db	#86, #cb, #c1, #86, #86, #d6, #86, #86
	db	#c3, #96, #d6, #fe, #fe, #d6, #b6, #ca
	db	#c3, #c1, #61, #61, #b1, #c1, #e6, #b6
	db	#a6, #c8, #ca, #ca, #f6, #fc, #d6, #a6
	db	#b6, #ec, #e6, #86, #c8, #f6, #b6, #b6
	db	#d6, #c2, #d6, #fc, #d6, #fc, #fc, #d6
	db	#d6, #da, #fc, #f6, #f6, #86, #ca, #a8
	db	#00, #50, #fc, #f8, #e0, #40, #82, #0c
	db	#00, #18, #7c, #56, #47, #37, #9f, #fc
	db	#31, #bc, #47, #9f, #7f, #7f, #ce, #ce
	db	#dc, #9b, #ef, #4f, #00, #86, #27, #7f
	db	#5b, #00, #7f, #00, #f3, #f7, #00, #00
	db	#00, #bf, #00, #00, #00, #00, #00, #00
	db	#00, #9f, #99, #00, #00, #fe, #e3, #e3
	db	#ee, #f8, #c0, #00, #00, #0f, #1c, #14
	db	#2c, #7d, #fd, #fd, #f0, #f8, #c7, #7f
	db	#f3, #fb, #fc, #fc, #ef, #b9, #f0, #f0
	db	#df, #00, #fd, #fb, #3f, #3f, #f0, #df
	db	#df, #9f, #c0, #80, #e0, #a1, #e1, #c1
	db	#11, #32, #61, #61, #61, #a1, #61, #31
	db	#11, #b1, #61, #c2, #81, #61, #21, #61
	db	#c1, #c1, #c1, #61, #c1, #61, #81, #61
	db	#c2, #c1, #61, #21, #11, #c1, #21, #61
	db	#c2, #cc, #c2, #cc, #21, #61, #cc, #cc
	db	#cc, #61, #66, #cc, #cc, #cc, #cc, #cc
	db	#66, #c3, #c2, #11, #11, #c1, #21, #61
	db	#61, #61, #21, #11, #11, #61, #c1, #21
	db	#21, #62, #61, #61, #c1, #61, #c2, #21
	db	#c1, #61, #21, #c2, #62, #c1, #21, #21
	db	#c1, #66, #c2, #61, #c2, #61, #61, #c3
	db	#c1, #c1, #61, #21, #21, #c2, #61, #21
	db	#80, #82, #07, #04, #0e, #1e, #fe, #fc
	db	#f8, #ce, #04, #04, #0c, #08, #18, #e6
	db	#c0, #3f, #be, #7f, #00, #fb, #18, #18
	db	#38, #38, #32, #11, #f3, #41, #fe, #10
	db	#ee, #fe, #04, #06, #1e, #01, #02, #93
	db	#c6, #59, #10, #01, #02, #02, #01, #07
	db	#c7, #0d, #30, #e0, #c0, #e7, #f0, #f0
	db	#80, #00, #24, #7d, #1d, #a2, #40, #40
	db	#08, #f7, #10, #c0, #c0, #80, #c4, #cc
	db	#ec, #03, #fc, #03, #03, #10, #a0, #10
	db	#f4, #02, #fa, #01, #05, #98, #71, #ec
	db	#48, #dc, #ef, #e7, #e0, #3c, #fe, #61
	db	#b1, #c1, #61, #f1, #f1, #f6, #f8, #fc
	db	#f6, #f6, #d6, #f6, #d6, #d6, #b2, #ca
	db	#e6, #c1, #cb, #c8, #cc, #c2, #86, #fc
	db	#f6, #d6, #d6, #d6, #ca, #86, #c9, #86
	db	#c2, #cb, #d6, #d6, #d6, #86, #86, #86
	db	#fc, #f6, #fc, #96, #d6, #fc, #f6, #d6
	db	#fc, #f6, #fc, #fc, #d6, #ca, #b1, #c1
	db	#c1, #11, #61, #61, #ca, #86, #d6, #f6
	db	#a6, #c8, #d6, #d6, #fc, #d6, #d6, #d6
	db	#da, #a6, #ca, #a6, #a6, #e6, #d6, #86
	db	#ca, #a6, #cb, #ec, #86, #d6, #ed, #c3
	db	#f6, #f6, #fe, #f3, #d6, #c3, #c1, #a6
	db	#00, #01, #03, #0b, #31, #61, #01, #03
	db	#03, #33, #d5, #bb, #2e, #ef, #e6, #66
	db	#1f, #77, #3e, #7f, #00, #00, #00, #e7
	db	#c6, #fd, #fd, #11, #f3, #7f, #fe, #f5
	db	#00, #fe, #fe, #e6, #fd, #00, #f7, #00
	db	#39, #86, #ef, #fc, #fe, #fd, #7e, #17
	db	#38, #f0, #cf, #1f, #d9, #e6, #08, #c0
	db	#40, #00, #0f, #9c, #1d, #dc, #77, #b7
	db	#f7, #f7, #db, #ec, #3f, #bd, #e6, #ef
	db	#ec, #fc, #fc, #fc, #dc, #ef, #ef, #ee
	db	#f4, #fd, #f8, #fe, #f7, #fb, #8e, #ee
	db	#a7, #21, #00, #00, #ea, #7c, #fe, #9c
	db	#11, #b1, #21, #b1, #b1, #21, #21, #61
	db	#c1, #c1, #c2, #c1, #c2, #c3, #61, #61
	db	#21, #61, #61, #62, #66, #66, #cc, #61
	db	#c1, #c1, #c1, #c2, #61, #c1, #63, #c2
	db	#66, #61, #c1, #c2, #c1, #cc, #c2, #cc
	db	#61, #21, #61, #c3, #c3, #61, #c1, #c2
	db	#61, #21, #61, #61, #c2, #61, #61, #91
	db	#61, #11, #31, #21, #61, #c2, #c2, #21
	db	#21, #62, #c2, #c2, #61, #c2, #c2, #c1
	db	#c1, #21, #61, #21, #21, #21, #c1, #c2
	db	#61, #21, #61, #61, #c1, #c1, #c1, #61
	db	#c1, #c1, #11, #11, #c2, #61, #61, #21
	db	#10, #fc, #fc, #f8, #f9, #f2, #f2, #f2
	db	#f5, #fc, #ec, #e8, #f4, #f4, #f4, #f8
	db	#fc, #fc, #fc, #fe, #39, #38, #18, #e3
	db	#9c, #c0, #e2, #f6, #24, #fe, #fc, #01
	db	#0b, #09, #83, #d0, #01, #01, #01, #c9
	db	#9c, #47, #78, #f0, #3c, #3c, #7c, #fc
	db	#d0, #fe, #fc, #f8, #40, #00, #03, #0b
	db	#3f, #4d, #cf, #46, #30, #30, #75, #3b
	db	#1e, #06, #93, #08, #28, #42, #bf, #8f
	db	#b7, #34, #df, #c8, #18, #42, #84, #c7
	db	#c7, #88, #40, #c0, #01, #09, #14, #f7
	db	#0f, #ce, #cc, #c0, #7f, #3e, #0a, #13
	db	#c1, #64, #c4, #c4, #64, #c5, #a1, #b1
	db	#b1, #c4, #a4, #64, #c4, #c4, #c4, #c4
	db	#64, #c4, #64, #64, #d6, #f8, #fc, #ca
	db	#b8, #d6, #ca, #ca, #86, #cb, #cb, #ec
	db	#f6, #fc, #fc, #a6, #d6, #fc, #fc, #fc
	db	#fb, #ed, #fc, #d6, #d6, #f6, #fc, #fb
	db	#fc, #ca, #c1, #61, #a1, #11, #c1, #c1
	db	#61, #ca, #c3, #d6, #d6, #fc, #f6, #f6
	db	#fc, #d6, #b6, #d6, #a6, #86, #ca, #ca
	db	#c3, #86, #cb, #86, #d6, #86, #86, #ca
	db	#cb, #86, #fc, #e6, #f6, #f6, #d6, #c7
	db	#d6, #f6, #fc, #d6, #ca, #ca, #86, #a2
	db	#ee, #fc, #fd, #f9, #f9, #f0, #01, #01
	db	#03, #e5, #03, #f3, #58, #28, #98, #fb
	db	#7d, #fd, #bd, #fc, #fe, #c6, #e7, #e3
	db	#63, #fc, #e2, #f6, #e7, #fe, #fc, #fe
	db	#d4, #f6, #6c, #2f, #d7, #fe, #fe, #36
	db	#00, #38, #81, #f9, #00, #c3, #83, #00
	db	#2f, #fe, #fe, #c0, #00, #00, #00, #1f
	db	#0f, #49, #7f, #7f, #34, #cf, #8a, #44
	db	#e1, #7e, #64, #9d, #87, #f7, #bf, #8f
	db	#bf, #bf, #9f, #07, #f7, #df, #c7, #c7
	db	#c7, #4f, #bf, #7f, #f6, #b6, #f7, #10
	db	#cf, #31, #33, #ee, #3f, #3e, #7f, #e4
	db	#a1, #21, #61, #61, #c1, #61, #41, #41
	db	#41, #61, #41, #21, #14, #14, #14, #61
	db	#c1, #61, #c1, #21, #c1, #21, #61, #61
	db	#21, #c2, #61, #61, #21, #61, #61, #61
	db	#c1, #61, #81, #21, #c2, #61, #61, #81
	db	#11, #c1, #81, #c2, #cc, #21, #61, #11
	db	#61, #61, #61, #21, #11, #11, #11, #61
	db	#21, #61, #61, #c1, #c2, #61, #21, #21
	db	#61, #c2, #31, #c1, #c1, #c1, #61, #61
	db	#61, #c1, #61, #c2, #c1, #c1, #c2, #61
	db	#61, #c2, #61, #c1, #21, #c1, #c5, #d6
	db	#c3, #21, #61, #c2, #61, #61, #c1, #81
	db	#41, #01, #01, #7f, #00, #00, #00, #00
	db	#00, #00, #bf, #00, #00, #40, #40, #40
	db	#40, #c0, #40, #40, #7f, #c0, #cc, #e0
	db	#46, #f0, #f0, #fc, #84, #eb, #8e, #98
	db	#07, #c0, #c0, #04, #84, #80, #80, #88
	db	#a1, #38, #bf, #10, #08, #fe, #fc, #f9
	db	#a8, #40, #00, #00, #0b, #fe, #65, #b6
	db	#36, #7e, #e8, #68, #e0, #84, #80, #80
	db	#20, #40, #c0, #b8, #11, #04, #0c, #d0
	db	#70, #f3, #10, #dc, #d8, #ef, #40, #60
	db	#c0, #60, #60, #eb, #9e, #0a, #fc, #be
	db	#df, #2c, #26, #60, #c4, #ae, #ec, #78
	db	#c1, #74, #74, #41, #44, #44, #44, #44
	db	#44, #44, #41, #44, #44, #d4, #e4, #54
	db	#e4, #c4, #e4, #e4, #41, #64, #41, #b4
	db	#41, #84, #b1, #c4, #f1, #c2, #86, #86
	db	#a8, #f6, #d6, #d6, #d6, #f6, #d6, #d6
	db	#86, #d6, #ca, #e6, #a6, #c1, #c1, #c1
	db	#c1, #c1, #11, #11, #c1, #ca, #a6, #c3
	db	#f6, #d6, #fc, #fc, #f6, #f6, #d6, #96
	db	#d6, #d6, #d6, #db, #86, #d6, #e6, #d6
	db	#d6, #ca, #f6, #fc, #d6, #c8, #fc, #f6
	db	#d6, #d6, #d6, #b6, #cb, #b6, #ca, #c2
	db	#c2, #d6, #d6, #d6, #b6, #b8, #ca, #b3
	db	#00, #9f, #bf, #3f, #7f, #7f, #ff, #df
	db	#df, #9f, #9b, #93, #33, #33, #33, #33
	db	#13, #13, #11, #11, #19, #98, #3d, #0c
	db	#1e, #42, #07, #b8, #7a, #7f, #1d, #f9
	db	#f8, #3d, #e6, #32, #fb, #7e, #e3, #00
	db	#56, #e7, #be, #cf, #e7, #fe, #fe, #f8
	db	#50, #80, #00, #00, #04, #1e, #98, #bf
	db	#c1, #fe, #17, #97, #1c, #79, #78, #62
	db	#ea, #44, #d3, #b8, #f6, #73, #f2, #fb
	db	#32, #f3, #a3, #23, #fa, #ef, #be, #9e
	db	#df, #6e, #5b, #14, #9c, #f0, #fc, #00
	db	#00, #af, #ee, #7f, #33, #51, #cc, #81
	db	#44, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #61, #a1, #61, #c2, #21
	db	#21, #c1, #c2, #c2, #c1, #c1, #c2, #cc
	db	#c2, #c1, #81, #c1, #c1, #61, #61, #81
	db	#b1, #b1, #11, #11, #b1, #61, #21, #61
	db	#c1, #c1, #61, #81, #c1, #c1, #c3, #c2
	db	#c2, #c2, #c2, #c1, #c2, #c2, #21, #c1
	db	#c2, #61, #c1, #61, #c2, #63, #61, #21
	db	#c5, #c2, #c2, #31, #61, #21, #61, #66
	db	#66, #c2, #c2, #c1, #21, #21, #61, #61
	db	#04, #8f, #fc, #f8, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #fb
	db	#f9, #fd, #de, #de, #cf, #ef, #e7, #f3
	db	#62, #b1, #3e, #9f, #87, #80, #98, #10
	db	#90, #92, #92, #93, #93, #ef, #13, #13
	db	#93, #13, #17, #17, #97, #13, #13, #13
	db	#13, #13, #13, #13, #13, #17, #13, #13
	db	#13, #13, #13, #93, #13, #13, #93, #13
	db	#13, #93, #92, #93, #93, #12, #17, #17
	db	#93, #93, #93, #12, #13, #13, #17, #17
	db	#93, #12, #93, #92, #92, #93, #93, #12
	db	#12, #97, #13, #12, #12, #12, #13, #13
	db	#74, #74, #74, #74, #74, #44, #44, #44
	db	#44, #44, #44, #44, #44, #44, #44, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#d1, #91, #41, #41, #41, #a1, #d1, #b1
	db	#b1, #b1, #e1, #e1, #b1, #c3, #e1, #e1
	db	#e1, #e1, #e1, #e1, #e1, #e1, #e1, #e1
	db	#e1, #e1, #e1, #e1, #e1, #e1, #e1, #e1
	db	#e1, #e1, #e1, #e1, #e1, #e1, #e1, #e1
	db	#e1, #e1, #e1, #d1, #e1, #f1, #d1, #d1
	db	#a1, #e1, #e1, #f1, #e1, #e1, #e1, #d1
	db	#a1, #71, #d1, #71, #f1, #e1, #b1, #f1
	db	#f1, #a1, #71, #f1, #71, #f1, #e1, #e1
	db	#03, #00, #98, #60, #60, #00, #00, #00
	db	#e7, #e7, #e7, #27, #33, #23, #31, #11
	db	#10, #90, #98, #8c, #86, #c6, #c3, #40
	db	#79, #78, #18, #04, #00, #1f, #13, #97
	db	#11, #14, #15, #14, #14, #92, #94, #94
	db	#14, #10, #10, #90, #10, #10, #10, #10
	db	#10, #10, #10, #10, #14, #10, #94, #94
	db	#94, #94, #94, #14, #94, #94, #14, #94
	db	#94, #14, #15, #16, #14, #81, #12, #92
	db	#12, #10, #14, #95, #90, #90, #92, #92
	db	#12, #97, #16, #17, #15, #10, #10, #85
	db	#85, #12, #96, #15, #17, #81, #94, #94
	db	#c1, #74, #74, #74, #74, #44, #44, #44
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #d1, #61, #41, #d1, #61, #61
	db	#61, #61, #61, #61, #d1, #61, #61, #61
	db	#61, #61, #61, #61, #d1, #d1, #c1, #c1
	db	#61, #61, #a1, #61, #61, #31, #61, #c1
	db	#61, #61, #61, #c1, #61, #31, #31, #31
	db	#41, #61, #c1, #61, #c1, #61, #61, #31
	db	#41, #61, #c1, #61, #61, #61, #51, #61
	db	#c1, #51, #61, #c1, #61, #61, #c1, #c1
	db	#c0, #00, #00, #00, #00, #fe, #00, #00
	db	#df, #df, #df, #cf, #cf, #ef, #e7, #f7
	db	#f7, #f7, #fb, #21, #11, #9e, #cf, #e3
	db	#f0, #c7, #76, #04, #18, #3c, #7f, #3f
	db	#1f, #0f, #07, #83, #83, #81, #81, #c0
	db	#d0, #c0, #80, #80, #90, #90, #90, #90
	db	#90, #80, #80, #a0, #80, #e0, #88, #9f
	db	#9f, #80, #df, #dd, #80, #e0, #c0, #80
	db	#80, #80, #80, #80, #c0, #c0, #80, #80
	db	#80, #c0, #80, #c0, #80, #80, #c0, #c0
	db	#c0, #80, #80, #88, #88, #d8, #c0, #78
	db	#c8, #ca, #c6, #80, #80, #88, #88, #c8
	db	#c4, #44, #44, #44, #44, #41, #44, #44
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #d1, #e1, #41, #41, #41
	db	#41, #d4, #d1, #d1, #91, #91, #84, #94
	db	#94, #94, #94, #91, #91, #81, #81, #c1
	db	#e1, #d1, #f1, #f1, #f1, #a1, #f1, #e1
	db	#e1, #f1, #f1, #c4, #f1, #64, #f1, #41
	db	#41, #f4, #41, #41, #f1, #c4, #e1, #a1
	db	#a1, #a1, #a1, #a1, #a1, #e1, #a1, #a1
	db	#a1, #f1, #a1, #d1, #f1, #f1, #f1, #f1
	db	#a1, #a1, #a1, #a1, #a1, #f1, #f1, #c4
	db	#f1, #f1, #f1, #f1, #f1, #f1, #f1, #81
	db	#e0, #00, #fe, #fe, #dc, #cc, #cc, #8c
	db	#8c, #8c, #8c, #04, #04, #06, #82, #82
	db	#81, #c0, #60, #7c, #3c, #08, #00, #00
	db	#00, #86, #bc, #38, #84, #78, #3c, #1f
	db	#0f, #07, #03, #ba, #9d, #a5, #98, #9c
	db	#8e, #8f, #1f, #1f, #0f, #df, #0f, #0f
	db	#cf, #1f, #1f, #82, #1f, #89, #1f, #89
	db	#89, #09, #89, #88, #5d, #c8, #1d, #dd
	db	#dd, #dd, #dd, #dd, #9c, #3c, #dc, #dc
	db	#dc, #1c, #dc, #9c, #5c, #5c, #0e, #5e
	db	#9e, #de, #ce, #ce, #ce, #06, #1a, #88
	db	#1f, #05, #2c, #40, #40, #50, #59, #d8
	db	#41, #44, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#11, #61, #61, #61, #41, #61, #91, #81
	db	#81, #81, #81, #48, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #d1, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #d1, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #61
	db	#41, #41, #c1, #e1, #c1, #61, #e1, #71
	db	#00, #00, #00, #00, #fb, #f9, #fd, #61
	db	#61, #21, #3e, #20, #20, #30, #18, #1c
	db	#1f, #0f, #07, #03, #81, #c0, #30, #1f
	db	#0d, #02, #01, #10, #34, #66, #fe, #fc
	db	#fc, #f8, #f0, #70, #f9, #f8, #f8, #fc
	db	#fc, #7f, #7f, #39, #7f, #3f, #3f, #3f
	db	#3f, #1f, #1f, #1f, #1f, #07, #07, #03
	db	#03, #03, #01, #fe, #00, #00, #00, #00
	db	#02, #02, #02, #02, #01, #01, #01, #01
	db	#00, #00, #00, #00, #00, #00, #80, #80
	db	#80, #70, #7f, #7d, #29, #c0, #df, #7f
	db	#7f, #3f, #3f, #0f, #0f, #0f, #37, #3b
	db	#44, #44, #44, #44, #41, #41, #41, #41
	db	#41, #61, #41, #e1, #91, #91, #f1, #91
	db	#64, #94, #91, #91, #d1, #61, #91, #91
	db	#91, #c1, #61, #d1, #f1, #f4, #f1, #f1
	db	#f1, #f1, #f1, #f4, #b7, #f4, #f4, #f4
	db	#f4, #fc, #f1, #f1, #f4, #f1, #f1, #f4
	db	#a4, #f4, #f4, #f4, #f4, #f4, #f4, #f4
	db	#f4, #f4, #b4, #41, #44, #44, #44, #44
	db	#14, #14, #14, #14, #14, #14, #14, #14
	db	#44, #44, #44, #44, #44, #44, #54, #54
	db	#c4, #c1, #41, #47, #47, #e4, #41, #41
	db	#41, #41, #41, #41, #41, #41, #e1, #e1
	db	#00, #fb, #72, #73, #61, #60, #60, #7d
	db	#7d, #3c, #10, #1e, #9f, #9f, #c3, #c9
	db	#0e, #07, #f3, #f9, #7c, #3e, #ce, #80
	db	#02, #07, #00, #38, #7e, #7c, #6c, #ec
	db	#68, #70, #70, #f0, #70, #fa, #fc, #fc
	db	#7e, #76, #33, #7e, #3e, #3f, #3f, #1f
	db	#1f, #1f, #1f, #0f, #0f, #0f, #07, #07
	db	#03, #01, #80, #80, #80, #81, #81, #81
	db	#81, #81, #80, #80, #40, #40, #40, #40
	db	#40, #40, #40, #60, #60, #60, #20, #20
	db	#30, #7f, #3a, #3e, #1e, #1c, #1e, #1e
	db	#0e, #0e, #0f, #07, #07, #07, #8f, #07
	db	#11, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#81, #81, #41, #41, #41, #41, #41, #41
	db	#61, #81, #11, #31, #71, #71, #f1, #e1
	db	#f1, #f1, #b1, #e1, #f4, #b1, #b4, #b1
	db	#b1, #a1, #a1, #a4, #a1, #a1, #a1, #a1
	db	#f1, #a1, #a1, #a1, #a1, #a1, #a1, #a1
	db	#a1, #a1, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #71, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#01, #07, #0f, #0f, #23, #3f, #1f, #8f
	db	#e3, #0e, #7f, #7f, #3f, #3f, #1f, #0f
	db	#07, #0f, #00, #00, #00, #1f, #1f, #7f
	db	#00, #7f, #7f, #7f, #3f, #1f, #0f, #0f
	db	#0f, #3f, #1f, #37, #37, #1f, #57, #f3
	db	#67, #07, #8f, #cf, #1f, #3f, #f7, #f3
	db	#f8, #f8, #fe, #fe, #fe, #00, #00, #00
	db	#00, #00, #00, #7f, #3f, #3f, #0f, #03
	db	#01, #fe, #00, #00, #00, #00, #00, #00
	db	#80, #80, #04, #fb, #f3, #38, #18, #9f
	db	#df, #df, #df, #00, #10, #14, #ef, #fd
	db	#f5, #f6, #fe, #fb, #fb, #fd, #fc, #01
	db	#61, #94, #94, #84, #91, #94, #94, #d4
	db	#91, #d9, #96, #96, #91, #91, #91, #94
	db	#91, #96, #99, #99, #99, #96, #91, #96
	db	#99, #96, #96, #91, #91, #94, #91, #91
	db	#91, #d1, #d1, #d1, #b1, #f1, #b4, #fa
	db	#f1, #f1, #f1, #f1, #f3, #fb, #fc, #f3
	db	#f6, #f6, #f6, #f6, #fb, #ff, #ff, #ff
	db	#ff, #ff, #ff, #fa, #f1, #a4, #f4, #f1
	db	#f4, #41, #44, #44, #44, #44, #14, #14
	db	#14, #14, #74, #47, #47, #74, #71, #41
	db	#41, #41, #41, #14, #14, #14, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #f4
	db	#f8, #03, #0f, #07, #81, #1f, #0f, #03
	db	#81, #ef, #7f, #7f, #7f, #1f, #0f, #07
	db	#63, #87, #00, #00, #00, #7f, #7f, #7f
	db	#00, #7f, #7f, #3f, #1f, #0f, #1f, #0f
	db	#27, #07, #07, #07, #17, #33, #5b, #57
	db	#0f, #0f, #ef, #f0, #3f, #c0, #f7, #f7
	db	#fb, #fd, #fc, #fe, #01, #00, #00, #00
	db	#00, #00, #00, #7f, #7f, #1f, #07, #fb
	db	#c0, #e0, #e0, #f0, #f0, #f0, #78, #78
	db	#78, #7c, #7c, #2c, #3c, #3c, #bf, #1c
	db	#0c, #0c, #04, #04, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #80, #80, #c0
	db	#41, #61, #81, #91, #41, #61, #81, #91
	db	#81, #86, #86, #81, #81, #81, #81, #81
	db	#41, #81, #88, #88, #88, #81, #81, #86
	db	#88, #86, #86, #81, #81, #81, #84, #81
	db	#d1, #91, #91, #91, #81, #a1, #f1, #a1
	db	#a5, #a4, #a1, #fa, #a1, #ba, #a6, #a1
	db	#a1, #a1, #a1, #a1, #ba, #aa, #aa, #aa
	db	#aa, #aa, #aa, #a1, #a1, #f1, #a1, #c1
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #11, #11, #11, #11
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #05, #f8
	db	#f8, #07, #fd, #00, #02, #fe, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #03
	db	#03, #07, #1f, #1f, #3f, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #7f, #7f, #7f, #7f, #00, #00, #f8
	db	#f1, #f3, #07, #fc, #fe, #fe, #00, #00
	db	#00, #3f, #3f, #8f, #f0, #00, #00, #00
	db	#00, #00, #00, #01, #fe, #fe, #fe, #01
	db	#01, #fe, #fe, #01, #01, #fe, #fe, #fe
	db	#01, #02, #0c, #4f, #3f, #3f, #c0, #c0
	db	#66, #99, #99, #99, #99, #99, #99, #99
	db	#99, #99, #99, #99, #99, #99, #d8, #94
	db	#94, #d8, #96, #99, #d8, #91, #99, #99
	db	#99, #99, #99, #99, #99, #99, #99, #b9
	db	#f9, #f9, #f9, #f9, #fb, #ff, #ff, #ff
	db	#ff, #ff, #ff, #ff, #ff, #ff, #ff, #ff
	db	#ff, #fb, #fb, #f9, #fb, #ff, #ff, #fb
	db	#f1, #fb, #cf, #f9, #f9, #fb, #ff, #ff
	db	#ff, #fb, #b1, #c1, #41, #44, #44, #44
	db	#14, #14, #14, #14, #41, #41, #41, #e4
	db	#d4, #41, #41, #c4, #c4, #41, #41, #41
	db	#14, #14, #14, #41, #41, #41, #e4, #f4
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #fc, #fc
	db	#fc, #fe, #f9, #fc, #fe, #fc, #fe, #00
	db	#00, #00, #00, #00, #00, #00, #00, #01
	db	#03, #07, #0f, #3f, #40, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #7f, #7f, #80, #00, #00, #fc
	db	#f8, #06, #fa, #f8, #fc, #01, #00, #00
	db	#00, #7f, #1f, #0e, #00, #00, #80, #00
	db	#40, #40, #60, #60, #20, #20, #20, #30
	db	#30, #30, #38, #18, #18, #18, #18, #18
	db	#18, #11, #03, #07, #0f, #3f, #7c, #d8
	db	#66, #88, #88, #88, #88, #88, #88, #88
	db	#88, #88, #88, #88, #88, #88, #94, #81
	db	#81, #98, #86, #81, #91, #81, #81, #88
	db	#88, #88, #88, #88, #88, #88, #88, #b8
	db	#a8, #a8, #a8, #a8, #ba, #aa, #aa, #aa
	db	#aa, #aa, #aa, #aa, #aa, #aa, #aa, #aa
	db	#aa, #aa, #a9, #a3, #ba, #aa, #aa, #a1
	db	#a1, #ba, #a8, #a1, #a8, #ba, #aa, #aa
	db	#aa, #a1, #b1, #61, #11, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #01, #f9, #c1, #0f, #3f
	db	#10, #80, #80, #02, #0f, #1b, #1f, #1e
	db	#3f, #3e, #38, #3f, #3c, #9e, #1f, #1f
	db	#ef, #0f, #f3, #f9, #fd, #fe, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #3f
	db	#3f, #3f, #3f, #3f, #7f, #00, #fe, #fc
	db	#f0, #c0, #80, #01, #01, #01, #03, #03
	db	#03, #81, #81, #81, #01, #fe, #fe, #00
	db	#03, #00, #7b, #88, #ef, #1f, #80, #00
	db	#00, #fe, #fd, #01, #03, #07, #0f, #0f
	db	#66, #99, #99, #99, #99, #99, #99, #99
	db	#99, #99, #99, #d9, #d4, #84, #94, #94
	db	#96, #a1, #a1, #c1, #71, #e1, #f1, #fb
	db	#f8, #f6, #f6, #f8, #f6, #f6, #fa, #fa
	db	#fb, #fa, #fe, #f5, #fb, #f6, #ff, #ff
	db	#ff, #ff, #ff, #ff, #ff, #ff, #ff, #ff
	db	#ff, #ff, #ff, #ff, #ff, #ff, #ff, #fc
	db	#fa, #fa, #f6, #fb, #fa, #ff, #f1, #f1
	db	#f1, #f1, #f1, #81, #91, #91, #64, #64
	db	#64, #81, #91, #81, #64, #41, #41, #44
	db	#14, #14, #41, #14, #41, #41, #14, #14
	db	#44, #41, #41, #91, #91, #84, #64, #94
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #03, #fc, #e1, #08, #40
	db	#c0, #e0, #c0, #85, #0d, #1f, #3b, #3b
	db	#fa, #f8, #fc, #fc, #fc, #7c, #fe, #fe
	db	#1f, #00, #03, #f3, #fc, #fe, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #7f
	db	#7f, #80, #7f, #7f, #7f, #01, #03, #f8
	db	#f8, #e0, #58, #78, #f8, #f8, #01, #01
	db	#81, #fd, #fc, #fc, #c0, #40, #60, #60
	db	#60, #63, #73, #76, #4e, #5e, #3c, #7c
	db	#f8, #f0, #c0, #f9, #f9, #03, #07, #07
	db	#66, #88, #88, #88, #88, #88, #88, #88
	db	#88, #88, #88, #98, #91, #d1, #d1, #61
	db	#d1, #61, #61, #31, #31, #71, #71, #f1
	db	#e1, #f1, #f1, #f1, #f4, #f4, #f1, #f3
	db	#fa, #ff, #fa, #a1, #a1, #a3, #aa, #aa
	db	#aa, #aa, #aa, #aa, #aa, #aa, #aa, #aa
	db	#aa, #aa, #aa, #aa, #aa, #aa, #aa, #a6
	db	#a3, #ba, #a1, #a8, #a8, #6a, #6a, #a1
	db	#a1, #a1, #41, #41, #41, #41, #91, #91
	db	#91, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #91, #91, #81
	db	#c0, #f0, #f4, #fc, #fe, #00, #00, #00
	db	#00, #00, #00, #80, #f0, #f8, #e0, #df
	db	#63, #0b, #02, #c0, #c0, #80, #80, #07
	db	#07, #83, #04, #06, #07, #0b, #19, #1d
	db	#9c, #c0, #e8, #fc, #c8, #3f, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#fc, #fd, #f0, #d4, #cf, #9f, #1f, #3f
	db	#01, #03, #03, #07, #07, #0f, #0f, #0f
	db	#1f, #1f, #1f, #1f, #1f, #1f, #1f, #3f
	db	#3f, #7f, #3f, #3f, #3f, #3f, #3f, #1f
	db	#7f, #2f, #1f, #1f, #1f, #1f, #ef, #ef
	db	#91, #94, #84, #91, #91, #99, #99, #99
	db	#99, #99, #99, #d8, #d9, #d9, #98, #91
	db	#96, #91, #d1, #71, #f1, #f1, #f1, #41
	db	#41, #41, #d1, #91, #f1, #f1, #f4, #f7
	db	#f1, #f1, #fa, #fa, #ea, #f3, #ff, #ff
	db	#ff, #ff, #ff, #ff, #ff, #ff, #ff, #ff
	db	#ff, #ff, #ff, #ff, #ff, #ff, #ff, #ff
	db	#a6, #f6, #f6, #f6, #a1, #91, #91, #91
	db	#b8, #f9, #f9, #f9, #f9, #f9, #f9, #f9
	db	#f9, #f9, #f9, #f9, #f9, #f9, #f9, #f6
	db	#f6, #f4, #f4, #f4, #f4, #f4, #f4, #f1
	db	#f1, #f9, #a9, #a9, #f8, #f8, #ac, #ac
	db	#8f, #e0, #f8, #fe, #fe, #fe, #00, #00
	db	#00, #00, #00, #00, #07, #df, #7f, #2f
	db	#17, #17, #07, #81, #f8, #ce, #06, #00
	db	#00, #00, #83, #c7, #c3, #d3, #09, #08
	db	#6a, #81, #e1, #f3, #e7, #1f, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#fe, #fc, #fb, #e3, #e7, #8f, #3f, #7f
	db	#7f, #7e, #07, #07, #0f, #0f, #0f, #1f
	db	#0f, #1f, #1f, #1f, #3f, #3f, #7f, #7f
	db	#7f, #3f, #3f, #3f, #3f, #1f, #1f, #7f
	db	#1f, #5f, #0f, #0f, #ef, #ef, #0f, #0f
	db	#41, #81, #91, #81, #81, #81, #88, #88
	db	#88, #88, #88, #99, #81, #86, #91, #81
	db	#61, #81, #61, #61, #41, #41, #41, #11
	db	#11, #11, #41, #71, #71, #71, #f4, #f1
	db	#41, #e1, #f1, #f1, #f1, #a1, #aa, #aa
	db	#aa, #aa, #aa, #aa, #aa, #aa, #aa, #aa
	db	#aa, #aa, #aa, #aa, #aa, #aa, #aa, #aa
	db	#f1, #a1, #a1, #a1, #81, #81, #81, #81
	db	#91, #8a, #a8, #a8, #a8, #a8, #a8, #a8
	db	#a8, #a8, #a8, #a8, #a8, #a8, #a1, #a1
	db	#a1, #a1, #a1, #a1, #a1, #a1, #a1, #a1
	db	#a1, #a1, #f8, #f6, #a1, #a1, #f6, #f6
	db	#00, #00, #00, #00, #00, #7f, #80, #80
	db	#c0, #e0, #c0, #f0, #e0, #f0, #f8, #f8
	db	#fc, #fc, #fc, #fe, #5e, #7e, #01, #81
	db	#7e, #7f, #7f, #7f, #7f, #80, #3f, #7f
	db	#00, #00, #00, #00, #80, #c0, #e0, #e0
	db	#f0, #e0, #f0, #f0, #f0, #f0, #e0, #e0
	db	#e0, #e0, #c0, #c0, #c0, #c0, #80, #7f
	db	#00, #1e, #3f, #7f, #7f, #7f, #7f, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #fe, #fe, #fe, #fc, #f8, #f8, #f0
	db	#44, #44, #44, #44, #44, #41, #d4, #91
	db	#91, #84, #84, #84, #94, #94, #94, #94
	db	#94, #94, #84, #91, #96, #91, #d9, #d9
	db	#96, #91, #94, #94, #94, #f9, #96, #96
	db	#99, #99, #99, #99, #f9, #f9, #f9, #f9
	db	#f9, #f9, #f9, #f9, #f9, #f9, #f9, #f9
	db	#f9, #f9, #f9, #f9, #f9, #f8, #f8, #96
	db	#99, #b9, #f9, #f9, #f9, #fb, #fb, #ff
	db	#ff, #ff, #ff, #ff, #ff, #ff, #ff, #ff
	db	#ff, #ff, #ff, #ff, #ff, #ff, #ff, #ff
	db	#ff, #ff, #ff, #ff, #ff, #ff, #ff, #ff
	db	#ff, #fd, #f4, #f4, #f4, #f4, #f4, #f4
	db	#00, #e0, #f0, #78, #38, #0e, #03, #f9
	db	#9f, #c0, #e0, #e0, #f4, #f2, #f0, #f8
	db	#f8, #3c, #7c, #9e, #3e, #fe, #7f, #7f
	db	#3f, #7e, #3f, #3f, #3f, #3f, #7f, #7f
	db	#7f, #00, #00, #00, #80, #c0, #e0, #f0
	db	#e0, #f0, #e0, #e0, #f0, #e0, #f0, #f0
	db	#e0, #e0, #e0, #e0, #c0, #df, #9f, #3f
	db	#7f, #0f, #1f, #3f, #7f, #7f, #80, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#01, #fe, #fe, #fc, #fe, #fc, #fc, #f8
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #91, #91, #91, #81, #81, #81, #81
	db	#81, #81, #91, #81, #81, #86, #81, #81
	db	#81, #81, #81, #81, #81, #81, #81, #81
	db	#81, #88, #88, #88, #a8, #a8, #a8, #a8
	db	#a8, #a8, #a8, #a8, #a8, #a8, #a8, #a8
	db	#a8, #a8, #a8, #a8, #a8, #91, #91, #81
	db	#81, #b8, #a8, #a8, #a8, #a8, #ba, #aa
	db	#aa, #aa, #aa, #aa, #aa, #aa, #aa, #aa
	db	#aa, #aa, #aa, #aa, #aa, #aa, #aa, #aa
	db	#aa, #aa, #aa, #aa, #aa, #aa, #aa, #aa
	db	#ba, #a3, #a1, #a1, #a4, #a4, #a4, #a4
	db	#fe, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #82
	db	#be, #cb, #00, #00, #00, #7e, #3c, #01
	db	#03, #03, #03, #03, #81, #03, #83, #83
	db	#83, #c3, #c6, #8f, #cf, #d6, #cd, #eb
	db	#cb, #dc, #03, #07, #43, #02, #f8, #fc
	db	#fc, #fc, #fc, #fe, #fe, #fe, #fe, #00
	db	#00, #01, #01, #80, #80, #c0, #c0, #c0
	db	#e0, #e0, #e0, #e0, #e0, #f0, #f0, #f0
	db	#f0, #f8, #f8, #f8, #f8, #fc, #fc, #fe
	db	#fc, #f8, #f0, #f0, #e0, #c0, #c0, #80
	db	#80, #00, #00, #00, #00, #00, #00, #00
	db	#41, #44, #44, #44, #44, #44, #44, #44
	db	#44, #44, #44, #44, #44, #44, #44, #14
	db	#41, #41, #14, #44, #44, #41, #41, #61
	db	#91, #84, #94, #94, #91, #e4, #94, #94
	db	#94, #91, #91, #84, #84, #91, #91, #91
	db	#91, #83, #b8, #f9, #f8, #f8, #91, #94
	db	#91, #91, #91, #91, #91, #96, #98, #99
	db	#99, #d9, #d9, #b8, #f9, #f9, #f9, #f9
	db	#f9, #f9, #f9, #f9, #f9, #f9, #f9, #f9
	db	#f9, #f9, #f9, #f9, #f9, #f9, #fd, #f1
	db	#f1, #f1, #f4, #f4, #f4, #f4, #b4, #a4
	db	#54, #44, #44, #44, #44, #44, #44, #44
	db	#00, #00, #00, #00, #00, #00, #80, #e0
	db	#08, #00, #00, #00, #80, #40, #62, #3e
	db	#00, #00, #80, #40, #40, #30, #18, #98
	db	#c1, #03, #03, #80, #fc, #81, #81, #81
	db	#c1, #85, #8b, #c4, #c0, #e7, #ef, #cd
	db	#e3, #d3, #d7, #d7, #b7, #f2, #f8, #f8
	db	#fc, #f8, #fe, #fc, #fe, #fe, #fe, #fe
	db	#00, #01, #01, #00, #c0, #c0, #e0, #e0
	db	#c0, #e0, #f0, #f0, #f0, #e0, #f0, #f8
	db	#f8, #f0, #f0, #f0, #f8, #f8, #fe, #fc
	db	#fc, #f8, #f0, #e0, #e0, #c0, #80, #bc
	db	#7e, #7e, #fe, #fe, #fe, #fe, #fe, #fe
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41
	db	#41, #61, #81, #41, #41, #81, #d1, #81
	db	#81, #84, #84, #91, #91, #81, #81, #81
	db	#81, #91, #91, #81, #91, #91, #81, #81
	db	#81, #81, #81, #81, #81, #81, #83, #86
	db	#88, #98, #98, #99, #a8, #a8, #a8, #a8
	db	#a8, #a8, #a8, #a8, #a8, #a8, #a8, #a8
	db	#a8, #a8, #a8, #a8, #a8, #a8, #a6, #a1
	db	#a1, #a1, #a1, #a1, #a1, #a1, #f1, #41
	db	#41, #41, #41, #41, #41, #41, #41, #41


;============================================================================
;
;  image3
;
;============================================================================
;PCG
proc_s1_image3:
PROC
		call	image3_setup
		jp		frame_proc_write_image_horz_up
ENDP

;xPCG
public	proc_s1_image3_atastroke
proc_s1_image3_atastroke:
PROC
		halt
		call	cls_image
		call	image3_setup
		jp		write_image_horz_up_atastroke
ENDP

image3_setup:
		ld		hl, image3_pcgptn
		ld		(WK_WRTIMG_SRC), hl
		ld		de, #e80
		ld		(WK_WRTIMG_DST), de
		ld		a, #70
		ld		b, 12
		ret

;================
;PCG` p15,c15 
;================
image3_pcgptn:
	db	#0f, #1f, #1f, #3f, #3f, #3f, #7f, #7f
	db	#fc, #fc, #fc, #fc, #fc, #fc, #fe, #fe
	db	#cf, #ff, #d4, #cf, #e2, #c3, #e1, #e0
	db	#00, #3e, #00, #f4, #fc, #dc, #98, #73
	db	#a4, #07, #77, #77, #26, #f6, #f4, #c4
	db	#22, #40, #6a, #6a, #42, #c2, #a8, #e2
	db	#44, #c4, #84, #c4, #39, #bf, #42, #09
	db	#1a, #3f, #47, #7a, #36, #b2, #70, #fe
	db	#36, #33, #03, #30, #3f, #3f, #e7, #b7
	db	#f3, #f9, #f9, #7a, #fd, #fc, #23, #43
	db	#9f, #53, #80, #7f, #7a, #a8, #bf, #80
	db	#fd, #dd, #c2, #7f, #09, #fd, #1c, #94
	db	#be, #6d, #d0, #f7, #7f, #9f, #20, #60
	db	#31, #0d, #f2, #5c, #f6, #e6, #dd, #05
	db	#22, #0b, #01, #bf, #30, #bf, #5f, #bf
	db	#f6, #f6, #f6, #f8, #f8, #f6, #f6, #f9
	db	#f9, #f9, #f9, #f9, #f9, #f9, #f9, #f9
	db	#86, #81, #96, #81, #91, #84, #84, #94
	db	#88, #86, #88, #86, #81, #91, #91, #81
	db	#96, #86, #91, #81, #86, #81, #86, #98
	db	#98, #98, #96, #98, #98, #98, #98, #96
	db	#98, #98, #98, #98, #d8, #86, #98, #d8
	db	#96, #d6, #d6, #86, #86, #d6, #d1, #81
	db	#b1, #c1, #e1, #c1, #81, #c1, #ca, #ca
	db	#c7, #c7, #b7, #b1, #c7, #c7, #cb, #e2
	db	#c9, #c3, #96, #ca, #ca, #b6, #ca, #72
	db	#cb, #cb, #b6, #ca, #b6, #c2, #86, #98
	db	#c1, #c8, #96, #cb, #ca, #ca, #a6, #b6
	db	#b6, #b6, #c2, #a6, #ca, #cb, #a6, #a6
	db	#c1, #b1, #ec, #c1, #d1, #c1, #c3, #61
	db	#df, #1f, #1f, #3f, #3f, #7f, #7f, #7f
	db	#f8, #fc, #fc, #fe, #fe, #fe, #fc, #fc
	db	#c0, #c0, #c3, #e3, #cd, #e0, #e0, #e0
	db	#e3, #c3, #86, #0e, #0e, #29, #73, #b8
	db	#13, #32, #0a, #aa, #62, #6b, #42, #00
	db	#19, #19, #11, #11, #11, #11, #53, #11
	db	#b9, #39, #39, #39, #79, #79, #39, #79
	db	#e1, #fe, #be, #bc, #f8, #7c, #fe, #70
	db	#09, #3f, #7c, #7f, #5f, #3f, #27, #37
	db	#f5, #f5, #02, #06, #fb, #f9, #01, #9c
	db	#9f, #f3, #00, #7f, #72, #77, #bf, #bf
	db	#dc, #dd, #3d, #7f, #e6, #00, #f3, #ef
	db	#bf, #6d, #d7, #f7, #7f, #9f, #9f, #9f
	db	#42, #f0, #00, #b3, #f2, #e6, #a2, #fa
	db	#1f, #14, #3f, #1f, #07, #1f, #9f, #9f
	db	#a1, #a6, #a6, #a1, #a1, #a1, #a1, #a3
	db	#a8, #a8, #a8, #a8, #a8, #a8, #a8, #a8
	db	#91, #91, #81, #91, #81, #91, #91, #81
	db	#61, #61, #61, #61, #61, #61, #81, #61
	db	#81, #61, #61, #61, #61, #61, #d1, #11
	db	#61, #61, #81, #d1, #d1, #d1, #61, #d1
	db	#d1, #d1, #d1, #d1, #81, #d1, #d1, #61
	db	#65, #61, #d1, #61, #61, #61, #81, #61
	db	#61, #61, #b1, #a1, #21, #61, #61, #61
	db	#61, #81, #61, #71, #61, #81, #e1, #81
	db	#62, #61, #cc, #61, #81, #c1, #61, #81
	db	#61, #61, #21, #61, #21, #66, #c2, #21
	db	#61, #62, #21, #61, #61, #61, #c1, #21
	db	#31, #21, #66, #c1, #61, #61, #c1, #21
	db	#b1, #a1, #61, #61, #b1, #81, #61, #21
	db	#0f, #f0, #f0, #0f, #4f, #f0, #e0, #e0
	db	#e0, #f0, #f0, #f0, #f8, #f8, #f8, #f8
	db	#00, #3f, #1f, #8f, #83, #c0, #cc, #c0
	db	#00, #00, #00, #00, #01, #be, #3c, #c3
	db	#f8, #f2, #c0, #c8, #9f, #df, #df, #df
	db	#69, #d8, #14, #6b, #b4, #14, #35, #70
	db	#dc, #22, #bd, #bd, #bd, #bd, #bd, #7b
	db	#33, #67, #67, #fe, #9d, #76, #fe, #fe
	db	#20, #c0, #00, #00, #00, #00, #3a, #3f
	db	#60, #30, #10, #10, #18, #08, #44, #0d
	db	#00, #00, #00, #00, #00, #40, #4e, #16
	db	#00, #00, #00, #00, #00, #00, #96, #fe
	db	#00, #00, #00, #00, #00, #00, #08, #eb
	db	#00, #00, #00, #00, #00, #00, #16, #57
	db	#00, #00, #00, #00, #00, #00, #38, #3f
	db	#a8, #da, #da, #a9, #fd, #da, #da, #da
	db	#f6, #f8, #f9, #f9, #f9, #f9, #f9, #f9
	db	#99, #91, #91, #91, #91, #91, #91, #91
	db	#99, #99, #99, #99, #a9, #96, #91, #81
	db	#96, #96, #96, #96, #81, #81, #81, #81
	db	#86, #86, #98, #86, #96, #96, #98, #98
	db	#d6, #98, #d9, #d9, #d9, #d9, #d9, #86
	db	#d6, #d6, #d8, #d1, #65, #d8, #91, #91
	db	#e1, #f1, #11, #11, #11, #11, #c1, #61
	db	#e1, #e1, #e1, #91, #e1, #91, #e3, #f2
	db	#11, #11, #11, #11, #11, #c1, #cb, #86
	db	#11, #11, #11, #11, #11, #11, #cb, #63
	db	#11, #11, #11, #11, #11, #11, #f1, #b8
	db	#11, #11, #11, #11, #11, #11, #c1, #ca
	db	#11, #11, #11, #11, #11, #11, #c1, #81
	db	#07, #07, #07, #4f, #e0, #cf, #cf, #cf
	db	#fc, #fe, #f0, #f8, #f8, #f8, #f8, #fc
	db	#7f, #7f, #1f, #07, #85, #8c, #db, #df
	db	#00, #00, #00, #00, #fe, #7c, #83, #b5
	db	#fc, #f1, #e3, #83, #63, #23, #83, #b3
	db	#9c, #8d, #89, #9d, #09, #29, #08, #09
	db	#bd, #9d, #bd, #bd, #bd, #bd, #bd, #bd
	db	#f8, #f8, #02, #f8, #fe, #be, #3e, #1e
	db	#d8, #80, #00, #00, #00, #00, #9d, #3e
	db	#34, #20, #20, #30, #10, #18, #88, #60
	db	#00, #00, #00, #00, #00, #00, #40, #f3
	db	#00, #00, #00, #00, #00, #00, #02, #fe
	db	#00, #00, #00, #00, #00, #00, #05, #14
	db	#00, #00, #00, #00, #00, #00, #a0, #40
	db	#00, #00, #00, #00, #00, #00, #46, #3f
	db	#f6, #f6, #f8, #f1, #da, #f1, #f1, #f1
	db	#a1, #a1, #a8, #a8, #a8, #a8, #a8, #a8
	db	#81, #81, #81, #81, #81, #61, #61, #81
	db	#88, #88, #88, #88, #86, #81, #81, #61
	db	#81, #81, #81, #61, #61, #61, #61, #61
	db	#81, #61, #61, #61, #81, #81, #d1, #d1
	db	#81, #d1, #81, #81, #81, #81, #81, #d1
	db	#81, #81, #e6, #61, #61, #d1, #51, #51
	db	#41, #d1, #11, #11, #11, #11, #61, #21
	db	#c1, #c1, #71, #71, #c1, #71, #d1, #81
	db	#11, #11, #11, #11, #11, #11, #91, #c2
	db	#11, #11, #11, #11, #11, #11, #81, #21
	db	#11, #11, #11, #11, #11, #11, #b1, #21
	db	#11, #11, #11, #11, #11, #11, #b1, #91
	db	#11, #11, #11, #11, #11, #11, #a1, #21
	db	#0f, #0e, #0f, #0f, #0f, #0f, #07, #07
	db	#e0, #f0, #c0, #f8, #88, #cc, #c0, #e0
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#d0, #30, #20, #bf, #87, #c7, #ef, #00
	db	#00, #00, #00, #00, #00, #00, #00, #fd
	db	#fa, #f2, #e2, #e0, #90, #cf, #2f, #ef
	db	#bf, #20, #20, #dc, #dc, #41, #61, #dc
	db	#fc, #fc, #fc, #fe, #fe, #fe, #01, #fe
	db	#f9, #47, #58, #ed, #7a, #61, #af, #32
	db	#25, #8c, #0b, #80, #d2, #0f, #3f, #66
	db	#fd, #02, #fc, #03, #c0, #41, #61, #7f
	db	#31, #3f, #df, #80, #a0, #1f, #7c, #0f
	db	#a6, #d5, #06, #98, #83, #8d, #c4, #a9
	db	#14, #eb, #13, #61, #97, #f9, #39, #91
	db	#20, #ef, #b7, #20, #08, #b0, #c0, #1f
	db	#a9, #f6, #f6, #a8, #a8, #a8, #f6, #f6
	db	#f9, #f8, #c9, #b8, #f9, #a8, #f8, #f6
	db	#99, #99, #99, #99, #99, #99, #99, #99
	db	#c8, #c8, #f6, #96, #91, #91, #86, #99
	db	#99, #99, #99, #99, #99, #99, #99, #86
	db	#91, #96, #98, #96, #98, #86, #86, #86
	db	#86, #98, #98, #d9, #d9, #98, #98, #d6
	db	#84, #85, #87, #82, #d7, #87, #76, #64
	db	#41, #54, #c3, #54, #54, #c3, #54, #c1
	db	#54, #43, #54, #fc, #54, #c7, #a7, #d1
	db	#43, #e4, #cb, #74, #73, #c1, #c2, #ca
	db	#e1, #c5, #b1, #fc, #d1, #b1, #ca, #c1
	db	#c3, #c3, #a6, #ba, #b8, #a8, #a6, #c1
	db	#d1, #c3, #a6, #a8, #ca, #cb, #b8, #c1
	db	#b1, #c8, #c1, #96, #d6, #a6, #a8, #c1
	db	#0e, #0f, #0f, #07, #07, #07, #0f, #0f
	db	#f0, #7f, #30, #9f, #cf, #e7, #f3, #f9
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#df, #e7, #25, #1f, #df, #8f, #cf, #00
	db	#00, #00, #00, #00, #00, #00, #00, #fe
	db	#f5, #f4, #f4, #ec, #cc, #9c, #1c, #1c
	db	#dc, #dc, #dc, #dc, #dc, #9c, #9c, #bd
	db	#f2, #f0, #f9, #f9, #f0, #f9, #f8, #f8
	db	#03, #21, #fd, #f6, #fe, #00, #42, #fc
	db	#02, #7b, #b4, #97, #40, #40, #40, #70
	db	#03, #dd, #03, #0b, #01, #3e, #be, #00
	db	#86, #67, #c0, #8f, #8f, #80, #0c, #00
	db	#00, #fd, #f9, #80, #7c, #72, #b8, #10
	db	#23, #a7, #e4, #9e, #97, #f9, #c6, #46
	db	#1e, #ef, #db, #87, #7d, #cf, #3f, #20
	db	#f1, #a6, #a6, #f6, #f6, #f6, #a6, #a6
	db	#a8, #91, #f8, #91, #81, #91, #91, #a1
	db	#88, #88, #88, #88, #88, #88, #88, #88
	db	#91, #91, #96, #81, #81, #81, #91, #88
	db	#88, #88, #88, #88, #88, #88, #88, #91
	db	#81, #81, #81, #81, #d1, #d1, #d1, #d1
	db	#d1, #d1, #d1, #81, #81, #d1, #d1, #81
	db	#81, #81, #d1, #d1, #81, #d1, #d1, #81
	db	#31, #41, #41, #c1, #c1, #44, #c1, #41
	db	#21, #41, #31, #54, #a2, #91, #91, #31
	db	#51, #31, #74, #f3, #d1, #a1, #81, #11
	db	#c1, #81, #41, #81, #b1, #21, #81, #11
	db	#11, #61, #21, #c1, #21, #21, #21, #61
	db	#61, #61, #c1, #21, #61, #61, #21, #61
	db	#a1, #62, #81, #c3, #c2, #c1, #21, #61
	db	#1f, #0f, #0f, #0f, #07, #07, #07, #0f
	db	#c0, #c0, #c0, #c0, #e0, #e0, #e0, #e0
	db	#00, #00, #00, #00, #00, #00, #00, #02
	db	#00, #00, #00, #00, #00, #00, #40, #80
	db	#00, #02, #e8, #c3, #c7, #cf, #df, #00
	db	#00, #fe, #fc, #fe, #fe, #f9, #0c, #f8
	db	#20, #90, #b0, #92, #6d, #22, #22, #bf
	db	#f8, #07, #f3, #fc, #f8, #f8, #f8, #fc
	db	#18, #2b, #c1, #ef, #c4, #06, #07, #03
	db	#8c, #0c, #92, #7f, #00, #1b, #04, #84
	db	#08, #8c, #04, #04, #06, #b0, #f8, #22
	db	#00, #00, #04, #fe, #06, #08, #1c, #0f
	db	#01, #00, #10, #10, #42, #05, #3d, #20
	db	#3b, #e6, #12, #08, #1c, #a7, #f3, #f1
	db	#c2, #50, #42, #02, #80, #42, #81, #01
	db	#a9, #f9, #f9, #f9, #f9, #f9, #f9, #f6
	db	#f9, #f9, #f9, #f9, #f9, #f9, #f9, #f9
	db	#99, #99, #99, #99, #99, #99, #99, #d9
	db	#99, #99, #99, #99, #99, #99, #98, #a9
	db	#99, #d9, #96, #91, #91, #91, #86, #99
	db	#99, #96, #96, #91, #91, #86, #98, #91
	db	#98, #98, #98, #98, #86, #98, #98, #86
	db	#65, #76, #d1, #87, #84, #84, #84, #85
	db	#c1, #74, #74, #74, #74, #74, #74, #54
	db	#74, #54, #54, #42, #44, #74, #54, #54
	db	#b4, #54, #54, #54, #54, #74, #c5, #74
	db	#44, #44, #54, #41, #51, #51, #61, #c4
	db	#c1, #11, #c1, #41, #c1, #c1, #c1, #b1
	db	#c1, #c1, #c1, #31, #c1, #c1, #c3, #c1
	db	#c1, #c1, #c1, #c1, #c1, #c1, #31, #c1
	db	#0f, #0f, #0f, #0f, #0f, #0f, #0f, #0f
	db	#c0, #c0, #e0, #e0, #c0, #c0, #e0, #f0
	db	#00, #00, #00, #00, #00, #00, #fe, #fe
	db	#00, #00, #00, #00, #00, #00, #00, #3f
	db	#fe, #fe, #f5, #e1, #83, #e7, #ef, #00
	db	#fe, #fe, #fe, #fd, #fd, #fc, #f8, #00
	db	#4e, #6e, #4e, #4c, #de, #dc, #dc, #dc
	db	#f0, #f0, #f8, #f0, #f0, #f0, #f0, #f0
	db	#df, #08, #0c, #04, #26, #02, #02, #03
	db	#12, #82, #00, #ca, #00, #04, #81, #00
	db	#08, #00, #00, #00, #24, #02, #fb, #02
	db	#00, #00, #02, #00, #f8, #f4, #f8, #10
	db	#80, #00, #00, #00, #1c, #02, #02, #07
	db	#10, #31, #21, #12, #01, #01, #03, #20
	db	#30, #a0, #99, #00, #01, #81, #5e, #80
	db	#f1, #a1, #a1, #a1, #a1, #a1, #a1, #a6
	db	#a8, #a8, #a8, #a8, #a8, #a8, #a8, #a8
	db	#88, #88, #88, #88, #88, #88, #81, #81
	db	#88, #88, #88, #88, #88, #88, #99, #81
	db	#81, #81, #61, #81, #81, #81, #91, #88
	db	#81, #81, #81, #81, #81, #91, #91, #88
	db	#d1, #d1, #81, #d1, #81, #d1, #81, #d1
	db	#61, #81, #81, #61, #61, #81, #d1, #d1
	db	#41, #d1, #31, #a1, #21, #b1, #81, #21
	db	#c1, #c1, #11, #41, #11, #c1, #21, #11
	db	#51, #11, #11, #11, #c1, #e1, #41, #f1
	db	#11, #11, #c1, #11, #41, #41, #41, #b1
	db	#41, #11, #11, #11, #41, #21, #21, #31
	db	#c1, #21, #21, #21, #21, #c1, #c1, #61
	db	#31, #31, #31, #11, #21, #31, #21, #31
	db	#1f, #0f, #1f, #0f, #1f, #0f, #0f, #0f
	db	#e0, #c0, #c0, #c0, #c0, #c0, #c0, #c0
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#fe, #fe, #fd, #fc, #fc, #fe, #fc, #01
	db	#8d, #e9, #c3, #06, #18, #f0, #60, #fe
	db	#a0, #1f, #0f, #b1, #0e, #91, #81, #20
	db	#03, #f8, #f8, #f0, #f8, #f8, #f8, #f8
	db	#da, #e3, #0a, #30, #76, #48, #1e, #df
	db	#1e, #03, #fc, #03, #2c, #c8, #34, #13
	db	#10, #02, #20, #cf, #20, #84, #42, #c2
	db	#04, #00, #04, #04, #00, #00, #00, #00
	db	#80, #00, #80, #82, #f8, #08, #06, #0c
	db	#39, #80, #80, #10, #02, #0c, #24, #19
	db	#68, #a4, #fe, #1f, #0b, #0a, #06, #af
	db	#f9, #f8, #f8, #f6, #a9, #f8, #f8, #f8
	db	#f9, #f9, #f9, #f9, #f9, #f9, #f9, #f9
	db	#99, #99, #99, #99, #99, #99, #99, #99
	db	#99, #99, #99, #99, #99, #99, #99, #99
	db	#97, #96, #86, #96, #91, #91, #96, #a9
	db	#f1, #f8, #f6, #f9, #f6, #f6, #e8, #96
	db	#ed, #d9, #d9, #98, #d9, #98, #98, #98
	db	#76, #d4, #84, #84, #84, #64, #64, #64
	db	#74, #74, #54, #c4, #74, #74, #74, #41
	db	#71, #74, #42, #74, #c1, #74, #74, #74
	db	#54, #54, #54, #42, #54, #54, #74, #74
	db	#54, #44, #54, #54, #44, #44, #44, #44
	db	#54, #44, #54, #71, #41, #c1, #c1, #c1
	db	#c7, #41, #61, #c1, #31, #c1, #c1, #c1
	db	#c1, #c1, #c1, #c1, #c1, #c1, #c1, #c2
	db	#0f, #1f, #0f, #1f, #0f, #0f, #0f, #0f
	db	#c0, #e0, #e0, #c0, #c0, #c0, #c0, #c0
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#fd, #fd, #fc, #fc, #fe, #fc, #fc, #fc
	db	#e3, #43, #42, #cc, #b8, #73, #0f, #9f
	db	#ef, #cf, #cf, #ce, #0e, #2e, #6e, #4e
	db	#70, #70, #71, #70, #70, #f0, #f0, #f0
	db	#80, #40, #60, #20, #20, #37, #10, #18
	db	#eb, #06, #0b, #0d, #00, #26, #4b, #20
	db	#48, #40, #00, #38, #10, #10, #10, #0a
	db	#00, #10, #00, #00, #00, #80, #00, #00
	db	#00, #00, #01, #7c, #03, #f0, #e0, #c0
	db	#00, #0d, #00, #00, #0c, #06, #1e, #16
	db	#00, #48, #0c, #0c, #06, #07, #01, #80
	db	#a1, #a1, #a1, #a6, #f1, #a1, #a1, #a1
	db	#a8, #a8, #a8, #a8, #a8, #a8, #a8, #a8
	db	#88, #88, #88, #88, #88, #88, #88, #88
	db	#88, #88, #88, #88, #88, #88, #88, #88
	db	#81, #81, #91, #81, #81, #81, #86, #86
	db	#e1, #f1, #f6, #e1, #81, #e1, #91, #81
	db	#81, #81, #81, #81, #81, #d1, #d1, #d1
	db	#81, #81, #d1, #d1, #d1, #81, #61, #81
	db	#31, #a1, #31, #f1, #21, #21, #91, #31
	db	#41, #71, #41, #c1, #44, #21, #21, #21
	db	#c1, #61, #11, #41, #c1, #d1, #b1, #71
	db	#11, #41, #11, #11, #11, #41, #11, #11
	db	#11, #11, #c1, #41, #31, #41, #41, #41
	db	#11, #21, #11, #11, #21, #21, #21, #21
	db	#11, #31, #c1, #c1, #21, #21, #31, #c1
	db	#1f, #1f, #1f, #0f, #0f, #0f, #0f, #0f
	db	#fe, #fe, #fc, #f8, #f0, #f0, #e0, #e0
	db	#3f, #7e, #ba, #d3, #54, #00, #00, #00
	db	#80, #00, #00, #7f, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #01, #fe, #03
	db	#f0, #c0, #80, #ae, #07, #87, #c7, #85
	db	#43, #80, #6c, #1e, #8c, #8f, #9f, #80
	db	#e0, #fa, #03, #f8, #fc, #f8, #f8, #f8
	db	#7f, #00, #00, #42, #08, #7f, #d9, #39
	db	#5c, #0f, #02, #06, #01, #09, #00, #04
	db	#08, #48, #40, #07, #02, #03, #80, #80
	db	#c3, #01, #0d, #04, #60, #4e, #30, #04
	db	#f2, #51, #ee, #30, #1f, #3f, #0c, #80
	db	#d4, #84, #a0, #60, #01, #03, #1f, #37
	db	#02, #1e, #03, #bf, #c0, #84, #a0, #e8
	db	#a9, #a9, #a9, #f6, #f6, #f6, #f6, #f6
	db	#f6, #fb, #f9, #f9, #f9, #f9, #f9, #f9
	db	#f9, #f6, #e6, #96, #98, #99, #99, #99
	db	#f9, #99, #99, #98, #99, #99, #99, #99
	db	#99, #99, #99, #99, #99, #a9, #93, #d9
	db	#91, #91, #91, #61, #f1, #f1, #f1, #f1
	db	#98, #c8, #96, #91, #91, #91, #81, #f6
	db	#81, #81, #f6, #64, #d7, #d7, #83, #84
	db	#41, #44, #44, #54, #74, #43, #54, #75
	db	#74, #42, #e4, #54, #b4, #e4, #44, #74
	db	#74, #74, #71, #74, #74, #74, #95, #f4
	db	#42, #71, #71, #c4, #54, #74, #74, #54
	db	#72, #74, #42, #74, #74, #71, #54, #e4
	db	#c1, #74, #c1, #74, #54, #f4, #c7, #c4
	db	#f4, #74, #c4, #c7, #e1, #c1, #c1, #c1
	db	#0f, #0f, #0f, #df, #1f, #1f, #1f, #1f
	db	#fe, #01, #fe, #f8, #f8, #f0, #f0, #e0
	db	#7f, #7f, #3c, #80, #ef, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #fe, #00, #fe
	db	#e3, #e1, #d8, #86, #86, #06, #84, #cf
	db	#23, #b9, #1f, #2f, #1f, #80, #80, #87
	db	#b9, #03, #18, #3b, #f9, #71, #70, #70
	db	#10, #03, #04, #04, #04, #85, #80, #80
	db	#a4, #f1, #80, #01, #01, #00, #00, #06
	db	#18, #49, #00, #82, #01, #00, #82, #00
	db	#3f, #00, #fe, #1c, #08, #fc, #d0, #90
	db	#3d, #b9, #91, #00, #20, #c3, #03, #03
	db	#00, #00, #00, #80, #c0, #f0, #d8, #30
	db	#26, #02, #3e, #60, #08, #02, #60, #40
	db	#f1, #f1, #f1, #a1, #a6, #a6, #a6, #a6
	db	#a1, #ba, #a8, #a8, #a8, #a8, #a8, #a8
	db	#f1, #f1, #e1, #81, #91, #88, #88, #88
	db	#88, #88, #88, #88, #88, #88, #88, #88
	db	#88, #88, #88, #88, #88, #86, #88, #83
	db	#81, #81, #61, #61, #e1, #e1, #f1, #e1
	db	#81, #91, #81, #81, #61, #71, #71, #81
	db	#61, #71, #d1, #61, #81, #81, #d1, #d1
	db	#41, #21, #21, #21, #21, #41, #b1, #21
	db	#31, #41, #c1, #c1, #71, #11, #11, #41
	db	#71, #41, #44, #71, #41, #11, #71, #11
	db	#41, #44, #41, #41, #71, #21, #71, #41
	db	#41, #71, #41, #11, #21, #41, #71, #41
	db	#44, #11, #44, #c1, #c1, #21, #41, #51
	db	#21, #f1, #31, #d1, #21, #31, #21, #c1
	db	#07, #0e, #0f, #0f, #0f, #0f, #0f, #0f
	db	#f8, #14, #86, #ee, #f4, #f8, #fc, #fc
	db	#1f, #1f, #1f, #0f, #0f, #07, #0f, #3f
	db	#81, #c1, #c0, #e1, #c0, #c0, #80, #80
	db	#e0, #f0, #ff, #00, #00, #00, #00, #00
	db	#61, #4c, #90, #cb, #00, #00, #fc, #f4
	db	#b7, #67, #0f, #00, #00, #00, #3f, #1f
	db	#d0, #f2, #c0, #f5, #c1, #d8, #f0, #f1
	db	#fc, #fd, #f9, #f8, #f0, #f8, #f0, #c0
	db	#e0, #e0, #e0, #0f, #f0, #18, #ba, #9d
	db	#00, #08, #10, #18, #3c, #37, #3f, #1c
	db	#00, #00, #08, #20, #20, #78, #e5, #84
	db	#00, #04, #00, #80, #20, #c0, #86, #e6
	db	#00, #30, #10, #00, #00, #60, #10, #f8
	db	#9f, #20, #10, #10, #10, #10, #6c, #04
	db	#f6, #f6, #f8, #f8, #f6, #f6, #f1, #f1
	db	#f1, #f1, #fd, #f1, #f6, #f8, #f8, #f6
	db	#f1, #f1, #f1, #f6, #f8, #f8, #f8, #f6
	db	#f1, #e1, #f1, #f1, #f8, #f9, #f9, #f9
	db	#91, #96, #96, #99, #99, #99, #99, #99
	db	#81, #86, #91, #96, #99, #99, #96, #96
	db	#86, #86, #96, #99, #99, #99, #96, #96
	db	#96, #96, #98, #96, #96, #91, #91, #91
	db	#81, #81, #81, #81, #81, #64, #87, #64
	db	#84, #84, #64, #42, #74, #54, #74, #74
	db	#44, #54, #74, #74, #74, #74, #74, #74
	db	#44, #44, #54, #74, #74, #74, #74, #74
	db	#44, #54, #44, #54, #54, #74, #54, #42
	db	#44, #74, #c4, #44, #44, #71, #54, #74
	db	#43, #e4, #f4, #b1, #d4, #c4, #c1, #e4
	db	#0f, #fb, #0f, #0f, #0f, #0f, #1f, #1f
	db	#98, #da, #84, #d4, #e2, #f0, #f8, #fc
	db	#1d, #0d, #0d, #09, #6b, #e7, #07, #0f
	db	#c3, #c0, #c1, #c2, #e0, #c0, #c0, #80
	db	#f6, #f8, #01, #00, #00, #00, #00, #00
	db	#b4, #00, #6c, #e4, #10, #00, #fe, #f8
	db	#07, #0f, #1f, #3f, #00, #00, #df, #0f
	db	#ee, #ec, #ec, #c8, #f8, #e3, #db, #c2
	db	#f9, #f8, #78, #73, #79, #e0, #06, #11
	db	#c1, #09, #20, #30, #10, #da, #0f, #26
	db	#00, #80, #00, #0c, #07, #7e, #7e, #fc
	db	#04, #08, #00, #b0, #f0, #61, #c6, #fa
	db	#00, #00, #00, #40, #c0, #e0, #e9, #1d
	db	#00, #81, #11, #00, #20, #bf, #c0, #e0
	db	#20, #30, #10, #df, #08, #08, #ef, #46
	db	#a8, #8a, #a6, #a6, #a6, #a6, #a9, #a9
	db	#31, #e1, #b1, #a1, #a1, #a1, #a1, #a1
	db	#f1, #e1, #f1, #f1, #d1, #61, #f1, #f6
	db	#61, #71, #31, #e1, #f6, #f8, #f8, #f8
	db	#86, #81, #d8, #88, #88, #88, #88, #88
	db	#61, #11, #61, #81, #98, #88, #86, #81
	db	#91, #91, #81, #81, #88, #88, #86, #81
	db	#81, #81, #61, #81, #81, #81, #81, #81
	db	#61, #61, #61, #61, #61, #81, #41, #c1
	db	#61, #71, #71, #d1, #81, #21, #31, #71
	db	#11, #41, #11, #41, #71, #71, #71, #21
	db	#41, #41, #11, #41, #c1, #71, #41, #c1
	db	#11, #11, #11, #c1, #c1, #71, #c1, #41
	db	#11, #21, #41, #11, #41, #41, #71, #c1
	db	#f1, #31, #71, #41, #31, #b1, #41, #31
	db	#01, #03, #03, #03, #03, #07, #07, #07
	db	#34, #f0, #e0, #e0, #e0, #c0, #fc, #1c
	db	#40, #13, #02, #01, #20, #38, #1c, #1f
	db	#02, #20, #97, #84, #01, #03, #01, #80
	db	#05, #08, #f6, #e9, #81, #43, #f0, #70
	db	#1c, #38, #70, #80, #80, #00, #fe, #fc
	db	#de, #c6, #34, #80, #28, #48, #59, #93
	db	#20, #60, #70, #70, #70, #f1, #f1, #f0
	db	#00, #7c, #bc, #fe, #fe, #fc, #fc, #fc
	db	#f9, #f8, #f8, #03, #f8, #03, #07, #f0
	db	#1f, #ce, #0f, #1b, #93, #9f, #33, #81
	db	#1f, #97, #df, #97, #cf, #c7, #00, #04
	db	#fc, #3f, #e4, #bc, #b0, #f0, #01, #00
	db	#8c, #66, #22, #92, #21, #40, #14, #0c
	db	#01, #01, #03, #06, #07, #33, #40, #70
	db	#f6, #f8, #f8, #f8, #f6, #f8, #f6, #f8
	db	#ca, #f1, #f1, #f6, #f1, #f1, #d1, #fc
	db	#c1, #96, #91, #d1, #61, #61, #f1, #f1
	db	#96, #a6, #86, #96, #81, #91, #91, #c1
	db	#98, #98, #81, #81, #86, #86, #96, #98
	db	#86, #d6, #d6, #d8, #86, #88, #81, #81
	db	#81, #86, #86, #86, #91, #91, #91, #91
	db	#f8, #98, #96, #96, #96, #96, #96, #96
	db	#88, #86, #86, #81, #81, #81, #81, #81
	db	#81, #81, #81, #76, #87, #76, #76, #84
	db	#74, #74, #74, #74, #74, #74, #74, #54
	db	#42, #72, #74, #74, #74, #74, #44, #74
	db	#71, #42, #74, #74, #74, #74, #74, #44
	db	#54, #c1, #54, #74, #c4, #54, #74, #71
	db	#74, #74, #74, #74, #74, #74, #f4, #74
	db	#03, #03, #03, #03, #07, #07, #07, #07
	db	#e0, #f0, #f0, #e0, #e0, #f8, #f8, #f8
	db	#66, #0c, #05, #00, #00, #00, #08, #1c
	db	#01, #47, #0f, #03, #32, #0c, #06, #03
	db	#fa, #f2, #ec, #d6, #03, #6d, #fb, #e7
	db	#3f, #7f, #7f, #e0, #00, #fe, #fc, #31
	db	#e1, #90, #80, #24, #c4, #bd, #83, #6b
	db	#7f, #7f, #6f, #6f, #ef, #ee, #ee, #ee
	db	#fe, #fe, #7e, #7c, #7c, #7e, #7e, #7e
	db	#72, #71, #71, #71, #f0, #f8, #f2, #e1
	db	#08, #06, #8f, #9d, #d0, #0b, #bb, #20
	db	#f0, #7e, #4f, #ef, #a3, #83, #83, #02
	db	#5b, #f8, #90, #d0, #fa, #ec, #a0, #04
	db	#71, #00, #40, #01, #e1, #b0, #8c, #f7
	db	#00, #00, #04, #00, #80, #80, #f2, #60
	db	#a8, #a6, #a6, #a6, #a8, #a6, #a6, #a6
	db	#f1, #a1, #a1, #a1, #a6, #a1, #91, #f1
	db	#91, #c1, #81, #11, #11, #11, #f1, #f1
	db	#81, #81, #61, #81, #61, #61, #61, #91
	db	#61, #61, #61, #61, #61, #61, #81, #61
	db	#81, #81, #81, #86, #88, #61, #61, #61
	db	#61, #61, #61, #61, #81, #61, #81, #61
	db	#61, #61, #81, #81, #81, #81, #81, #81
	db	#61, #61, #61, #61, #61, #61, #61, #61
	db	#61, #61, #61, #81, #61, #84, #81, #61
	db	#71, #71, #71, #71, #42, #74, #41, #41
	db	#41, #41, #74, #71, #71, #71, #21, #41
	db	#41, #71, #71, #71, #c1, #41, #c1, #41
	db	#21, #44, #21, #c1, #41, #41, #71, #41
	db	#11, #11, #21, #11, #d1, #f1, #c1, #31
	db	#ce, #e0, #dd, #20, #32, #1c, #fe, #01
	db	#48, #64, #20, #df, #3e, #38, #d5, #88
	db	#f3, #e7, #c7, #cf, #3f, #3f, #a0, #01
	db	#c0, #c0, #c1, #fe, #fe, #fc, #fb, #04
	db	#1f, #bf, #7f, #7f, #7c, #80, #b0, #f0
	db	#d3, #87, #0f, #ef, #0f, #8f, #0f, #1f
	db	#f0, #04, #ce, #15, #10, #00, #2a, #fa
	db	#3f, #9f, #9f, #cf, #ef, #20, #20, #20
	db	#00, #00, #01, #fd, #fd, #fd, #00, #00
	db	#c7, #f7, #f7, #f7, #01, #f3, #f3, #fb
	db	#c0, #80, #80, #80, #80, #80, #80, #09
	db	#00, #00, #00, #03, #00, #00, #01, #05
	db	#11, #a5, #02, #82, #06, #40, #14, #92
	db	#80, #c0, #40, #20, #18, #18, #86, #21
	db	#07, #55, #18, #1a, #23, #43, #01, #01
	db	#86, #86, #81, #86, #86, #96, #63, #f8
	db	#98, #d8, #96, #81, #81, #81, #ba, #fb
	db	#81, #81, #81, #81, #81, #81, #98, #91
	db	#d8, #d8, #86, #81, #81, #81, #81, #d8
	db	#d1, #81, #81, #81, #d8, #98, #d8, #86
	db	#86, #d6, #86, #81, #d6, #d1, #86, #d1
	db	#86, #98, #86, #98, #98, #88, #96, #81
	db	#86, #81, #81, #81, #81, #d8, #d6, #d8
	db	#88, #88, #98, #86, #86, #86, #88, #88
	db	#86, #81, #81, #81, #86, #81, #81, #81
	db	#84, #94, #94, #84, #94, #94, #64, #c1
	db	#44, #44, #44, #54, #44, #44, #74, #c4
	db	#74, #54, #54, #54, #74, #54, #54, #c1
	db	#f4, #f4, #c4, #e4, #c1, #c1, #54, #74
	db	#74, #74, #74, #74, #74, #74, #74, #74
	db	#e4, #cc, #8a, #11, #61, #e0, #fd, #f9
	db	#37, #67, #cf, #af, #9d, #42, #03, #de
	db	#e1, #c3, #e3, #07, #0f, #5f, #1f, #9e
	db	#f0, #e0, #fe, #fe, #fc, #fb, #f6, #e1
	db	#bf, #1f, #3f, #7f, #7f, #7f, #f0, #00
	db	#e7, #e7, #e7, #cf, #cf, #df, #9f, #bf
	db	#e0, #f9, #f1, #e0, #e0, #e0, #c0, #c5
	db	#87, #67, #67, #37, #17, #27, #2f, #2f
	db	#00, #00, #fe, #fe, #fe, #fe, #fe, #fe
	db	#e7, #e7, #e3, #e3, #f3, #fb, #f9, #f0
	db	#1f, #19, #18, #20, #00, #04, #0c, #7f
	db	#4e, #4e, #87, #00, #08, #00, #20, #75
	db	#07, #58, #60, #04, #08, #87, #c1, #00
	db	#be, #64, #60, #04, #df, #df, #08, #0a
	db	#38, #80, #00, #21, #10, #84, #00, #00
	db	#d1, #d1, #61, #61, #81, #81, #81, #61
	db	#81, #81, #81, #61, #61, #61, #f1, #a1
	db	#61, #81, #61, #81, #81, #61, #61, #61
	db	#86, #86, #81, #61, #61, #61, #61, #61
	db	#81, #81, #81, #81, #81, #81, #86, #88
	db	#81, #81, #81, #81, #81, #81, #81, #81
	db	#86, #61, #81, #81, #61, #61, #81, #61
	db	#61, #61, #61, #61, #61, #61, #81, #61
	db	#66, #66, #61, #61, #61, #61, #61, #61
	db	#61, #61, #61, #61, #81, #61, #61, #61
	db	#41, #41, #41, #41, #11, #41, #41, #41
	db	#41, #41, #41, #11, #41, #11, #41, #41
	db	#21, #41, #41, #c1, #41, #c1, #41, #44
	db	#41, #41, #41, #c1, #41, #41, #c1, #c1
	db	#21, #21, #11, #21, #c1, #c1, #11, #11
	db	#0c, #fc, #fa, #3d, #79, #08, #ee, #f0
	db	#04, #eb, #10, #4f, #60, #80, #1f, #15
	db	#f8, #f0, #f1, #fe, #fe, #fc, #fd, #f9
	db	#3f, #3f, #7f, #7e, #f8, #fc, #f8, #f0
	db	#cb, #c3, #07, #07, #4f, #0f, #df, #0f
	db	#fb, #f9, #f1, #d9, #c0, #c3, #e7, #c6
	db	#f0, #f0, #f0, #f0, #d0, #f8, #e0, #0c
	db	#00, #00, #00, #00, #00, #00, #bf, #28
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#fc, #fe, #fe, #df, #00, #fe, #ef, #ef
	db	#c4, #0c, #2f, #e0, #f0, #1f, #1f, #e0
	db	#60, #c0, #d0, #e0, #b8, #10, #84, #80
	db	#88, #1d, #1c, #08, #05, #06, #1b, #01
	db	#fe, #8b, #ec, #e2, #59, #fb, #88, #e0
	db	#10, #40, #30, #f8, #78, #00, #00, #ac
	db	#d8, #d9, #86, #d8, #d6, #98, #86, #d6
	db	#98, #86, #98, #d8, #98, #98, #d1, #d8
	db	#d8, #d8, #86, #81, #81, #81, #81, #81
	db	#d1, #d6, #d1, #d6, #d8, #d8, #d8, #d8
	db	#d8, #d6, #d8, #d6, #86, #d6, #81, #d6
	db	#d6, #d8, #d6, #d6, #d8, #d6, #86, #d6
	db	#d8, #d8, #d8, #d8, #d8, #86, #86, #98
	db	#88, #88, #88, #88, #88, #88, #86, #98
	db	#88, #88, #88, #88, #88, #88, #88, #88
	db	#81, #81, #81, #81, #88, #86, #81, #81
	db	#81, #74, #71, #87, #87, #c8, #76, #87
	db	#74, #74, #74, #74, #74, #c4, #c4, #c1
	db	#c4, #74, #74, #f4, #74, #f4, #74, #f4
	db	#74, #c7, #74, #74, #c7, #74, #c7, #74
	db	#54, #74, #74, #71, #71, #44, #44, #74
	db	#fc, #fc, #fd, #f9, #fb, #f3, #f3, #e6
	db	#f3, #f7, #e7, #ef, #8f, #1f, #00, #3f
	db	#fc, #f8, #fe, #fe, #fc, #f8, #f8, #f3
	db	#9f, #3f, #3f, #7f, #7f, #fe, #fc, #f8
	db	#f3, #f7, #e7, #e7, #e7, #cf, #8f, #9f
	db	#fb, #fb, #fb, #fb, #f3, #f3, #f3, #f3
	db	#f8, #f8, #f8, #f8, #f8, #00, #00, #f3
	db	#00, #00, #00, #00, #00, #00, #00, #97
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#fe, #fc, #de, #be, #ce, #cf, #df, #c7
	db	#0f, #0f, #07, #07, #0f, #0f, #0b, #0f
	db	#f0, #f1, #f0, #f0, #f8, #98, #8c, #00
	db	#2c, #3c, #1c, #2d, #3f, #7b, #69, #37
	db	#fc, #fe, #76, #ee, #a0, #60, #60, #be
	db	#00, #20, #c0, #5f, #c7, #7c, #f8, #53
	db	#81, #81, #81, #81, #81, #d1, #d1, #81
	db	#d1, #81, #d1, #81, #d1, #d1, #88, #81
	db	#86, #86, #81, #81, #81, #81, #81, #61
	db	#81, #81, #81, #81, #81, #86, #86, #86
	db	#86, #81, #81, #81, #81, #81, #81, #81
	db	#86, #81, #81, #81, #81, #81, #81, #81
	db	#86, #86, #86, #86, #86, #88, #88, #81
	db	#66, #66, #66, #66, #66, #66, #66, #61
	db	#66, #66, #66, #66, #66, #66, #66, #66
	db	#61, #61, #61, #61, #61, #61, #61, #61
	db	#71, #71, #71, #71, #71, #71, #71, #41
	db	#21, #71, #71, #71, #71, #71, #41, #44
	db	#71, #71, #71, #71, #21, #21, #41, #c1
	db	#71, #71, #71, #71, #74, #74, #74, #41
	db	#11, #c1, #21, #41, #41, #21, #21, #21
	db	#00, #7d, #f8, #fc, #4c, #52, #fe, #cc
	db	#ba, #bf, #3e, #82, #7c, #84, #82, #f1
	db	#57, #fd, #7e, #00, #bf, #1f, #fe, #f0
	db	#df, #f3, #3c, #00, #f7, #ef, #af, #1f
	db	#e0, #1c, #03, #f4, #00, #00, #00, #00
	db	#fc, #5c, #00, #00, #00, #00, #00, #00
	db	#80, #00, #e0, #80, #c0, #40, #e0, #e0
	db	#f0, #d0, #34, #08, #1e, #02, #02, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#40, #3f, #df, #ef, #e7, #f3, #f9, #fc
	db	#c0, #e0, #e0, #f0, #f0, #f0, #f0, #f0
	db	#80, #21, #30, #64, #26, #02, #61, #e0
	db	#09, #28, #00, #00, #00, #10, #19, #80
	db	#c0, #00, #40, #82, #48, #c0, #c0, #f6
	db	#03, #07, #13, #09, #00, #c4, #63, #0b
	db	#dd, #d8, #d8, #d8, #d8, #d8, #d9, #d8
	db	#d8, #d8, #d6, #98, #d6, #98, #98, #d8
	db	#d8, #d6, #d8, #dd, #d8, #d8, #d8, #d8
	db	#d8, #d6, #d8, #dd, #d6, #86, #86, #d6
	db	#fd, #d8, #d8, #d8, #dd, #dd, #dd, #dd
	db	#f9, #d8, #dd, #dd, #dd, #dd, #dd, #dd
	db	#d8, #dd, #d8, #d8, #d6, #d8, #d8, #d8
	db	#d8, #d8, #d8, #d8, #86, #d8, #86, #88
	db	#88, #88, #88, #88, #88, #88, #88, #88
	db	#96, #81, #81, #81, #81, #81, #81, #81
	db	#94, #94, #84, #64, #84, #84, #84, #84
	db	#e4, #54, #f4, #54, #54, #e4, #c1, #74
	db	#71, #54, #44, #44, #44, #54, #c4, #e4
	db	#71, #44, #54, #54, #74, #74, #74, #74
	db	#74, #74, #74, #74, #44, #54, #74, #74
	db	#00, #00, #fe, #00, #00, #fe, #fe, #fe
	db	#00, #00, #7f, #7c, #fd, #79, #79, #fb
	db	#01, #fe, #00, #00, #00, #00, #00, #fe
	db	#83, #00, #00, #00, #00, #e7, #df, #9f
	db	#f1, #00, #00, #fc, #00, #00, #00, #00
	db	#fc, #bf, #00, #00, #00, #00, #00, #00
	db	#00, #00, #f7, #e0, #00, #e0, #f0, #f0
	db	#f8, #fe, #fe, #3c, #00, #03, #00, #00
	db	#fe, #fe, #00, #00, #00, #00, #00, #00
	db	#3f, #df, #8f, #c7, #f3, #f9, #f0, #f9
	db	#9c, #80, #c0, #e0, #a0, #90, #80, #80
	db	#40, #60, #90, #0c, #04, #82, #fd, #60
	db	#fe, #01, #01, #01, #00, #00, #1f, #6c
	db	#bf, #00, #00, #60, #bc, #78, #00, #cc
	db	#00, #00, #30, #20, #03, #01, #60, #10
	db	#88, #88, #86, #88, #88, #86, #81, #81
	db	#88, #88, #86, #d1, #81, #d1, #d1, #81
	db	#d8, #86, #88, #88, #88, #88, #88, #86
	db	#d8, #88, #88, #88, #88, #86, #81, #81
	db	#d8, #dd, #dd, #86, #88, #88, #88, #88
	db	#d5, #d6, #88, #88, #88, #88, #88, #88
	db	#dd, #88, #86, #86, #88, #86, #86, #86
	db	#86, #86, #86, #86, #88, #86, #88, #66
	db	#61, #61, #66, #66, #66, #66, #66, #66
	db	#81, #61, #61, #61, #61, #61, #61, #61
	db	#21, #61, #61, #81, #61, #61, #61, #61
	db	#b1, #f1, #41, #31, #31, #41, #41, #71
	db	#41, #71, #41, #41, #11, #11, #41, #31
	db	#41, #11, #11, #41, #41, #41, #11, #71
	db	#11, #11, #41, #21, #21, #c1, #c1, #31
	db	#00, #00, #00, #7d, #3f, #bf, #7f, #7f
	db	#00, #00, #c9, #f9, #f9, #f9, #f6, #72
	db	#00, #00, #f6, #00, #00, #3c, #04, #02
	db	#00, #f2, #00, #6e, #7c, #7c, #1a, #0f
	db	#00, #f1, #93, #57, #7f, #61, #08, #02
	db	#3f, #07, #0f, #01, #01, #01, #03, #07
	db	#fe, #f8, #f8, #f0, #f0, #f0, #f0, #e0
	db	#00, #40, #80, #c0, #80, #c0, #c0, #c0
	db	#f0, #fc, #fe, #00, #00, #00, #00, #00
	db	#67, #07, #fd, #fe, #01, #fe, #fe, #00
	db	#90, #80, #20, #7f, #80, #7b, #c4, #c1
	db	#cf, #67, #e3, #f8, #10, #8a, #8b, #26
	db	#97, #03, #0f, #c0, #02, #3f, #3d, #4a
	db	#83, #c0, #e1, #f1, #41, #0f, #fe, #80
	db	#39, #91, #11, #66, #4e, #97, #05, #00
	db	#99, #dd, #dd, #d8, #d8, #d8, #d8, #d8
	db	#99, #dd, #d8, #d8, #d8, #d8, #d8, #d8
	db	#99, #dd, #d8, #dd, #dd, #d8, #fd, #fd
	db	#99, #d8, #88, #d8, #d8, #d8, #fd, #fd
	db	#99, #d8, #d8, #d8, #d8, #d8, #d8, #fd
	db	#d9, #f8, #d8, #fd, #fd, #fd, #fd, #fd
	db	#d6, #fd, #f8, #f8, #f8, #fd, #f8, #fd
	db	#88, #86, #86, #86, #d8, #d8, #d8, #d8
	db	#81, #81, #86, #88, #88, #88, #88, #88
	db	#c1, #e1, #61, #81, #98, #86, #86, #88
	db	#74, #74, #c7, #71, #64, #c6, #c7, #94
	db	#74, #74, #74, #74, #c7, #c7, #c7, #c7
	db	#74, #74, #74, #c7, #c7, #74, #74, #74
	db	#74, #74, #74, #74, #74, #74, #43, #74
	db	#74, #c4, #c7, #74, #74, #74, #74, #44
	db	#00, #00, #00, #00, #7f, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #00, #00
	db	#00, #00, #00, #00, #00, #00, #1e, #07
	db	#00, #00, #00, #00, #00, #00, #7f, #1f
	db	#00, #fb, #f7, #00, #00, #f1, #00, #ef
	db	#1f, #00, #f7, #03, #03, #03, #07, #00
	db	#00, #fe, #0f, #fb, #fb, #f8, #fb, #f0
	db	#00, #00, #00, #00, #e0, #e0, #e0, #f8
	db	#00, #fa, #00, #00, #00, #00, #00, #00
	db	#b7, #09, #c0, #fc, #fe, #00, #00, #00
	db	#40, #d9, #c0, #59, #79, #3f, #1f, #1b
	db	#a7, #fb, #fb, #00, #7f, #6f, #37, #a6
	db	#6b, #00, #bf, #3f, #fe, #f8, #fc, #3d
	db	#a1, #c1, #c3, #e9, #0f, #3f, #bd, #c0
	db	#82, #26, #2c, #e6, #6e, #ef, #82, #00
	db	#11, #88, #88, #88, #86, #88, #88, #88
	db	#11, #88, #88, #88, #88, #88, #88, #88
	db	#11, #88, #88, #88, #88, #dd, #d8, #d8
	db	#11, #88, #88, #88, #88, #dd, #d8, #d8
	db	#11, #86, #86, #88, #88, #86, #dd, #d8
	db	#d1, #dd, #d6, #d8, #d8, #d8, #d8, #dd
	db	#dd, #d8, #dc, #d8, #d8, #d8, #d8, #d8
	db	#11, #88, #88, #88, #86, #86, #86, #86
	db	#11, #61, #66, #66, #66, #66, #66, #66
	db	#41, #71, #61, #61, #61, #66, #66, #66
	db	#21, #71, #e4, #41, #21, #71, #71, #71
	db	#c1, #72, #72, #77, #74, #74, #74, #41
	db	#21, #77, #71, #74, #71, #71, #71, #71
	db	#c1, #71, #41, #41, #71, #71, #41, #71
	db	#21, #74, #74, #72, #72, #71, #21, #11

prog_end:
END
